from django.contrib import admin
from .models import *
# Register your models here.
class c123_nodeAdmin(admin.ModelAdmin):
    list_display = ['severity', 'pk', 'name', 'created_date', 'status', 'type', 'ind_deleted']
    list_filter = ['severity', 'name', 'created_date', 'status', 'type', "cluster_role",  'ind_deleted']
class TaskAdmin(admin.ModelAdmin):
    list_display = ['task', 'task_id', 'status', 'created_date', 'monitor_name', 'created_by']
    list_filter = ['task', 'status', 'created_by', 'monitor_name', 'target_id']
class TaskLogAdmin(admin.ModelAdmin):
    list_display = ['task', 'task_id', 'created_date', 'created_by']
    list_filter = ['task', 'task_id', 'target_id']
    search_fields = ['task_id']
class TaskStepLogAdmin(admin.ModelAdmin):
    list_display = ['task', 'task_id', 'created_date', 'step']
    list_filter = ['task', 'step', 'status', 'task_id', 'target_id']
    search_fields = ['task_id']
class c123_inventoryAdmin(admin.ModelAdmin):
    list_filter = ['node', 'database', 'type']
    list_display = ['node', 'database', 'type', 'created_date', 'status']
     
    def node(self, obj):
        return obj.node.name
    node.admin_order_field = "node__name"
class c123_clusterAdmin(admin.ModelAdmin):
    list_display = ['name', 'type']
    list_filter = ['name', 'type']
    
class c123_hostMonitorAdmin(admin.ModelAdmin):
    list_display = ["host","metric_name", "metric_value"]
    list_filter = ["metric_name", "host"]
    def host(self, obj):
        return obj.host.name
    host.admin_order_field = "host__name"
class clusterSizingAdmin(admin.ModelAdmin):
    list_display = ['db_type']
    list_filter = ['db_type']
class userNotificationsAdmin(admin.ModelAdmin):
    list_display = ['user', 'email']
    list_filter = ['user', 'email']
class userPrivilegesAdmin(admin.ModelAdmin):
    list_display = ['user']
    list_filter = ['user']
class c123_Oracle_StandaloneAdmin(admin.ModelAdmin):
    list_display = ['name', 'created_by', 'created_date', 'severity']
    list_filter = ['name', 'created_by', 'created_date', 'severity']
class c123_hostAdmin(admin.ModelAdmin):
    list_display = ['name', 'pk', 'ind_deleted']
    list_filter = ['name', 'ind_deleted']
class c123_databaseAdmin(admin.ModelAdmin):
    list_display = ['severity', 'pk', 'name', 'created_date', 'status', 'type', 'ind_deleted']
    list_filter = ['severity', 'name', 'created_date', 'status', 'type', 'ind_deleted']
class IntegratedServiceAdmin(admin.ModelAdmin):
    list_filter = ['type', 'name', 'host_name', 'ind_verified']
admin.site.register(c123_node, c123_nodeAdmin)
admin.site.register(c123_cluster, c123_clusterAdmin)
admin.site.register(c123_host, c123_hostAdmin)
admin.site.register(c123_host_monitor, c123_hostMonitorAdmin)
admin.site.register(c123_node_monitor)
admin.site.register(TaskLog, TaskLogAdmin)
admin.site.register(TaskStepLog, TaskStepLogAdmin)
admin.site.register(UserPrivileges, userPrivilegesAdmin)
admin.site.register(UserNotifications, userNotificationsAdmin)
admin.site.register(Task, TaskAdmin)
admin.site.register(ClusterSizing, clusterSizingAdmin)
admin.site.register(OracleClusterSizing)
admin.site.register(Organization)
admin.site.register(Profile)
admin.site.register(SystemConfig)
admin.site.register(CustomerKey)
admin.site.register(OracleSystemConfig)
admin.site.register(c123_inventory, c123_inventoryAdmin)
admin.site.register(c123_Oracle_Standalone, c123_Oracle_StandaloneAdmin),
admin.site.register(c123_database, c123_databaseAdmin)
admin.site.register(IntegratedService, IntegratedServiceAdmin)
