from django.apps import AppConfig
from django.db.backends.signals import connection_created

class ClustercoreConfig(AppConfig):
    default_auto_field = 'django.db.models.BigAutoField'
    name = 'clusterCore'

    def ready(self):
        # scheduler should be linked after django initialization and be defined for every thread
        connection_created.connect(self.initialize_scheduler)
        import clusterCore.signals

    def initialize_scheduler(self, **kwargs):
        from django.conf import settings
        if not hasattr(settings, 'scheduler'):
            from clusterCore.scheduler import SchedulerWrapper
            settings.scheduler = SchedulerWrapper()
