from django.db.models.signals import pre_save
from django.dispatch import receiver
from django.contrib.auth.models import User
from .models import c123_dashboard_item

@receiver(pre_save, sender=c123_dashboard_item)
def set_order_id(sender, instance, **kwargs):
    user = User.objects.filter(pk = instance.created_by.id).first()
    last_order = sender.objects.filter(created_by=user).order_by('-order_id').first()

    if last_order != None:
        instance.order_id = (last_order.order_id + 1)
    else:
        instance.order_id = 1
