import multiprocessing, os

# Get the port from environment variable, default to 8000 if not set
port = os.getenv('PORT', 8000)
bind =  f'127.0.0.1:{port}'
workers = multiprocessing.cpu_count() * 2 + 1  # Dynamic worker calculation
threads = 2 # Helps with concurrent requests
timeout = 120  # Prevents workers from hanging indefinitely
keepalive = 5  # Allows keep-alive connections
preload_app = False  # Loads app before forking workers
worker_class = "gevent"  # Async worker for better performance
certfile = "123cluster.crt"
keyfile = "123cluster.key"