import { InputTextarea } from "primereact/inputtextarea";
import { useEffect, useRef } from "react";
import { useSelector } from "react-redux";

export default function ErrorTextBox(props)

{
    const textBoxRef = useRef(null);
    const { isLoading} = useSelector((state) => state.layout);
    useEffect(() => {
           if (props.error && !isLoading){
    
            textBoxRef.current.scrollIntoView();
           }
      }, [props.error, isLoading]);

    return (
        <div className="field grid flex align-items-center">
            <div className="col-fixed flex">
            <i className="pi pi-exclamation-triangle mr-1" style={{marginTop: "0.20rem"}}/>
                Error:
            </div>

            <div className="col">
            <InputTextarea ref={textBoxRef} value={props.error} rows = {3} cols = {20}/>
            </div>

        </div>);
    
}