
import { useState } from "react"
import { InputText } from "primereact/inputtext";
import { InputTextarea } from "primereact/inputtextarea";
import { Button } from "primereact/button";
import validator from "../../../util/validator";
import constraints from "./constraints";

export default function ContactsForm(props) {
    const [email, setEmail] = useState("");
    const [message, setMessage] = useState("");
    const [emailError, setEmailError] = useState("");
    const [messageError, setMessageError] = useState("");
    const [firstName, setFirstName] = useState("");
    const [lastName, setLastName] = useState("");
    const [subject, setSubject] = useState("");

    const handleSubmit = () =>
    {

        const errors = validate();
        if(errors.length === 0)
        {


        }

    }

    const validate = () => 
    {
        const errors = []
        let error = validator(constraints)("email", email);
        (error == null || errors.push(error)) && setEmailError(error);
    
        error = validator(constraints)("message", message);
        (error == null || errors.push(error)) && setMessageError(error);
        return errors;

    }


    return (<div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container card">
        <div className="field grid">

            <div className="col">
                <div className="font-semibold">
                    First Name
                </div>
                <InputText value={firstName} onChange={(e) => setFirstName(e.target.value)} placeholder="First Name" />


            </div>

            <div className="col">

                <div className="font-semibold">
                    Last Name
                </div>

                <InputText value={lastName} onChange={(e) => setLastName(e.target.value)} placeholder="Last Name" />

            </div>

        </div>

        <div className="field grid">

        <div className="font-semibold">
                    Email {<span className="p-error">*</span>}
                </div>

                 <InputText type="email" value={email} onChange={(e) => setEmail(e.target.value)} placeholder="Email" />
                <div className="text-sm p-error">{emailError}</div>

        </div>

        <div className="field grid">

        <div className="font-semibold">
                    Subject
                </div>

                <InputText value={subject} onChange={(e) => setSubject(e.target.value)} placeholder="Subject" />

        </div>

        <div className="field grid">

        <div className="font-semibold">
                    Your Message {<span className="p-error">*</span>}
                </div>

                <InputTextarea value={message} onChange={(e) => setMessage(e.target.value)} placeholder="Your Message" />
                <div className="text-sm p-error">{messageError}</div>

        </div>

        <div className="field flex"><Button className="p-button-success w-max ml-auto mr-auto" label="Submit Form" onClick={handleSubmit}/></div>


        


    </div>)

}

