import { useDispatch, useSelector } from 'react-redux';
import { SignupActions } from '../../../store/signup/reducer';
import { UserUpdateActions } from '../../../store/userUpdate/reducer';
import {Dropdown} from "primereact/dropdown";
import { InputText } from 'primereact/inputtext';





const NotificationsForm = (props) => {

const noticeOptions = 
[
    { label: "For all databases", value: "ALL" },
    { label: "For databases of this user only", value: "ONU" },
];

  const {data}  = useSelector((state) => props.update ? state.userUpdate : state.signUp);

  const dispatch = useDispatch();


    const onInput = (name, value) => {

    
      (props.update ?  dispatch(UserUpdateActions.setData({...data, notice_dict:
        {
  
          ...data.notice_dict,
          [name]: value
  
        }
      })) : dispatch(SignupActions.setData({...data, notice_dict:
        {
  
          ...data.notice_dict,
          [name]: value
  
        }
      }))
      ); 
  
    };


  return (
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
    <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">
    <div className="field grid">
                    <div className="col-6">Email:</div>
                      <div className="col-6">
                      <InputText type = "email" className="p-inputtext-sm" placeholder="Email" value={data.notice_dict.email} onChange={(e) => onInput("email", e.target.value)} />
                      <div className="error-help"><small className="p-error p-d-block">{props.emailError}</small> </div>
                    </div>
     </div>               
    <div className="field grid">
                    <div className="col-6">Send an email on new &amp; resolved alerts:</div>
                      <div className="col-6">
                      <Dropdown className="p-inputtext-sm" value={data.notice_dict.completed_actions_alerts} 
                      options={noticeOptions} 
                      onChange={(e)  => onInput("completed_actions_alerts", e.value)} 
                      />
                     
                    </div>

                    </div>

                    <div className="field grid">
                    <div className="col-6"> Send an email on completed actions:</div>
                      <div className="col-6">

                      <Dropdown className="p-inputtext-sm" value={data.notice_dict.nodes_resolved_alerts} 
                      options={noticeOptions} 
                      onChange={(e)  => onInput("nodes_resolved_alerts", e.value)} 
                      />
                    
                    </div>
                    </div>
                    
    </div>
    </div>
    )

  };

  
  export default NotificationsForm;
