import { useDispatch, useSelector } from 'react-redux';
import { SignupActions } from '../../../store/signup/reducer';
import { InputText } from 'primereact/inputtext';
import { Password } from 'primereact/password';
import { UserUpdateActions } from '../../../store/userUpdate/reducer';
import { footer } from '../../../util/passwordHelpers';





const UserPasswordForm = (props) => {

  const {data}  = useSelector((state) =>  props.update ? state.userUpdate : state.signUp);
  const dispatch = useDispatch();

    const onInput = (name, value) =>
    {

     props.update ? 
     dispatch(UserUpdateActions.setData({...data, user_dict:
      {

        ...data.user_dict,
        [name]: value

      }
    }))
    :   
    dispatch(SignupActions.setData({...data, user_dict:
      {

        ...data.user_dict,
        [name]: value

      }
    }))

    }

    
    
   return(
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
    <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">
   {props.update === false &&
   ( <div className="field grid">
                    <div className="col-6">Username:</div>
                      <div className="col-6">
                      <InputText className="p-inputtext-sm" 
                      placeholder="Name" value={data.user_dict?.username} 
                      onChange={(e) => onInput("username", e.target.value)} 
                      autoComplete="new-password"
                      />
                      <div className="error-help"><small className="p-error p-d-block">{props.errors?.username}</small> </div>
                    </div>
                    </div>)
}
                    <div className="field grid">
                    <div className="col-6">Password:</div>
                      <div className="col-6">
                      <Password 
                      value={data.user_dict?.password} 
                      onChange={(e) => onInput("password", e.target.value)}
                      autoComplete="new-password"
                      footer = {() => footer(data.user_dict?.password)}
                       toggleMask />
                      <div className= "error-help"><small id="name-help" className="p-error p-d-block">{props.errors?.password}</small> </div>
                    </div>
                    </div>

                    <div className="field grid">
                    <div className="col-6">Password confirmation:</div>
                      <div className="col-6">
                      <Password
                      value={data.user_dict?.password2} 
                      feedback = {false} 
                      autoComplete="new-password"
                      onChange={(e) => onInput("password2", e.target.value)}
                       toggleMask />
                      <div className='error-help'><small id="name-help" className="p-error p-d-block">{props.errors?.password2}</small> </div>
                    </div>
                    </div>
    </div>
    </div>
   )
};

export default UserPasswordForm;