import { OverlayPanel } from "primereact/overlaypanel";
import { Button } from "primereact/button";
import { useRef, useState } from "react";
import { ConfirmPopup } from "primereact/confirmpopup";
import { useDispatch } from "react-redux";
import { LayoutActions } from "../../store/layout/reducer";
export default function PgSizeCell({ db }) {

    const subscriptionsPanel = useRef(null);
    const dropSub = useRef(null);
    const toggleSub = useRef(null);
    const [showDeleteConfirm, setShowDeleteConfirm] = useState(false);
    const [showToggleConfirm, setShowToggleConfirm] = useState(false);
    const dispatch = useDispatch();

    return (<div className="flex align-items-center cell-text" draggable={false}  style={{ height: "20px" }}>{db?.display_size} {db?.ex_params?.[`sub_${db.name}`] ? <i className="pi pi-arrow-right-arrow-left verify-backup mr-4" onMouseEnter={(e) => {
        subscriptionsPanel.current?.show(e);

    }} /> : null } <OverlayPanel ref={subscriptionsPanel} onMouseLeave={() => subscriptionsPanel.current?.hide()} closeOnEscape>
            <div>status: replication {db?.ind_started ? '' : 'not'} running </div>
            <Button rounded className="live-rep-btn" ref={toggleSub} size="small" label={db?.ind_started ? 'pause' : 'unpause'} icon={db?.ind_started ? "pi pi-pause" : "pi pi-play"} onClick={() => {
              setShowToggleConfirm(true);
            }} />
            <Button rounded className="live-rep-btn" ref={dropSub} size="small" onClick={() => setShowDeleteConfirm(true)} label="Stop" icon="pi pi-trash" severity="danger" />
            <ConfirmPopup target={dropSub.current} className="multiline" acceptIcon="pi pi-trash" rejectIcon="pi pi-times" acceptLabel="Yes" rejectLabel="No" visible={showDeleteConfirm} onHide={() => setShowDeleteConfirm(false)} message={`Database will no longer be in ongoing live replication.\nAre you sure?`}
                icon="pi pi-exclamation-triangle" accept={() => {
                    setShowDeleteConfirm(false);
                    subscriptionsPanel.current?.hide();
                    dispatch(LayoutActions.dropPgPublication({ 'db_id': db?.id }))
                }} reject={() => setShowDeleteConfirm(false)} />
             <ConfirmPopup target={toggleSub.current} className="multiline" acceptIcon="pi pi-check" rejectIcon="pi pi-times" acceptLabel="Yes" rejectLabel="No" visible={showToggleConfirm} onHide={() => setShowToggleConfirm(false)} message={`Are you sure you want to ${db.ind_started ? 'pause' : 'unpause'} ongoing live replication?`}
                icon="pi pi-info-cirle" accept={() => {
                    setShowToggleConfirm(false);
                    subscriptionsPanel.current?.hide();
                    dispatch(LayoutActions.togglePgSubscription({ 'db_id': db?.id }))
                }} reject={() => setShowToggleConfirm(false)} />
        </OverlayPanel></div>)
}
