import { useRef } from "react";
import { useIsOverflow } from "../../util/useIsOverflow";
import { Tooltip } from "primereact/tooltip";
export default function TooltipCell(props)
{
    const element = useRef(null);
    const hasOverflow = useIsOverflow(element);

    return (<div onClick={props.onClick} ref={element} className={`${props.id} overflow-cell`}>
        {props.content}
        {hasOverflow && props.id && <Tooltip autoHide = {false} className="cell-tooltip tooltip-base" content = {props.content} target = {`.${props.id}`}/>}
    </div>)

}