const config = {
  //apiUrl: "http://192.168.1.42:8000"
  apiUrl: "".concat(String(window?.location?.protocol), '//', String(window?.location?.hostname), process.env.NODE_ENV === "development" ?  ":8000" : ""),
  encodePasswords: false,
  layoutMinHeight: 480,
  GB: 1048576.0,
  pathRegex: /^(\/[^\s]+)+$/,
  windowsPathRegex: /^[A-Z]:\\(?:[^\\/:*?"<>|\r\n]+\\)*[^\\/:*?"<>|\r\n]*$/i,
  passwordRegex: /^(?=.*[a-zA-Z])(?=.*\d)[a-zA-Z\d!@#$%^&*()_+\-=[\]{};':"\\|,.<>/?]*.{8,}$/,
  mysqlPasswordRegex: /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[@$!%*?&])[A-Za-z\d@$!%*?&]{8,}$/,
  mssqlPasswordRegex: /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[@$!%*?&])[A-Za-z\d@$!%*?&]{8,}$/,
  mssqlUsernameRegex: /^[a-zA-Z][a-zA-Z0-9_]{1,29}$/,
  oracleNameRegex: /^[a-zA-Z][a-zA-Z0-9_]{0,127}$/,
  oracleSIDRegex: /^[a-zA-Z][a-zA-Z0-9]{0,11}$/,
  postgresNameRegex: /^[a-zA-Z_][a-zA-Z0-9_]{0,62}$/,
  mongoNameRegex: /^[a-zA-Z0-9_-]{1,64}$/,
  mysqlNameRegex: /^[a-zA-Z0-9_$]{1,64}$/,
  mssqlNameRegex: /^[a-zA-Z][a-zA-Z0-9_]{0,127}$/,
  usernameRegex: /^[a-zA-Z0-9_@-]{4,20}$/,
  hostNameRegex: /^(?:\d{1,3}\.){3}\d{1,3}$|^(?=.{1,253}$)(?:(?!-)[a-zA-Z0-9-]{1,63}(?<!-)\.)+(?:[a-zA-Z]{2,})$/,
  emailRegex: "[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?",
  restoreConfirm: "restore me",
  dropConfirm: "drop me",
  unregisterConfirm: "unregister me",
  upgradeConfirm: "upgrade me",
  elastisearchNameRegex: /^[a-zA-Z][a-zA-Z0-9_-]{0,254}$/,
  formDefaults: {

    'user_dict': {

      'password': '',
      'password2': ''

    },
    "priv_dict": {

      'is_superuser': "False",
      'oracle_pdb_quota': 10,
      'oracle_pdb_view': "ONU",
      'oracle_pdb_create': "MED",
      'oracle_pdb_delete': "ONU",
      'mongo_quota': 10,
      'mongo_view': "ONU",
      'mongo_create': "MED",
      'mongo_delete': "ONU",
      'mysql_quota': 10,
      'mysql_view': "ONU",
      'mysql_create': "MED",
      'mysql_delete': "ONU",
      'mariadb_quota': 10,
      'mariadb_view': "ONU",
      'mariadb_create': "MED",
      'mariadb_delete': "ONU",
      'elasticsearch_quota': 10,
      'elasticsearch_view': "ONU",
      'elasticsearch_create': "MED",
      'elasticsearch_delete': "ONU",
      'mssql_quota': 10,
      'mssql_view': "ONU",
      'mssql_create': "MED",
      'mssql_delete': "ONU",
      'postgres_quota': 10,
      'postgres_view': "ONU",
      'postgres_create': "MED",
      'postgres_delete': "ONU",
      'redis_quota': 10,
      'redis_view': "ONU",
      'redis_create': "MED",
      'redis_delete': "ONU",



    },
    "notice_dict": {
      'email': '',
      'nodes_resolved_alerts': 'ONU',
      'completed_actions_alerts': 'ONU'
    }

  },

  tooltips:
    [
      "open status",
      "open layout",
      "open log",
      "notifications",
      "open config",
      "log out",
      "reload page",
      "add cluster",
      "can be changed in config page",
      'open monitoring & alerts',
      'open dashboard'
    ]
}

export const loadingMsg = "Loading...";
export const emptyMsg = "No available data";

export const regionOptions = [
  'eu-central-1',
  'ap-south-1',
  'eu-north-1', 
  'eu-west-3', 
  'eu-west-2',
  'eu-west-1',
  'ap-northeast-3',
  'ap-northeast-2',
  'ap-northeast-1',
  'il-central-1',
  'ca-central-1',
  'sa-east-1',
  'ap-southeast-1',
  'ap-southeast-2',
  'us-east-1',
  'us-east-2',
  'us-west-1',
  'us-west-2',
]



export const timePeriods =
{

  TEN_MIN: '10 minutes',
  HOUR: '1 hour',
  SIX_HOURS: '6 hours',
  DAY: '1 day',
  WEEK: '1 week'

}

export const clusterDropModes = {
  CLUSTER: "cluster",
  PRIMARY: "primary"
}

export const layoutSortOptions = {
  NEWEST: "newest",
  SEVERITY:  "severity",
  CHILD_COUNT: "number of nodes"

}

export const osTypes = [
  {label: "Centos 8", value: "centos 8"},
  {label: "Ubuntu 22", value: "ubuntu 22"}

]

export const awsOsTypes = [
  {label: "Ubuntu 22", value: "ubuntu 22"},
  {label: "Ubuntu 24", value: "ubuntu 24"},
  {label: "Centos 9", value: "centos 9"},
  {label: "Centos 10", value: "centos 10"},
  {label: "RHEL 9", value: "rhel 9"},
  
  


]

export const restoreOptions = {
  THIS: { value: 'this', label: 'Restore to the time when this backup was created.' },
  LATEST: { value: 'latest', label: 'Restore to the latest possible time available.' },
  CUSTOM: { value: 'custom', label: 'Restore to a custom specified time' }
}

export const clusterSizeOptions =
  [
    { label: "Small", value: "SMALL" },
    { label: "Medium", value: "MEDIUM" },
    { label: "Large", value: "LARGE" },
    { label: "Very Large", value: "VERY_LARGE" },

  ]

export const repositoryOptions =
  [
    { label: "Network repository", value: "network" },
    { label: "Local repository", value: "local" }
  ];

export const oracleIncrementalLevel =
  [
    { label: "No incremental", value: "" },
    { label: "Differential", value: "INCREMENTAL LEVEL 1" },
    { label: "Cumulative", value: "INCREMENTAL LEVEL 1 CUMULATIVE" }
  ];

export const timePeriodTypes = [
  { label: 'Last 10 Minutes', value: timePeriods.TEN_MIN },
  { label: 'Last 1 Hour', value: timePeriods.HOUR },
  { label: 'Last 6 Hours', value: timePeriods.SIX_HOURS },
  { label: 'Last 1 Day', value: timePeriods.DAY },
  { label: 'Last 1 Week', value: timePeriods.WEEK }
];
export const agentTypes = [
  { label: 'High availability', value: 'High Availability' },
  { label: 'Load balancer', value: 'Load Balancer' },
];
export const types =
{

  MARIADB: 'MARIADB',
  MYSQL: 'MYSQL',
  MSSQL: 'MSSQL',
  POSTGRES: 'POSTGRES',
  POSTGRES_K8S: 'POSTGRES_K8S',
  MONGO_K8S: 'MONGO_K8S',
  MONGO: "MONGO",
  ELASTIC: "ELASTIC",
  REDIS: "REDIS",
  HAPROXY: "HAPROXY",
  ORACLE_PDB: "ORACLE_PDB",
  ORACLE_CDB: "ORACLE_CDB",
  LINUX: "LINUX",
  WINDOWS: "WINDOWS",
  AWS: "AWS",
  PROXMOX: "PROXMOX",
  K8S: "K8S",
  ALL: "ALL"

}

export const clusterRoles =
{

  CDB: "CDB",
  PDB: "PDB",
  PRIMARY: "PRIMARY",
  STANDBY: "STANDBY",
  ARBITER: "ARBITER",
  BALANCER: "BALANCER",
  SENTINEL: "SENTINEL",
}

export const aggregationFunctionTypes = {

  AVG: 'average',
  MAX: 'maximum',
  MIN: 'minimum'

}

export const daysOfWeekOptions = [
  { label: "Mon", value: "mon" },
  { label: "Tue", value: "tue" },
  { label: "Wed", value: "wed" },
  { label: "Thu", value: "thu" },
  { label: "Fri", value: "fri" },
  { label: "Sat", value: "sat" },
  { label: "Sun", value: "sun" },
];

export const mysqlVersionOptions =
  [
    { label: "8.4", value: "8.4" },
    { label: "8.0", value: "8.0" },
    { label: "5.7", value: "5.7" }

  ];

export const tableGroupingTypes = {
  CLUSTER: "cluster",
  DATABASE: "database",
  NO_GROUPING: "ungrouped"
}
export const tableGroupingOptions =
[
  { label: "Cluster", value: tableGroupingTypes.CLUSTER },
  { label: "Database", value: tableGroupingTypes.DATABASE },
  { label: "No grouping", value: tableGroupingTypes.NO_GROUPING }

];

export const elasticsearchVersionOptions =
  [
    { label: "8", value: "8" },
    { label: "7", value: "7" },
  ];


export const mariadbVersionOptions =
  [
    { label: "11.4", value: "11.4" },
    { label: "11.2", value: "11.2" },
    { label: "11.1", value: "11.1" },
    { label: "11.0", value: "11.0" },
    { label: "10.11", value: "10.11" },
    { label: "10.6", value: "10.6" },
    { label: "10.5", value: "10.5" },
    { label: "10.4", value: "10.4" },

  ];

export const mongoVersionOptions =
  [
    { label: "8.0", value: "8.0" },
    { label: "7.0", value: "7.0" },
    { label: "6.0", value: "6.0" },
    { label: "5.0", value: "5.0" },
    { label: "4.4", value: "4.4" },
    { label: "4.2", value: "4.2" },
    // { label: "4.0", value: "4.0" },
    // { label: "3.6", value: "3.6" },
  ];

export const pgVersionOptions =
  [
    { label: "17", value: 17 },
    { label: "16", value: 16 },
    { label: "15", value: 15 },
    { label: "14", value: 14 },
    { label: "13", value: 13 },
    { label: "12", value: 12 },
    { label: "11", value: 11 },
    { label: "10", value: 10 },
  ];


export const cpuAggregationOptions = [
  { label: 'Average', value: aggregationFunctionTypes.AVG },
  { label: 'Maximum', value: aggregationFunctionTypes.MAX },
  { label: 'Minimum', value: aggregationFunctionTypes.MIN },
];

export const dbTypes = [
  { label: 'All databases', value: types.ALL },
  { label: 'Elasticsearch', value: types.ELASTIC },
  { label: 'HAProxy', value: types.HAPROXY },
  { label: 'MariaDB', value: types.MARIADB },
  { label: 'SQL Server', value: types.MSSQL },
  { label: 'MySQL', value: types.MYSQL },
  { label: 'MongoDB', value: types.MONGO },
  { label: 'Oracle PDB', value: types.ORACLE_PDB },
  { label: 'Oracle CDB', value: types.ORACLE_CDB },
  { label: 'PostgreSQL', value: types.POSTGRES },
  { label: 'Redis', value: types.REDIS },

];

export const serviceTypes = [
  { label: 'All Services', value: types.ALL},
  { label: 'AWS account', value: types.AWS},
  { label: 'Proxmox server', value: types.PROXMOX },
  { label: 'K8s node', value: types.K8S},
];

export default config;