import { Dialog } from "primereact/dialog";
import { Button } from "primereact/button";
import { Dropdown } from "primereact/dropdown";
import { useState } from "react";
import { tableGroupingOptions} from "../../config";
import { Checkbox } from "primereact/checkbox";
import { useSelector } from "react-redux";

export default function ChangeTableLayoutDialog ({visible, onHide, onOkClick}) {

    const {grouping, timeline} = useSelector((state) => state.app);
    const [tableGrouping, setTableGrouping] = useState(grouping);
    const [showTimeline, setShowTimeline] = useState(timeline);
    const renderFooter = () => {
        return (
            <div style={{ display: "flex", justifyContent: "space-between" }}>
                <Button label={"Close"} icon="pi pi-times" onClick={onHide} className="p-button-text" />
                <Button
                    label={"Select"}
                    icon="pi pi-check"
                    iconPos="right"
                    onClick={() => {onOkClick(tableGrouping, showTimeline)}} autoFocus />
            </div>
        );

    }



    return (

        <Dialog
            className='table-settings'
            header={"Table settings"}
            visible={visible}
            style={{ width: '30vw', maxHeight: "90%" }}
            onHide={onHide}
            footer={renderFooter()}>
            <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
                <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

                    <div className="field grid">
                        <div className="col-fixed" style={{width: '220px'}}> Group table by:</div>
                        <div className="col">

                            <Dropdown value={tableGrouping}  className="p-inputtext-sm mt-2" options={tableGroupingOptions} onChange={(e) => setTableGrouping(e.value)}></Dropdown>
                        </div>
                    </div>
                    
                    <div className="field grid">
                        <div className="col-fixed" style={{width: '220px'}}> Show timeline:</div>
                        <div className="col">

                        <Checkbox checked = {showTimeline} onChange={(e) => setShowTimeline(e.checked)}/>
                        
                        </div>
                    </div>
                </div>
            </div>

        </Dialog >)

};