import { Dialog } from "primereact/dialog";
import { ProgressBar } from "primereact/progressbar";
import { useEffect, useState } from "react";
import { useSelector, useDispatch } from "react-redux";
import { DownloadActions } from "../../store/downloadFile/reducer";



export default function DownloadFileDialog ({visible, onHide, selectedFile}) {


    const {progress} = useSelector((state) => state.download);
    const dispatch = useDispatch();
    const [progressValue, setProgressValue] = useState(0);

    useEffect(() => {

        console.log(progress);
        if (progress) setProgressValue(Number(progress));
    }, [progress])

    useEffect(() => {

        if (visible && selectedFile) dispatch(DownloadActions.downloadFile(selectedFile));

    },  [visible, selectedFile, dispatch])




    return (

        <Dialog
            className='download-file'
            header={"Download log file"}
            visible={visible}
            style={{ width: '30vw', maxHeight: "90%" }}
            onHide={onHide}>
            <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
                <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

                    <div className="field grid">
                        <div className="col-fixed" style={{width: '220px'}}>Download Progress:</div>
                        <div className="col">
                             <ProgressBar value={progressValue}></ProgressBar>
                        </div>
                    </div>
                </div>
            </div>

        </Dialog >)

};