import { Dialog } from "primereact/dialog";
import { Button } from "primereact/button";
import { RadioButton } from 'primereact/radiobutton';
import { useState } from "react";
import { clusterDropModes } from "../../config";


const DropModeDialog = (props) => {

    const [dropMode, setDropMode] = useState(clusterDropModes.PRIMARY);

    const handleOk = () => {


        props.onOkClick(dropMode);


    }

    const renderFooter = () => {
        return (
            <div style={{ display: "flex", justifyContent: "space-between" }}>
                <Button label={"Close"} icon="pi pi-times" onClick={props.onHide} className="p-button-text" />
                <Button
                    label={"Next"}
                    icon="pi pi-arrow-right"
                    iconPos="right"
                    onClick={handleOk} autoFocus />
            </div>
        );

    }



    return (

        <Dialog
            className='choose-monitor-type'
            header={"Drop primary / cluster"}
            visible={props.visible}
            style={{ width: '30vw', maxHeight: "90%" }}
            onHide={props.onHide}
            footer={renderFooter()}>
            <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
                <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

                    <div className="field grid">
                        <div className="col">
                            <div className="field-radiobutton">
                                <RadioButton inputId="dropOption1" name="dropOption"  value={clusterDropModes.PRIMARY} checked={dropMode === clusterDropModes.PRIMARY } onChange={(e) => setDropMode(e.value)} />
                                <label htmlFor="dropOption1">Drop this primary only</label>
                            </div>
                            <div className="field-radiobutton">
                                <RadioButton inputId="dropOption2" name="dropOption"  value={clusterDropModes.CLUSTER} checked={dropMode === clusterDropModes.CLUSTER} onChange={(e) => setDropMode(e.value)} />
                                <label htmlFor="dropOption2">Drop the entire cluster</label>
                            </div>
                        </div>
                    </div>


                </div>
            </div>

        </Dialog>)

};

export default DropModeDialog;