import { Dialog } from "primereact/dialog";
import moment from "moment";
import { Terminal } from "primereact/terminal";

const DumpDetailsDialog =  (props) => 
{

  
  return (<Dialog
    className='dump-details'
    header={`Dump for ${props.dump.node_name}:`}
    visible={props.visible}
    style={{ width: '50vw', maxHeight: '90%', height: "450px"}}
    onHide={props.onHide}>
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
    <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">


                    <div className="field grid">
                    <label className="col-fixed">{`Created by :`}</label>
                      <div className="col">
                        {props.dump.created_by}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Creation date:`}</label>
                      <div className="col">
                      { moment(props.dump.created_date).format("MMM DD,YYYY, hh:mm A")}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Dump file_name :`}</label>
                      <div className="col">
                        { props.dump.name}
                    </div>
                    </div>

                     
                                      <div className="field grid">
                                      <label className="col-fixed">{`Log:`}</label>
                                      {props.dump.run_log ?                     <Terminal
                    welcomeMessage = {props.dump.run_log} prompt = {"$"}
                  /> : "No logs"}
                          </div>
                    <div className="field grid">
                    <label className="col-fixed">{`Duration (sec):`}</label>
                      <div className="col">
                        {props.dump.ex_params.duration}

                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Size (GB):`}</label>
                      <div className="col">
                        {props.dump.display_size}

                    </div>
                    </div>

        </div>

        </div>

        </Dialog>
)

}

export default DumpDetailsDialog;
