import { Dialog } from "primereact/dialog";
import { Button } from "primereact/button";
import { RadioButton } from 'primereact/radiobutton';
import { useState } from "react";
import { types } from "../../../config";


const MonitorTypeDialog = (props) => {

    const [monitorOption, setMonitorOption] = useState(types.ELASTIC);

    const handleOk = () => {


        props.onOkClick(monitorOption);


    }

    const renderFooter = () => {
        return (
            <div style={{ display: "flex", justifyContent: "space-between" }}>
                <Button label={"Close"} icon="pi pi-times" onClick={props.onHide} className="p-button-text" />
                <Button
                    label={"Next"}
                    icon = "pi pi-arrow-right"
                    iconPos="right"
                    onClick={handleOk} autoFocus />
            </div>
        );

    }



    return (

        <Dialog
            className='choose-monitor-type'
            header={"Choose monitor node type"}
            visible={props.visible}
            style={{ width: '30vw', maxHeight: "90%"}}
            onHide={props.onHide}
            footer={renderFooter()}>
            <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
                <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

                    <div className="field grid">
                        <div className="col"> 
                        <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption1" name="monitorOption" value={types.ELASTIC} checked={monitorOption === types.ELASTIC} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption1">Elasticsearch</label>
                            </div>
                        <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption2" name="monitorOption" value={types.MARIADB} checked={monitorOption === types.MARIADB} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption2">MariaDB</label>
                            </div>
                        <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption3" name="monitorOption" value={types.MONGO} checked={monitorOption ===types.MONGO} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption3">MongoDB</label>
                            </div>
                            <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption4" name="monitorOption" value={types.MSSQL} checked={monitorOption === types.MSSQL} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption4">SQL Server</label>
                            </div>
                            <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption5" name="monitorOption" value={types.MYSQL} checked={monitorOption === types.MYSQL} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption5">MySQL</label>
                            </div>
                            <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption6" name="monitorOption" value={types.ORACLE_CDB} checked={monitorOption === types.ORACLE_CDB} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption6">Oracle CDB</label>
                            </div>

                            <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption7" name="monitorOption" value={types.ORACLE_PDB} checked={monitorOption === types.ORACLE_PDB} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption7">Oracle PDB</label>
                            </div>
                            <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption8" name="monitorOption" value={types.POSTGRES} checked={monitorOption === types.POSTGRES} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption8">PostgreSQL</label>
                            </div>
                            <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption9" name="monitorOption" value={types.REDIS} checked={monitorOption === types.REDIS} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption9">Redis</label>
                            </div>
                            <div className="field-radiobutton">
                                <RadioButton inputId="monitorOption10" name="monitorOption" value={types.LINUX} checked={monitorOption === types.LINUX} onChange={(e) => setMonitorOption(e.value)} />
                                <label htmlFor="monitorOption10">Linux</label>
                            </div>
                        </div>
                    </div>


                </div>
            </div>

        </Dialog>)

};

export default MonitorTypeDialog;