import { Dialog } from "primereact/dialog";
import { Button } from "primereact/button";
import { SelectButton } from "primereact/selectbutton";
import { useState } from "react";

const AddCDBMethodDialog = ({ visible, onHide, onOkClick}) => {

 const [addMethod, setAddMethod] = useState("register")

 const addOptions = [
  { label: "Register existing CDB", value: "register" },
  { label: "Install new CDB", value: "install" }
]

  const renderFooter = () => {
    return (
      <div className="flex justify-content-center">
        <Button label={"Close"} icon="pi pi-times" onClick={onHide} className="p-button-text"/>
        <Button
          label={"Next"}
          icon={`pi pi-arrow-right`}
          onClick={() => onOkClick(addMethod)} autoFocus />
      </div>
    );

  }

  return (<Dialog
    className='add-cdb_method-dialog'
    header="Add CDB"
    footer={renderFooter()}
    dismissableMask
    visible={Boolean(visible)}
    style={{ width: '40vw', maxHeight: '90%' }}
    onHide={onHide}>
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
      <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

        <div className="field grid">
          <div className="col">

            <SelectButton className="p-button-sm" value={addMethod} options={addOptions} onChange={(e) => setAddMethod(e.value)} />

          </div>
        </div>

      </div>
    </div>

  </Dialog>
  )

}

export default AddCDBMethodDialog;