import config from "../../../config";

const constraints = {
    name: {
        presence: {
            message: "PDB Name is required field.",
            allowEmpty: false
        },
        format:{

            pattern: "^[a-zA-Z0-9]+([a-zA-Z0-9_]+)*$",
            message: "PDB Name has invalid format"

        },
       
    },
    dbUserName: {
        presence: {
            message: "DB User Name is required field.",
            allowEmpty: false
        },
        format:{

            pattern: "[\\w\\$\\#]+$",
            message: "DB User Name has invalid format"

        },
        exclusion: {
            within:  ["sys", "system"],
          }
    },
    dbPassword: {
        presence: {
            message: "Password is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.passwordRegex,
            message: "Password has invalid format."
        }
    },
    fileDestination: {
        presence: {
            message: "File Destination is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.pathRegex,
            message: "File Destination has invalid format."
        }
    },
}

export default constraints;