import config from "../../../config";

const constraints = {
    username: {
        presence: {
            message: "Database Username is required field."
        }
    },
    password: {
        presence: {
            message: "Password is required field."
        },
        format: {
            pattern: config.passwordRegex,
            message: "Password has invalid format."
        }
    },
    name: {

        presence: {
            message: "PDB name is required field",
            allowEmpty: false
        },
        format: {
            pattern: config.oracleNameRegex,
            message: "PDB name has invalid format."
        },
    },
    serviceName: {
        presence: {
            message: "Service Name is required field."
        },
        format: {

            pattern: "^[a-zA-Z0-9]*$",
            message: "Service Name has invalid format."

        }
    },
    port: {
        presence: {
            message: "Port is required field."
        },
        numericality: {
            greaterThan: 0,
            lessThanOrEqualTo: 65535,
        }
    },
    
    hostName: {
        presence: {
            message: "Host Name is required field."
        },
        format: {
            pattern: config.hostNameRegex,
            message: "Host Name has invalid format."
        }
    },
}

export default constraints;