import { Dialog } from "primereact/dialog";
import moment from "moment";
import { Terminal } from "primereact/terminal";

const ExportDetailsDialog =  (props) => 
{

  
  return (<Dialog
    className='export-details'
    header={`Export for ${props.export.created_by}@${props.export.node_name}:`}
    visible={props.visible}
    style={{ width: '50vw', maxHeight: '90%', height: "700px"}}
    onHide={props.onHide}>
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
    <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">


                    <div className="field grid">
                    <label className="col-fixed">{`Created by :`}</label>
                      <div className="col">
                        { props.export.created_by}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Creation date:`}</label>
                      <div className="col">
                      { moment(props.export.created_date).format("MMM DD,YYYY, hh:mm A")}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Export file_name :`}</label>
                      <div className="col">
                        { props.export.name}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Exit code:`}</label>
                      <div className="col">
                        {props.export.ex_params.exit_code}

                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Duration (sec):`}</label>
                      <div className="col">
                        {props.export.ex_params.duration}

                    </div>
                    </div>

                    
                    <div className="field grid">
                    <label className="col-fixed">{`Log:`}</label>
                    </div>
                    {props.export.run_log ?                     <Terminal
  welcomeMessage = {props.export.run_log} prompt = {"$"}
/> : "No logs"}
        </div>

        </div>

        </Dialog>
)

}

export default ExportDetailsDialog;
