import { Dialog } from "primereact/dialog";
import moment from "moment";
import { Terminal } from "primereact/terminal";

const FlashbackDetailsDialog =  (props) => 
{

  
  return (<Dialog
    className='flashback-details'
    header={`Flashback for ${props.flashback.node_name}:`}
    visible={props.visible}
    style={{ width: '50vw', maxHeight: '90%'}}
    onHide={props.onHide}>
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
    <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

    <div className="field grid">
                    <label className="col-fixed">{`Name :`}</label>
                      <div className="col">
                        { props.flashback.name}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Created by :`}</label>
                      <div className="col">
                        { props.flashback.created_by}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Creation date:`}</label>
                      <div className="col">
                      { moment(props.flashback.created_date).format("MMM DD,YYYY, hh:mm A")}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Exit code:`}</label>
                      <div className="col">
                        {props.flashback.ex_params.exit_code}

                    </div>
                    </div>

                    
                    <div className="field grid">
                    <label className="col-fixed">{`Flashback guarantee:`}</label>
                      <div className="col">
                        {props.flashback.ex_params.guaranteed ? "Yes" : "No"}

                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Duration (sec):`}</label>
                      <div className="col">
                        {props.flashback.ex_params.duration}

                    </div>
                    </div>

                    
                    <div className="field grid">
                    <label className="col-fixed">{`Log:`}</label>
                    </div>

                    {props.flashback.run_log ?                     <Terminal
  welcomeMessage = {props.flashback.run_log} prompt = {"$"}
/> : "No logs"}
        </div>

        </div>

        </Dialog>
)

}

export default FlashbackDetailsDialog;
