import { Dialog } from "primereact/dialog";
import { Button } from "primereact/button";
import { FileUpload } from 'primereact/fileupload';
import { useState } from "react";
import ErrorTextBox from "../../../components/errorTextBox";
import { useSelector } from "react-redux";


const ImportStandaloneDialog = (props) => 
{
  const [file, setFile] = useState(false);
  const {errorMessage} = useSelector((state) => state.layout);
    
  const handleOk = () =>
  {
    if(file) props.onOkClick(file);
  }

  const onFileUpload = (e) =>
  {
      if(e.files.length > 0) 
      {
        setFile(e.files[0]);

      }
  }

  const renderFooter = () => {
        return (
            <div style={{ display: "flex", justifyContent: "space-between" }}>
                <Button label={"Cancel"} icon="pi pi-times" onClick={props.onHide} className="p-button-text" />
                <Button
                    label={"Upload"}
                    onClick={handleOk} autoFocus />
            </div>
        );
 
}



  return (
    
    <Dialog
            className='import-standalone'
            header={`TNS file upload`}
            visible={props.visible}
            style={{ width: '30vw'}}
            onHide={props.onHide}
            footer={renderFooter()}>
            <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
            <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">
                    <div className="field grid">
                    <label className="col-fixed">{"File source:"}</label>
                      <div className="col">
                      <FileUpload mode="basic" onSelect = {onFileUpload} />
                    </div>
                    </div>
                    {errorMessage && <ErrorTextBox error = {errorMessage?.message ? errorMessage.message : errorMessage}/>}
                    </div>
            </div>
        </Dialog>)

};

export default ImportStandaloneDialog;