
//need to check
import { useState } from "react";
import { Checkbox } from 'primereact/checkbox';
import { Dialog } from "primereact/dialog";
import { Button } from "primereact/button";
import { Slider } from 'primereact/slider';
import { useSelector } from "react-redux";
import ErrorTextBox from "../../../components/errorTextBox";

export const LimitsPDBDialog = (props) => {

  const {errorMessage, isLoading} = useSelector((state) => state.layout);
  const [autoStart, setAutoStart] = useState(false);
  const [maxSize, setMaxSize] = useState(1);
  const [sharedSize, setSharedSize] = useState(1);
  const [cpuCount, setCpuCount] = useState(1);

  const handleOk = () => {

    props.onOkClick(
      {
        "pdb_id": props.node.id,
        "auto_start": autoStart,
        "max_size": maxSize,
        "shared_size": sharedSize,
        "cpu_count": cpuCount,
      })
  }

  const renderFooter = () => {
    return (
      <div style={{ display: "flex", justifyContent: "space-between" }}>
        <Button label={"Close"} icon="pi pi-times" onClick={props.onHide} className="p-button-text" />
        <Button
          label={"Submit"}
          icon= {`pi pi-${isLoading ? 'spin pi-spinner' : 'check'}`}
          iconPos="right"
          onClick={handleOk} autoFocus />
      </div>
    );
  }

  return (
    <Dialog
      className='limit-pdb'
      header={`${props.node.location} configuration`}
      visible={props.visible}
      style={{ width: '50vw'}}
      onHide={props.onHide}
      footer={renderFooter()}>
      <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
        <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">
          <div className="field grid" style={{ "alignItems": "center" }}>
            <label className="col-fixed">{`Max disk size ${maxSize} GB`}</label>
            <div className="col">

              <Slider value={maxSize} min={1} max={16} step={1} onChange={(e) => setMaxSize(e.value)} />
            </div>
          </div>
          <div className="field grid" style={{ "alignItems": "center" }}>
            <label className="col-fixed">{`Shared temp size ${sharedSize} GB`}</label>
            <div className="col">
              <Slider min={1} max={16} value={sharedSize} step={1} onChange={(e) => setSharedSize(e.value)} />
            </div>
          </div>
          <div className="field grid" style={{ "alignItems": "center" }}>
            <label className="col-fixed">{`Limit cpu count to ${cpuCount} CPUs`}</label>
            <div className="col">
              <Slider min={1} max={16} value={cpuCount} step={1} onChange={(e) => setCpuCount(e.value)} />
            </div>
          </div>
          <div className="field grid">
            <label className="col-fixed">{"Auto startup"}</label>
            <div className="col">
              <Checkbox
                onChange={e => setAutoStart(e.checked)}
                checked={autoStart}>
              </Checkbox>
            </div>
          </div>
          {errorMessage && <ErrorTextBox error = {errorMessage?.message ? errorMessage.message : errorMessage}/>}
        </div>
      </div>
    </Dialog>)
};

export default LimitsPDBDialog;