import config from "../../../config";

const constraints = {
    port: {
        presence: {
            message: "Port is required field.",
            allowEmpty: false
        },
        numericality: {
            greaterThan: 0,
            lessThanOrEqualTo: 65535,
        }
    },
    osUsername: {
        presence: {
            message: "OS Username is required field.",
            allowEmpty: false
        },
        format:                                                         
        {
            pattern: config.usernameRegex,
            message: "Os Username has invalid format."
        }
    },
    privateKey: {
        presence: {
            message: "Private Key is required field.",
            allowEmpty: false
        }
    },
    osPassword: {
        presence: {
            message: "Password is required field.",
            allowEmpty: false
        },
        length: {
            minimum: 5,
            tooShort: "min %{count} characters"
        },
    },
    repmgrUserPassword: {
        presence: {
            message: "Password is required field.",
            allowEmpty: false
        },
    },

    hostname: {
        presence: {
            message: "Hostname is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.hostNameRegex,
            message: "Host Name has invalid format."
        }
    },
    sshPort: {
        presence: {
            message: "SSH Port is required field.",
            allowEmpty: false
        },
        numericality: {
            greaterThan: 0,
            lessThanOrEqualTo: 65535
        }
    },
    pgData: {
        presence: {
            message: "$PGDATA is required field.",
            allowEmpty: false
        },

        format:                                                         
        {
            pattern: config.pathRegex,
            message: "$PGDATA has invalid format."
        }
    },
    writeAheadLogDirectory: {
        presence: {
            message: "wal directory is required field.",
            allowEmpty: false
        },

        format:                                                         
        {
            pattern: config.pathRegex,
            message: "wal directory has invalid format."
        }
    },
}

export default constraints;