import { Dialog } from "primereact/dialog";
import moment from "moment";
import { Terminal } from "primereact/terminal";

const BackupDetailsDialog =  (props) => 
{

  
  return (<Dialog
    className='backup-details'
    header={`Backup for ${props.backup.node_name}:`}
    visible={props.visible}
    style={{ width: '50vw', maxHeight: '90%', height: "400px"}}
    onHide={props.onHide}>
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
    <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

    <div className="field grid">
                    <label className="col-fixed">{`Name:`}</label>
                      <div className="col">
                        { props.backup.name}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Created by:`}</label>
                      <div className="col">
                        { props.backup.created_by}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Creation date:`}</label>
                      <div className="col">
                      { moment(props.backup.created_date).format("MMM DD,YYYY, hh:mm A")}
                    </div>
                    </div>

                   
                                    <div className="field grid">
                                    <label className="col-fixed">{`Log:`}</label>
                                    {props.backup.run_log ?                     <Terminal
                  welcomeMessage = {props.backup.run_log} prompt = {"$"}
                /> : "No logs"}
                        </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Duration (sec):`}</label>
                      <div className="col">
                        {props.backup.ex_params.duration}

                    </div>
                    </div>
                    
        </div>

        </div>

        </Dialog>
)

}

export default BackupDetailsDialog;
