import config from "../../../config";

const constraints = {
    clusterName: {
        presence: {
            message: "Cluster Name is required field.",
            allowEmpty: false
        },
        format: {
            pattern: /^\S*$/,
            message: "Cluster Name has invalid format."
        }
    },
    databaseUsername: {
        presence: {
            message: "Database Username is required field.",
            allowEmpty: false
        },
        length: {
            maximum: 31,
            tooLong: "max %{count} characters"
        },
        format:                                                         
        {
            pattern: config.usernameRegex,
            message: "Database Username has invalid format."
        }
    },
    databasePassword: {
        presence: {
            message: "Password is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.passwordRegex,
            message: "Password has invalid format."
        }
    },

    redisUserPassword: {
        presence: {
            message: "Password is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.passwordRegex,
            message: "Password has invalid format."
        }
    },

    masterauthPassword: {
        presence: {
            message: "Password is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.passwordRegex,
            message: "Password has invalid format."
        }
    },
}

export default constraints;