import { Dialog } from "primereact/dialog";
import { Button } from "primereact/button";
import { Dropdown } from "primereact/dropdown";
import { useState } from "react";
import { osTypes} from "../../config";


export default function SelectOsDialog ({visible, service, onBack, onHide, onOkClick}) {

    const [osOption, setOsOption] = useState(osTypes[0].value);

    const renderFooter = () => {
        return (
            <div style={{ display: "flex", justifyContent: "space-between" }}>
                <Button label={"Back"} icon="pi pi-arrow-left" onClick={onBack} className="p-button-text" />
                <Button
                    label={"Next"}
                    icon="pi pi-arrow-right"
                    iconPos="right"
                    onClick={() => onOkClick(osOption)} autoFocus />
            </div>
        );

    }



    return (

        <Dialog
            className='choose-os'
            header={"Choose OS version"}
            visible={visible}
            style={{ width: '30vw', maxHeight: "90%" }}
            onHide={onHide}
            footer={renderFooter()}>
            <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
                <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

                    <div className="field grid">
                        <div className="col-fixed" style={{width: '220px'}}>OS Options:</div>
                        <div className="col">

                            <Dropdown value={osOption}  className="p-inputtext-sm mt-2" options={service?.supported_os ? osTypes.filter((t) => Object.keys(service.supported_os).includes(t.value)) : null} onChange={(e) => setOsOption(e.value)}></Dropdown>
                        </div>
                    </div>
                </div>
            </div>

        </Dialog >)

};