import { Dialog } from "primereact/dialog";
import { Terminal } from "primereact/terminal";

const StepDetailsDialog = ({ step, visible, onHide }) => {


  return (<Dialog
    className='step-details'
    header={`Details for ${step?.step} step of ${step?.task}:`}
    visible={visible}
    style={{ width: '50vw', maxHeight: '90%', height: "700px" }}
    onHide={onHide}>
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
      <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">
        <div className="field grid">
          <label className="col-fixed">{`Exit code:`}</label>
          <div className="col">
            {step?.retcode ? step?.retcode : 0}

          </div>
        </div>

        <div className="field">
          <label>{`Return message:`}</label>
        </div>

        <div> 


        <Terminal
              welcomeMessage={step?.retmsg ? step.retmsg : 'no message'} className={step?.retmsg ? "" : "h-4rem"}
            />
        
        
        </div>

    
        <div className="field">
          <label className="col">{`Return output:`}</label>
        </div>

        <div> 
          <Terminal className={`multiline ${step?.retoutput ? "" : "h-4rem"}`}
                welcomeMessage={step?.retoutput ? step.retoutput : 'no output'}
              />

        </div>      

        </div>
      </div>

  </Dialog>
  )

}

export default StepDetailsDialog;
