import { Dialog } from 'primereact/dialog';
import { InputTextarea } from 'primereact/inputtextarea';

export default function WarningDialog(props) {

    return (

        <Dialog
            className='warning modal'
            header={`Warning`}
            visible={props.visible}
            style={{ width: '40vw', maxHeight: "90%" }}
            onHide={props.onHide}>
            <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
                <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">
                    <div className="field grid">
                        <div className="col-fixed" >Message: </div>
                        <div className="col multiline">  
                         <InputTextarea value={props.message?.text} rows={5} cols={30} /></div>
                    </div>
                    {props.message.status && <div className="field grid">
                        <div className="col-fixed" >Status: </div>
                        <div className="col">{props.message?.status}</div>
                    </div>}


                </div>
            </div>

        </Dialog>);
}