import { Provider } from "react-redux";
import { PersistGate } from "redux-persist/integration/react";
import { persistor, store } from "./store/store";
import App from "./app";
import "./assets/css/custom.css";
import 'react-toastify-modernize/dist/ReactToastify.css';
import "primereact/resources/themes/lara-dark-teal/theme.css";
import "primereact/resources/primereact.min.css";
import "primeflex/primeflex.css";
import "primeicons/primeicons.css";
import { PrimeReactProvider } from 'primereact/api'


const onBeforeLift = () => {
};


const Entry = () => {

    return (
            <Provider store={store}>
                <PersistGate loading={null} persistor={persistor} onBeforeLift={onBeforeLift}>
                    <PrimeReactProvider>
                        <App />
                    </PrimeReactProvider>
                </PersistGate>
            </Provider>
    );
}


export default Entry;
