import axios from "axios";
import config from "../../config";
const addElasticSearchMaster = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/create_elasticsearch_master/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const addElasticSearchIndex = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/add_elasticsearch_index/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const checkElasticSearchIndexSize = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_elasticsearch_index_size/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response.data
            }
        });
    return error_data ? error_data : res?.data;
}
const checkElasticSearchIndexName = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_elasticsearch_index_name/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response.data
            }
        });
    return error_data ? error_data : res?.data;
}
const checkElasticSearchVersionExists = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_elasticsearch_version_exists/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response.data
            }
        });
    return error_data ? error_data : res?.data;
}
const getElasticSearchClusterStatus = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/elasticsearch_cluster_status/${id}/`;
    let error_data = false;
    const res = await axios.post(url, null,
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const upgradeElasticSearchNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/upgrade_elasticsearch_node/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const dumpElasticSearchIndex = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/dump_elasticsearch_index/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const copyElasticSearchIndex = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/copy_elasticsearch_index/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}

const restoreElasticSearchIndex = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/restore_elasticsearch_index/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const startElasticSearchNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/start_elasticsearch_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const stopElasticSearchNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/stop_elasticsearch_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const restoreElasticSearchCluster = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/restore_elasticsearch_cluster/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const snapshotElasticSearchCluster = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/snapshot_elasticsearch_cluster/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const getElasticSearchDetails = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/status/elastic/${id}/`;
    let error_data;
    const res = await axios.get(url,
        {
            headers: {
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const dropElasticSearchNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/drop_elasticsearch_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const removeElasticSearchSchedule = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/remove_elasticsearch_schedule/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const dropElasticSearchIndex = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/drop_elasticsearch_index/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const addElasticSearchNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/create_elasticsearch_node/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const switchElasticsearchNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/switch_elasticsearch_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    return error_data ? error_data : res?.data;
}
const apiElasticSearch =
{
    addElasticSearchMaster,
    addElasticSearchIndex,
    checkElasticSearchIndexName,
    checkElasticSearchIndexSize,
    dumpElasticSearchIndex,
    getElasticSearchClusterStatus,
    copyElasticSearchIndex,
    restoreElasticSearchIndex,
    dropElasticSearchIndex,
    snapshotElasticSearchCluster,
    restoreElasticSearchCluster,
    removeElasticSearchSchedule,
    dropElasticSearchNode,
    getElasticSearchDetails,
    startElasticSearchNode,
    stopElasticSearchNode,
    addElasticSearchNode,
    checkElasticSearchVersionExists,
    switchElasticsearchNode,
    upgradeElasticSearchNode
}
export default apiElasticSearch;