import axios from "axios";
import config from "../../config";
const addMariaDBMaster = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/create_mariadb_master/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const switchMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/switch_mariadb_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMariaDBUserExists = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mariadb_user_exists/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const startMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/start_mariadb_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const stopMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/stop_mariadb_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const upgradeMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/upgrade_mariadb_node/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const getMariaDBDetails = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/status/mariadb/${id}/`;
    let error_data;
    const res = await axios.get(url,
        {
            headers: {
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
        return error_data ? error_data : res?.data;
}
const addMariaDBDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/add_mariadb_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMariaDBVersionExists = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mariadb_version_exists/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const restoreMariaDBDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/restore_mariadb_database/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const dropMariaDBDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/drop_mariadb_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const exportMariaDBDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/export_mariadb_database/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMariaDBDatabaseSize = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mariadb_database_size/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
    }
const checkMariaDBDatabaseName = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mariadb_database_name/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const dropMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/drop_mariadb_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const exportMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/export_mariadb_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const importMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/import_mariadb_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const addMariaDBStandby = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/create_mariadb_standby/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const backupMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/backup_mariadb_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const restoreMariaDBNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/restore_mariadb_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const removeMariaDBSchedule = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/remove_mariadb_schedule/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const copyMariaDBDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/copy_mariadb_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const getMariaDBClusterStatus = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/mariadb_cluster_status/${id}/`;
    let error_data = false;
    const res = await axios.post(url, null,
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}

const apiMariaDB = 
{
    addMariaDBMaster,
    checkMariaDBDatabaseName,
    addMariaDBDatabase,
    exportMariaDBDatabase,
    checkMariaDBDatabaseSize,
    dropMariaDBDatabase,
    dropMariaDBNode,
    exportMariaDBNode,
    importMariaDBNode,
    stopMariaDBNode,
    startMariaDBNode,
    restoreMariaDBDatabase,
    addMariaDBStandby,
    getMariaDBDetails,
    backupMariaDBNode,
    restoreMariaDBNode,
    removeMariaDBSchedule,
    getMariaDBClusterStatus,
    switchMariaDBNode,
    copyMariaDBDatabase,
    checkMariaDBUserExists,
    checkMariaDBVersionExists,
    upgradeMariaDBNode,
   
}
export default apiMariaDB;