import axios from "axios";
import config from "../../config";
const getNodeMonitorNames = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/get_node_monitor_names/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    ;
    return error_data ? error_data : res?.data;
}

const checkNodeCpuRamCurrent = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_cpu_ram_current/`;
    const res = await axios.post(url, data, {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const getMonitorChartColumns = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/get_monitor_chart_columns/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    ;
    return error_data ? error_data : res?.data;
}
const getLastNodeMonitorAlert = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/get_last_node_monitor_alert/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    ;
    return error_data ? error_data : res;
}
const getMonitorChart = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/get_monitor_chart/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }
        });
    ;
    return error_data ? error_data : res?.data;
}
const getMessage = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/get_message/${id}/`;
    const res = await axios.get(url, {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const getMonitors = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/get_monitors/`;
    const res = await axios.post(url, data, {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const snoozeMonitor = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/snooze_monitor/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const getAlerts = async (accessToken) => {
    const url = `${config.apiUrl}/cluster-core/api/alerts_list/`;
    const res = await axios.get(url, {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const getAgents = async (accessToken) => {
    const url = `${config.apiUrl}/cluster-core/api/agents_list/`;
    const res = await axios.get(url, {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const getNodeMonitorsTable = async (accessToken, tyoe) => {
    const url = `${config.apiUrl}/cluster-core/api/get_node_monitors_table/${tyoe}/`;
    const res = await axios.get(url, {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const getAgentsSummary = async (accessToken) => {
    const url = `${config.apiUrl}/cluster-core/api/get_agents_summary/`;
    const res = await axios.get(url, {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const getNodeAlerts = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/alerts_list/${data?.node_id}/`;
    const res = await axios.post(url, JSON.stringify(data), {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const getAlertHistory = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/get_alert_history/`;
    const res = await axios.post(url, data, {
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + accessToken
        }
    });
    return res?.data;
}
const addAgent = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/add_agent/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const deleteAgent = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/delete_agent/${id}/`;
    let error_data = false;
    const res = await axios.delete(url,
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const editAgent = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/edit_agent/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const addMonitor = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/add_monitor/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const updateMonitor = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/update_monitor/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const getAgentsChart = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/get_agents_chart/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const deleteMonitor = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/delete_monitor/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const getDashboardMonitors = async (accessToken, data) => {
  const url = `${config.apiUrl}/cluster-core/api/get_dashboard_monitors/`;
  const res = await axios.post(url, data, {
      headers: {
          "Content-Type": "application/json",
          "Authorization": "Bearer " + accessToken
      }
  });
  return res?.data;
}
const reorderDashboardMonitors = async (accessToken, data) => {
  const url = `${config.apiUrl}/cluster-core/api/reorder_dashboard_monitors/`;
  const res = await axios.post(url, data, {
      headers: {
          "Content-Type": "application/json",
          "Authorization": "Bearer " + accessToken
      }
  });
  return res?.data;
}
const addDashboardMonitor = async (accessToken, data) => {
  const url = `${config.apiUrl}/cluster-core/api/add_dashboard_monitor/`;
  let error_data = false;
  const res = await axios.post(url, JSON.stringify(data),
      {
          headers: {
              "Content-Type": "application/json",
              "Authorization": "Bearer " + accessToken
          }
      }).catch(function (error) {
          if (error.response) {
              error_data = error.response
          }});
  return error_data ? error_data : res?.data;
}
const deleteDashboardMonitor = async (accessToken, data) => {
  const url = `${config.apiUrl}/cluster-core/api/delete_dashboard_monitor/`;
  let error_data = false;
  const res = await axios.post(url, JSON.stringify(data),
      {
          headers: {
              "Content-Type": "application/json",
              "Authorization": "Bearer " + accessToken
          }
      }).catch(function (error) {
          if (error.response) {
              error_data = error.response
          }});
  return error_data ? error_data : res?.data;
}

const apiMonitoring = {
    snoozeMonitor,
    getAlertHistory,
    getAlerts,
    getNodeAlerts,
    getMessage,
    getMonitors,
    addMonitor,
    addAgent,
    editAgent,
    deleteAgent,
    getAgents,
    getNodeMonitorsTable,
    getAgentsChart,
    getAgentsSummary,
    updateMonitor,
    getNodeMonitorNames,
    getMonitorChartColumns,
    getLastNodeMonitorAlert,
    getMonitorChart,
    deleteMonitor,
    getDashboardMonitors,
    reorderDashboardMonitors,
    addDashboardMonitor,
    deleteDashboardMonitor,
    checkNodeCpuRamCurrent
}
export default apiMonitoring;
