import axios from "axios";
import config from "../../config";
const addMsSQLMaster = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/create_mssql_master/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const switchMsSQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/switch_mssql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMsSQLUserExists = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mssql_user_exists/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const startMsSQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/start_mssql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const stopMsSQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/stop_mssql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const getMsSQLDetails = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/status/mssql/${id}/`;
    let error_data;
    const res = await axios.get(url,
        {
            headers: {
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
        return error_data ? error_data : res?.data;
}
const addMsSQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/add_mssql_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMsSQLVersionExists = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mssql_version_exists/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const restoreMsSQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/restore_mssql_database/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const dropMsSQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/drop_mssql_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const exportMsSQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/export_mssql_database/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMsSQLDatabaseSize = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mssql_database_size/`;
    let error_data;
    const res = await axios.post(url, data,
        {
            headers: {
                "Authorization": "Bearer " + accessToken,
                "Content-Type": "application/json",
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
    }
const checkMsSQLDatabaseName = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mssql_database_name/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const dropMsSQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/drop_mssql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const exportMsSQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/export_mssql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const importMsSQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/import_mssql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const addMsSQLStandby = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/create_mssql_standby/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const backupMsSQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/backup_mssql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const restoreMsSQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/restore_mssql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const removeMsSQLSchedule = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/remove_mssql_schedule/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const copyMsSQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/copy_mssql_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const getMsSQLClusterStatus = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/mssql_cluster_status/${id}/`;
    let error_data = false;
    const res = await axios.post(url, null,
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}

const apiMsSQL = 
{
    addMsSQLMaster,
    checkMsSQLDatabaseName,
    addMsSQLDatabase,
    exportMsSQLDatabase,
    checkMsSQLDatabaseSize,
    dropMsSQLDatabase,
    dropMsSQLNode,
    exportMsSQLNode,
    importMsSQLNode,
    stopMsSQLNode,
    startMsSQLNode,
    restoreMsSQLDatabase,
    addMsSQLStandby,
    getMsSQLDetails,
    backupMsSQLNode,
    restoreMsSQLNode,
    removeMsSQLSchedule,
    getMsSQLClusterStatus,
    copyMsSQLDatabase,
    checkMsSQLUserExists,
    switchMsSQLNode,
    checkMsSQLVersionExists,
   
}
export default apiMsSQL;