import axios from "axios";
import config from "../../config";
const addMySQLMaster = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/create_mysql_master/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const upgradeMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/upgrade_mysql_node/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const switchMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/switch_mysql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMySQLUserExists = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mysql_user_exists/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const startMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/start_mysql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const stopMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/stop_mysql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const getMySQLDetails = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/status/mysql/${id}/`;
    let error_data;
    const res = await axios.get(url,
        {
            headers: {
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
        return error_data ? error_data : res?.data;
}
const addMySQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/add_mysql_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMySQLVersionExists = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mysql_version_exists/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const restoreMySQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/restore_mysql_database/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const dropMySQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/drop_mysql_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const exportMySQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/export_mysql_database/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const checkMySQLDatabaseSize = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mysql_database_size/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
    }
const checkMySQLDatabaseName = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/check_mysql_database_name/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const dropMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/drop_mysql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const exportMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/export_mysql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const importMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/import_mysql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const addMySQLStandby = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/create_mysql_standby/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const backupMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/backup_mysql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const restoreMySQLNode = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/restore_mysql_node/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const removeMySQLSchedule = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/remove_mysql_schedule/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response.data
            }});
        return error_data ? error_data : res?.data;
}
const copyMySQLDatabase = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/copy_mysql_database/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}
const getMySQLClusterStatus = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/mysql_cluster_status/${id}/`;
    let error_data = false;
    const res = await axios.post(url, null,
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}

const getMySQLSettings = async (accessToken, id) => {
    const url = `${config.apiUrl}/cluster-core/api/get_mysql_settings/${id}/`;
    let error_data;
    const res = await axios.get(url,
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
        return error_data ? error_data : res?.data;
}

const editMySQLSettings = async (accessToken, data) => {
    const url = `${config.apiUrl}/cluster-core/api/edit_mysql_settings/`;
    let error_data;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
              error_data = error.response
            }});
        return error_data ? error_data : res?.data;
}

const apiMySQL = 
{
    addMySQLMaster,
    checkMySQLDatabaseName,
    addMySQLDatabase,
    exportMySQLDatabase,
    checkMySQLDatabaseSize,
    dropMySQLDatabase,
    dropMySQLNode,
    exportMySQLNode,
    importMySQLNode,
    stopMySQLNode,
    startMySQLNode,
    restoreMySQLDatabase,
    addMySQLStandby,
    getMySQLDetails,
    backupMySQLNode,
    restoreMySQLNode,
    removeMySQLSchedule,
    getMySQLClusterStatus,
    copyMySQLDatabase,
    checkMySQLUserExists,
    switchMySQLNode,
    checkMySQLVersionExists,
    getMySQLSettings,
    editMySQLSettings,
    upgradeMySQLNode

   
}
export default apiMySQL;