import axios from "axios";
import config from "../../config";
const addPgPod = async (accessToken, data) => {
    const url = `${config.apiUrl}/kubernetes/api/create_pg_primary/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}

const addPgStandbyPod = async (accessToken, data) => {
    const url = `${config.apiUrl}/kubernetes/api/create_pg_standby/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}

const apiPostgKubernetes = 
{
    addPgPod,
    addPgStandbyPod
 
}
export default apiPostgKubernetes;