import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
const initialState = {
    isLoading: false,
    errorMessage: "",
    data: false,
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setErrorMessage: ["errorMessage"],
    clusterUpdate: ["data"],
}, { prefix: 'CLUSUP/' });
export const ClusterUpdateActionTypes = Types;
export const ClusterUpdateActions = Creators;
export const clusterUpdateReducer = createReducer(initialState, {
    [ClusterUpdateActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [ClusterUpdateActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [ClusterUpdateActionTypes.CLUSTER_UPDATE]: produce((draft, { data }) => ({ ...draft, data }))
});