import { call, put, takeLeading, select, delay} from "redux-saga/effects";
import { ClusterUpdateActions, ClusterUpdateActionTypes } from "./reducer";
import { ConfigActions } from "../config/reducer";
import api from "../../services/api";
import { StatusActions } from "../status/reducer";
import { LayoutActions } from "../layout/reducer";
function* clusterUpdate(action) {
    try {
        
        yield put(ClusterUpdateActions.setLoading(true));
        const { accessToken } = yield select(state => state.app);
        yield call(api.clusterUpdate, accessToken, action);
        yield put(ClusterUpdateActions.setErrorMessage(""));
        yield put(ClusterUpdateActions.setLoading(false));
        delay(1000);
        yield put(ConfigActions.setConfig(null));
        yield put (StatusActions.setNodes(null));
        yield put (LayoutActions.setNodes(null));
    }
    catch (e) {
        yield put(ClusterUpdateActions.setLoading(false));
    }
}
const sagas = [
    takeLeading(ClusterUpdateActionTypes.CLUSTER_UPDATE, clusterUpdate)
];
export default sagas;