import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
const initialState = {
    isLoading: false,
    errorMessage: "",
    database_users: null,
    integrated_services: null,
    config: false
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setErrorMessage: ["errorMessage"],
    getConfig: null,
    getIntegratedServices: null,
    setIntegratedServices: ["integrated_services"],
    addIntegratedService: ["data", "callback"],
    editIntegratedService: ["data", "callback"],
    dropIntegratedService: ["data"],
    getDatabaseUsers: ["id"],
    setConfig: ["config"],
    setDatabaseUsers: ["database_users"],
    dropDatabaseUser: ["data"],
    editDatabaseUser: ["data", "callback"],
    addLicense:  ["data", "callback"],
    updateSystemConfig: ["data"],
    removeLicense:  ["data"],
}, { prefix: 'CONFIG/' });
export const ConfigActionTypes = Types;
export const ConfigActions = Creators;
export const configReducer = createReducer(initialState, {
    [ConfigActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [ConfigActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [ConfigActionTypes.SET_CONFIG]: produce((draft, { config }) => ({ ...draft, config })),
    [ConfigActionTypes.SET_DATABASE_USERS]: produce((draft, { database_users }) => ({ ...draft, database_users })),
    [ConfigActionTypes.SET_INTEGRATED_SERVICES]: produce((draft, { integrated_services }) => ({ ...draft, integrated_services }))
});
