import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
const initialState = {
    isLoading: false,
    infoMessage: "",
    errorMessage: "",
    valid_name: undefined,
    valid_path: undefined,
    schemas: undefined,
    disks: undefined,
    port_exists: undefined,
    path_exists: undefined,
    pg_version_exists: undefined,
    mongo_version_exists: undefined,
    mariadb_version_exists: undefined,
    mysql_version_exists: undefined,
    mariadb_user_exists: undefined,
    mysql_user_exists: undefined,
    oracle_version_exists: undefined,
    elasticsearch_version_exists: undefined,
    haproxy_exists: undefined,
    redis_version_exists: undefined,
    elasticsearch_index_size: undefined,
    mongo_db_size: undefined,
    mariadb_db_size: undefined,
    mysql_db_size: undefined,
    mssql_db_size: undefined,
    pg_user_exists: undefined,
    pg_db_size: undefined,
    pg_primary_status: null,
    haproxies: [],
    mariadb_cluster_status: null,
    mysql_cluster_status: null,
    mssql_cluster_status: null,
    mongo_cluster_status: null,
    elasticsearch_cluster_status: null,
    nodes: false,
    databases: undefined,
    flashbacks: undefined,
    pg_backups: undefined,
    pg_exports: undefined,
    pg_k8s_backups: undefined,
    pg_k8s_exports: undefined,
    elastic_backups: undefined,
    elastic_exports: undefined,
    mariadb_backups: undefined,
    mariadb_exports: undefined,
    mysql_backups: undefined,
    mysql_exports: undefined,
    mongo_backups: undefined,
    mongo_exports: undefined,
    mongo_k8s_backups: undefined,
    mongo_k8s_exports: undefined,
    mssql_backups: undefined,
    mssql_exports: undefined,
    redis_backups: undefined,
    free_ip: undefined,
    free_pod_ip: undefined,
    subnets: null,
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setInfoMessage: ["infoMessage"],
    setErrorMessage: ["errorMessage"],
    getNodes: null,
    getPgPrimaryStatus: ["id"],
    getMongoClusterStatus: ["id"],
    getElasticsearchClusterStatus: ["id"],
    getMariaDbClusterStatus: ["id"],
    getMySqlClusterStatus: ["id"],
    getMsSqlClusterStatus: ["id"],
    setPgPrimaryStatus: ["pg_primary_status"],
    setMongoClusterStatus: ["mongo_cluster_status"],
    setElasticsearchClusterStatus: ["elasticsearch_cluster_status"],
    setMariaDbClusterStatus: ["mariadb_cluster_status"],
    setMySqlClusterStatus: ["mysql_cluster_status"],
    setMsSqlClusterStatus: ["mssql_cluster_status"],
    setNodes: ["nodes"],
    setPgBackups: ["pg_backups"],
    setPgExports: ["pg_exports"],
    setPgK8sBackups: ["pg_k8s_backups"],
    setPgK8sExports: ["pg_k8s_exports"],
    setElasticBackups: ["elastic_backups"],
    setElasticExports: ["elastic_exports"],
    setMariaDbBackups: ["mariadb_backups"],
    setMariaDbExports: ["mariadb_exports"],
    setMySqlBackups: ["mysql_backups"],
    setMySqlExports: ["mysql_exports"],
    setMongoBackups: ["mongo_backups"],
    setMongoExports: ["mongo_exports"],
    setMongoK8sBackups: ["mongo_k8s_backups"],
    setMongoK8sExports: ["mongo_k8s_exports"],
    setMsSqlBackups: ["mssql_backups"],
    setMsSqlExports: ["mssql_exports"],
    setRedisBackups: ["redis_backups"],
    setFlashbacks: ["flasbacks"],
    refreshDbList: null,
    setDatabases: ["databases"],
    setHaProxies: ["haproxies"],
    addPdbNode: ["data", "callback"],
    addRedisNode: ["data", "callback"],
    addPgPrimary: ["data", "callback"],
    addPgPod: ["data", "callback"],
    addPgStandbyPod: ["data"],
    addMongoPod: ["data", "callback"],
    addRedisStandalone: ["data", "callback"],
    addRedisCluster: ["data", "callback"],
    addMongoShardedCluster: ["data", "callback"],
    removeRedisCluster: ["data", "callback"],
    dropMongoShardedCluster: ["data", "callback"],
    addElasticSearchMaster: ["data", "callback"],
    addMongoShardedClusterPrimary: ["data", "callback"],
    addMongoShardedClusterNode: ["data", "callback"],
    addPgStandby: ["data", "callback"],
    addHaProxy: ["data", "callback"],
    dropHaProxy: ["data", "callback"],
    addElasticsearchNode: ["data", "callback"],
    addMariaDbStandby: ["data", "callback"],
    addMySqlStandby: ["data", "callback"],
    addPgDatabase: ["data", "callback"],
    addMongoDatabase: ["data", "callback"],
    addElasticsearchIndex: ["data", "callback"],
    addMariaDbDatabase: ["data", "callback"],
    addMySqlDatabase: ["data", "callback"],
    addMsSqlDatabase: ["data", "callback"],
    copyPgDatabase: ["data", "callback"],
    copyMongoDatabase: ["data", "callback"],
    copyElasticsearchIndex: ["data", "callback"],
    copyMariaDbDatabase: ["data", "callback"],
    copyMySqlDatabase: ["data", "callback"],
    copyMsSqlDatabase: ["data", "callback"],
    checkPgDatabaseName: ["data"],
    checkMongoDatabaseName: ["data"],
    checkElasticsearchIndexName: ["data"],
    dropPgDatabase: ["data", "callback"],
    dropElasticsearchIndex: ["data", "callback"],
    dropMariaDbDatabase: ["data", "callback"],
    dropMongoDatabase: ["data", "callback"],
    dropMySqlDatabase: ["data", "callback"],
    dropMsSqlDatabase: ["data", "callback"],
    checkPgDatabaseSize: ["data"],
    setPgDatabaseSize: ["pg_db_size"],
    checkMongoDatabaseSize: ["data"],
    checkMariaDbDatabaseSize: ["data"],
    checkMySqlDatabaseSize: ["data"],
    checkMsSqlDatabaseSize: ["data"],
    setMongoDatabaseSize: ["mongo_db_size"],
    checkElasticsearchIndexSize: ["data"],
    setElasticsearchIndexSize: ["elasticsearch_index_size"],
    setMariaDbDatabaseSize: ["mariadb_db_size"],
    setMySqlDatabaseSize: ["mysql_db_size"],
    setMsSqlDatabaseSize: ["mssql_db_size"],
    addMongoMaster: ["data", "callback"],
    addMariaDbMaster: ["data", "callback"],
    addMySqlMaster: ["data", "callback"],
    addMsSqlMaster: ["data", "callback"],
    addMongoNode: ["data", "callback"],
    addCdbNode: ["data", "callback"],
    installCdbNode: ["data", "callback"],
    deletePDBNode: ["data", "callback"],
    deleteCDBNode: ["data", "callback"],
    openPDBNode: ["data", "callback"],
    checkPDBName: ["data"],
    checkPathName: ["data"],
    checkPathExists: ["data"],
    checkUserExists: ["data"],
    checkDumpExists: ["data"],
    checkDirExists: ["data"],
    checkPortExists: ["data"],
    checkPgDatabaseExists: ["data", "callback"],
    checkMongoDatabaseExists: ["data", "callback"],
    checkElasticsearchIndexExists: ["data", "callback"],
    checkMariaDbDatabaseExists: ["data", "callback"],
    checkMySqlDatabaseExists: ["data", "callback"],
    checkMsSqlDatabaseExists: ["data", "callback"],
    setPortExists: ["port_exists"],
    setPathExists: ["path_exists"],
    setHaProxyExists: ["haproxy_exists"],
    setPgVersionExists: ["pg_version_exists"],
    setMongoVersionExists: ["mongo_version_exists"],
    setMariaDbVersionExists: ["mariadb_version_exists"],
    setMySqlVersionExists: ["mysql_version_exists"],
    setElasticSearchVersionExists: ["elasticsearch_version_exists"],
    setRedisVersionExists: ["redis_version_exists"],
    setOracleVersionExists: ["oracle_version_exists"],
    checkHaProxyExists: ["data"],
    checkPgVersionExists: ["data"],
    checkMongoVersionExists: ["data"],
    checkMariaDbVersionExists: ["data"],
    checkMySqlVersionExists: ["data"],
    checkElasticSearchVersionExists: ["data"],
    checkRedisVersionExists: ["data"],
    checkOracleVersionExists: ["data"],
    checkPgUserExists: ["data"],
    checkMariaDbUserExists: ["data"],
    checkMySqlUserExists: ["data"],
    checkDiskSpace: ["data"],
    checkExportExists: ["data"],
    checkMariaDbDatabaseName: ["data"],
    checkMySqlDatabaseName: ["data"],
    checkMsSqlDatabaseName: ["data"],
    checkIfPgPrimary: ["pk", "callback"],
    setUserExists: ["user_exists"],
    setPgUserExists: ["pg_user_exists"],
    setDumpExists: ["dump_exists"],
    setDirExists: ["dir_exists"],
    setExportExists: ["export_exists"],
    setDiskSpace: ["disk_space"],
    renamePDB: ["data", "callback"],
    closePDBNode: ["data", "callback"],
    copyPDB: ["data", "callback"],
    restorePDB: ["data", "callback"],
    restoreFlashback: ["data", "callback"],
    restorePgDatabase: ["data", "callback"],
    restoreMariaDbDatabase: ["data", "callback"],
    restoreMySqlDatabase: ["data", "callback"],
    restoreMsSqlDatabase: ["data", "callback"],
    restoreMongoDatabase: ["data", "callback"],
    restoreElasticsearchIndex: ["data", "callback"],
    restorePgNode: ["data", "callback"],
    restoreMariaDbNode: ["data", "callback"],
    restoreMySqlNode: ["data", "callback"],
    restoreMsSqlNode: ["data", "callback"],
    restoreBackupMongoNode: ["data", "callback"],
    restoreRedisNode: ["data", "callback"],
    restoreElasticsearchCluster: ["data", "callback"],
    restoreDumpMongoNode: ["data", "callback"],
    backupPDB: ["data", "callback"],
    backupPgNode: ["data", "callback"],
    backupMongoNode: ["data", "callback"],
    snapshotElasticsearchCluster: ["data", "callback"],
    backupMariaDbNode: ["data", "callback"],
    backupMySqlNode: ["data", "callback"],
    backupMsSqlNode: ["data", "callback"],
    backupRedisNode: ["data", "callback"],
    importPgNode: ["data", "callback"],
    exportPgDatabase: ["data", "callback"],
    exportMariaDbDatabase: ["data", "callback"],
    exportMySqlDatabase: ["data", "callback"],
    exportMsSqlDatabase: ["data", "callback"],
    dumpMongoDatabase: ["data", "callback"],
    dumpElasticsearchIndex: ["data", "callback"],
    flashbackNode: ["data", "callback"],
    dropFlashback: ["data", "callback"],
    dropStandalone: ["data", "callback"],
    dropPgNode: ["data", "callback"],
    dropMariaDbNode: ["data", "callback"],
    dropMySqlNode: ["data", "callback"],
    dropMsSqlNode: ["data", "callback"],
    dropRedisNode: ["data", "callback"],
    dropMongoNode: ["data", "callback"],
    dropBackup: ["data", "callback"],
    dropExport: ["data", "callback"],
    checkConnection: ["data", "callback"],
    checkServiceConnection: ["data"],
    copyToCDB: ["data", "callback"],
    exportNode: ["data", "callback"],
    exportPgNode: ["data", "callback"],
    exportMySqlNode: ["data", "callback"],
    importMySqlNode: ["data", "callback"],
    exportMsSqlNode: ["data", "callback"],
    importMsSqlNode: ["data", "callback"],
    exportMariaDbNode: ["data", "callback"],
    importMariaDbNode: ["data", "callback"],
    dumpMongoNode: ["data", "callback"],
    importPDB: ["data", "callback"],
    changeClusterSize: ["data"],
    getDBFileDest: ["id"],
    setDBFileDest: ["db_file_dest"],
    setValidName: ["valid_name"],
    setValidPath: ["valid_path"],
    stopPgNode: ["data"],
    stopHaProxy: ["data"],
    stopMongoNode: ["data"],
    stopRedisNode: ["data"],
    stopElasticsearchNode: ["data"],
    stopMariaDbNode: ["data"],
    stopMySqlNode: ["data"],
    stopMsSqlNode: ["data"],
    switchPgNode: ["data", "callback"],
    clonePgStandby: ["data", "callback"],
    switchMySqlNode: ["data", "callback"],
    switchMariaDbNode: ["data", "callback"],
    switchRedisNode: ["data", "callback"],
    switchElasticsearchNode: ["data", "callback"],
    stepDownMongoNode: ["data", "callback"],
    removePgSchedule: ["data", "callback"],
    removeMongoSchedule: ["data", "callback"],
    removeElasticsearchSchedule: ["data", "callback"],
    removeRedisSchedule: ["data", "callback"],
    removeMariaDbSchedule: ["data", "callback"],
    removeMySqlSchedule: ["data", "callback"],
    removeOracleSchedule: ["data", "callback"],
    togglePgCluster: ["data"],
    startPgNode: ["data"],
    startHaProxy: ["data"],
    startMariaDbNode: ["data"],
    startMySqlNode: ["data"],
    startMsSqlNode: ["data"],
    startMongoNode: ["data"],
    startRedisNode: ["data"],
    startElasticsearchNode: ["data"],
    getOracleHome: ["data"],
    setOracleHome: ["oracle_home"],
    setMariaDbUserExists: ["mariadb_user_exists"],
    setMySqlUserExists: ["mysql_user_exists"],
    dropElasticsearchNode: ["data", "callback"],
    fetchSchemas: ["data"],
    fetchDisks: ["data"],
    setSchemas: ["schemas"],
    setDisks: ["disks"],
    getOracleStandalones: null,
    setOracleStandalones: ["standalones"],
    setRedisStandalones: ["redis_standalones"],
    importStandalone: ["data", "callback"],
    duplicateOracleStandalone: ["data", "callback"],
    checkPDBCredentials: ["data"],
    updatePDBCredentials: ["data", "callback"],
    getMaxPDB: ["data"],
    setMaxPDB: ["max_pdbs"],
    backupCDB: ["data", "callback"],
    importCDB: ["data", "callback"],
    isQuotaExceed: ["data"],
    isNodeHostReachable: ["data", "callback"],
    markNodeDeleted: ["data", "callback"],
    verifyBackup: ["data", "callback"],
    checkInventoryExists: ["data", "callback"],
    refreshContainer: ["id"],
    setNodeField: ["index", "field", "value"],
    checkRedisClusterHealth: ["data", "callback"],
    checkSentinelMasterName: ["data"],
    sentinelMonitorMaster: ["data", "callback"],
    sentinelRemoveMonitor: ["data", "callback"],
    sentinelFailover: ["data", "callback"],
    dropPgPublication: ["data"],
    togglePgSubscription: ["data"],
    upgradePgNode: ["data", "callback"],
    upgradeMongoNode: ["data", "callback"],
    upgradeMySqlNode: ["data", "callback"],
    upgradeMariaDbNode: ["data", "callback"],
    upgradeElasticsearchNode: ["data", "callback"],
    checkFreeIp: ["data"],
    checkFreePodIp: ["data", "callback"],
    setFreeIp: ["free_ip"],
    setFreePodIp: ["free_pod_ip"],
    getSubnets: ["data"],
    setSubnets: ["subnets"],
    dropCluster: ["data", "callback"],
}, { prefix: 'LAYOUT/' });
export const LayoutActionTypes = Types;
export const LayoutActions = Creators;
export const layoutReducer = createReducer(initialState, {
    [LayoutActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [LayoutActionTypes.SET_INFO_MESSAGE]: produce((draft, { infoMessage }) => ({ ...draft, infoMessage })),
    [LayoutActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [LayoutActionTypes.SET_NODES]: produce((draft, { nodes }) => ({ ...draft, nodes })),
    [LayoutActionTypes.SET_SUBNETS]: produce((draft, { subnets }) => ({ ...draft, subnets })),
    [LayoutActionTypes.SET_NODE_FIELD]: produce((draft, { index, field, value }) => {
        if (draft?.nodes?.[index]) {
          draft.nodes[index][field] = value;
        }
        return draft;
      }),
    [LayoutActionTypes.SET_PG_BACKUPS]: produce((draft, { pg_backups }) => ({ ...draft, pg_backups })),
    [LayoutActionTypes.SET_PG_EXPORTS]: produce((draft, { pg_exports }) => ({ ...draft, pg_exports })),
    [LayoutActionTypes.SET_PG_K8S_BACKUPS]: produce((draft, { pg_k8s_backups }) => ({ ...draft, pg_k8s_backups })),
    [LayoutActionTypes.SET_PG_K8S_EXPORTS]: produce((draft, { pg_k8s_exports }) => ({ ...draft, pg_k8s_exports })),
    [LayoutActionTypes.SET_MARIA_DB_BACKUPS]: produce((draft, { mariadb_backups }) => ({ ...draft, mariadb_backups })),
    [LayoutActionTypes.SET_MARIA_DB_EXPORTS]: produce((draft, { mariadb_exports }) => ({ ...draft, mariadb_exports })),
    [LayoutActionTypes.SET_MY_SQL_BACKUPS]: produce((draft, { mysql_backups }) => ({ ...draft, mysql_backups })),
    [LayoutActionTypes.SET_MY_SQL_EXPORTS]: produce((draft, { mysql_exports }) => ({ ...draft, mysql_exports })),
    [LayoutActionTypes.SET_MS_SQL_BACKUPS]: produce((draft, { mssql_backups }) => ({ ...draft, mssql_backups })),
    [LayoutActionTypes.SET_MS_SQL_EXPORTS]: produce((draft, { mssql_exports }) => ({ ...draft, mssql_exports })),
    [LayoutActionTypes.SET_MONGO_BACKUPS]: produce((draft, { mongo_backups }) => ({ ...draft, mongo_backups })),
    [LayoutActionTypes.SET_MONGO_EXPORTS]: produce((draft, { mongo_exports }) => ({ ...draft, mongo_exports })),
    [LayoutActionTypes.SET_MONGO_K8S_BACKUPS]: produce((draft, { mongo_k8s_backups }) => ({ ...draft, mongo_k8s_backups })),
    [LayoutActionTypes.SET_MONGO_K8S_EXPORTS]: produce((draft, { mongo_k8s_exports }) => ({ ...draft, mongo_k8s_exports })),
    [LayoutActionTypes.SET_ELASTIC_BACKUPS]: produce((draft, { elastic_backups }) => ({ ...draft, elastic_backups })),
    [LayoutActionTypes.SET_ELASTIC_EXPORTS]: produce((draft, { elastic_exports }) => ({ ...draft, elastic_exports })),
    [LayoutActionTypes.SET_REDIS_BACKUPS]: produce((draft, { redis_backups }) => ({ ...draft, redis_backups })),
    [LayoutActionTypes.SET_DB_FILE_DEST]: produce((draft, { db_file_dest }) => ({ ...draft, db_file_dest })),
    [LayoutActionTypes.SET_ORACLE_HOME]: produce((draft, { oracle_home }) => ({ ...draft, oracle_home })),
    [LayoutActionTypes.SET_VALID_NAME]: produce((draft, { valid_name }) => ({ ...draft, valid_name })),
    [LayoutActionTypes.SET_SCHEMAS]: produce((draft, { schemas }) => ({ ...draft, schemas })),
    [LayoutActionTypes.SET_DISKS]: produce((draft, { disks }) => ({ ...draft, disks })),
    [LayoutActionTypes.SET_ORACLE_STANDALONES]: produce((draft, { standalones }) => ({ ...draft, standalones })),
    [LayoutActionTypes.SET_REDIS_STANDALONES]: produce((draft, { redis_standalones }) => ({ ...draft, redis_standalones })),
    [LayoutActionTypes.SET_VALID_PATH]: produce((draft, { valid_path }) => ({ ...draft, valid_path })),
    [LayoutActionTypes.SET_USER_EXISTS]: produce((draft, { user_exists }) => ({ ...draft, user_exists })),
    [LayoutActionTypes.SET_DUMP_EXISTS]: produce((draft, { dump_exists }) => ({ ...draft, dump_exists })),
    [LayoutActionTypes.SET_DIR_EXISTS]: produce((draft, { dir_exists }) => ({ ...draft, dir_exists })),
    [LayoutActionTypes.SET_EXPORT_EXISTS]: produce((draft, { export_exists }) => ({ ...draft, export_exists })),
    [LayoutActionTypes.SET_DISK_SPACE]: produce((draft, { disk_space }) => ({ ...draft, disk_space })),
    [LayoutActionTypes.SET_MAX_PDB]: produce((draft, { max_pdbs }) => ({ ...draft, max_pdbs })),
    [LayoutActionTypes.SET_PORT_EXISTS]: produce((draft, { port_exists }) => ({ ...draft, port_exists })),
    [LayoutActionTypes.SET_PATH_EXISTS]: produce((draft, { path_exists }) => ({ ...draft, path_exists })),
    [LayoutActionTypes.SET_HA_PROXY_EXISTS]: produce((draft, { haproxy_exists }) => ({ ...draft, haproxy_exists })),
    [LayoutActionTypes.SET_PG_VERSION_EXISTS]: produce((draft, { pg_version_exists }) => ({ ...draft, pg_version_exists })),
    [LayoutActionTypes.SET_MONGO_VERSION_EXISTS]: produce((draft, { mongo_version_exists }) => ({ ...draft, mongo_version_exists })),
    [LayoutActionTypes.SET_REDIS_VERSION_EXISTS]: produce((draft, { redis_version_exists }) => ({ ...draft, redis_version_exists })),
    [LayoutActionTypes.SET_ORACLE_VERSION_EXISTS]: produce((draft, { oracle_version_exists }) => ({ ...draft, oracle_version_exists })),
    [LayoutActionTypes.SET_MARIA_DB_VERSION_EXISTS]: produce((draft, { mariadb_version_exists }) => ({ ...draft, mariadb_version_exists })),
    [LayoutActionTypes.SET_MY_SQL_VERSION_EXISTS]: produce((draft, { mysql_version_exists }) => ({ ...draft, mysql_version_exists })),
    [LayoutActionTypes.SET_ELASTIC_SEARCH_VERSION_EXISTS]: produce((draft, { elasticsearch_version_exists }) => ({ ...draft, elasticsearch_version_exists })),
    [LayoutActionTypes.SET_PG_USER_EXISTS]: produce((draft, { pg_user_exists }) => ({ ...draft, pg_user_exists })),
    [LayoutActionTypes.SET_PG_DATABASE_SIZE]: produce((draft, { pg_db_size }) => ({ ...draft, pg_db_size })),
    [LayoutActionTypes.SET_MARIA_DB_DATABASE_SIZE]: produce((draft, { mariadb_db_size }) => ({ ...draft, mariadb_db_size })),
    [LayoutActionTypes.SET_MY_SQL_DATABASE_SIZE]: produce((draft, { mysql_db_size }) => ({ ...draft, mysql_db_size })),
    [LayoutActionTypes.SET_MS_SQL_DATABASE_SIZE]: produce((draft, { mssql_db_size }) => ({ ...draft, mssql_db_size })),
    [LayoutActionTypes.SET_MONGO_DATABASE_SIZE]: produce((draft, { mongo_db_size }) => ({ ...draft, mongo_db_size })),
    [LayoutActionTypes.SET_ELASTICSEARCH_INDEX_SIZE]: produce((draft, { elasticsearch_index_size }) => ({ ...draft, elasticsearch_index_size })),
    [LayoutActionTypes.SET_DATABASES]: produce((draft, { databases }) => ({ ...draft, databases })),
    [LayoutActionTypes.SET_FLASHBACKS]: produce((draft, { flashbacks}) => ({ ...draft, flashbacks })),
    [LayoutActionTypes.SET_HA_PROXIES]: produce((draft, { haproxies }) => ({ ...draft, haproxies })),
    [LayoutActionTypes.SET_PG_PRIMARY_STATUS]: produce((draft, { pg_primary_status }) => ({ ...draft, pg_primary_status })),
    [LayoutActionTypes.SET_MARIA_DB_CLUSTER_STATUS]: produce((draft, { mariadb_cluster_status }) => ({ ...draft, mariadb_cluster_status })),
    [LayoutActionTypes.SET_MY_SQL_CLUSTER_STATUS]: produce((draft, { mysql_cluster_status }) => ({ ...draft, mysql_cluster_status })),
    [LayoutActionTypes.SET_MS_SQL_CLUSTER_STATUS]: produce((draft, { mssql_cluster_status }) => ({ ...draft, mssql_cluster_status })),
    [LayoutActionTypes.SET_MARIA_DB_USER_EXISTS]: produce((draft, { mariadb_user_exists }) => ({ ...draft, mariadb_user_exists })),
    [LayoutActionTypes.SET_MY_SQL_USER_EXISTS]: produce((draft, { mysql_user_exists }) => ({ ...draft, mysql_user_exists })),
    [LayoutActionTypes.SET_ELASTICSEARCH_CLUSTER_STATUS]: produce((draft, { elasticsearch_cluster_status }) => ({ ...draft, elasticsearch_cluster_status })),
    [LayoutActionTypes.SET_MONGO_CLUSTER_STATUS]: produce((draft, { mongo_cluster_status }) => ({ ...draft, mongo_cluster_status })),
    [LayoutActionTypes.SET_FREE_IP]: produce((draft, { free_ip}) => ({ ...draft, free_ip })),
    [LayoutActionTypes.SET_FREE_POD_IP]: produce((draft, { free_pod_ip}) => ({ ...draft, free_pod_ip })),
});
