import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
const initialState = {
    isLoading: false,
    errorMessage: "",
    logs: undefined,
    node_logs: undefined,
    node_log_files: []
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setErrorMessage: ["errorMessage"],
    getLogs: ["data"],
    getLogsPerNode: ["data"],
    getTimelineData: null,
    setTimelineData: ["timeline_data"],
    getStepLogs: ["id"],
    setStepLogs: ["stepLogs"],
    setLogs: ["logs"],
    setNodeLogs: ["node_logs"],
    setNodeLogFiles: ["node_log_files"],
    getNodeLogFiles: ["data"],
}, { prefix: 'LOG/' });
export const LogActionTypes = Types;
export const LogActions = Creators;
export const logReducer = createReducer(initialState, {
    [LogActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [LogActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [LogActionTypes.SET_LOGS]: produce((draft, { logs }) => ({ ...draft, logs })),
    [LogActionTypes.SET_STEP_LOGS]: produce((draft, { stepLogs }) => ({ ...draft, stepLogs })),
    [LogActionTypes.SET_TIMELINE_DATA]: produce((draft, { timeline_data }) => ({ ...draft, timeline_data})),
    [LogActionTypes.SET_NODE_LOGS]: produce((draft, { node_logs }) => ({ ...draft, node_logs })),
    [LogActionTypes.SET_NODE_LOG_FILES]: produce((draft, { node_log_files }) => ({ ...draft, node_log_files })),
});
