import { combineReducers } from "redux";
import { persistReducer } from "redux-persist";
import { appReducer } from "./app/reducer";
import { statusReducer } from "./status/reducer";
import { logReducer } from "./log/reducer";
import { configReducer } from "./config/reducer";
import { settingsReducer } from "./settings/reducer";
import {clusterUpdateReducer} from "./clusterUpdate/reducer"
import storage from "redux-persist/lib/storage";
import { signUpReducer } from "./signup/reducer";
import { userUpdateReducer } from "./userUpdate/reducer";
import { toastReducer } from "./toasts/reducer";
import { layoutReducer} from "./layout/reducer";
import {monitoringReducer} from "./monitoring/reducer";
import { taskNotificationReducer} from "./taskNotifications/reducer"
import { downloadReducer } from "./downloadFile/reducer";
export const rootReducer = combineReducers({
    app: persistReducer({
        key: "app",
        storage,
        whitelist: ["refreshToken", "accessToken", "user", "severity", "db_type", "time_period", "_search", "timeline", "grouping", "username", "password", "org_name"]
    }, appReducer),
    status: statusReducer,
    log: logReducer,
    config: configReducer,
    settings: settingsReducer,
    clusUp: clusterUpdateReducer,
    signUp: signUpReducer,
    userUpdate: userUpdateReducer,
    toasts: toastReducer,
    layout: layoutReducer,
    download: downloadReducer,
    monitoring:  persistReducer({
        key: "monitoring",
        storage,
        whitelist: ["messages"]
    }, monitoringReducer),
    taskNotifications: persistReducer({
        key: "taskNotifications",
        storage,
        whitelist: ["notifications"]
    }, taskNotificationReducer),
});
