import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
const initialState = {
    isLoading: false,
    errorMessage: "",
    settings: false
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setErrorMessage: ["errorMessage"],
    getSystemSettings: null,
    updateSystemSettings: ["data"],
    setSettings: ['settings'],
}, { prefix: 'SETTINGS/' });
export const SettingsActionTypes = Types;
export const SettingsActions = Creators;
export const settingsReducer = createReducer(initialState, {
    [SettingsActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [SettingsActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [SettingsActionTypes.SET_SETTINGS]: produce((draft, { settings }) => ({ ...draft, settings })),
});
