import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
import config from "../../config";
const initialState = {
    isLoading: false,
    errorMessage: "",
    infoMessage: "",
    data: config.formDefaults,
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setErrorMessage: ["errorMessage"],
    setInfoMessage: ["infoMessage"],
    validateEmail: ["data", "callback"],
    requestDemo: ["data", "callback"],
    setData: ["data"],
    signUp: ["data", "callback"]
}, { prefix: 'SIGNUP/' });
export const SignupActionTypes = Types;
export const SignupActions = Creators;
export const signUpReducer = createReducer(initialState, {
    [SignupActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [SignupActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [SignupActionTypes.SET_INFO_MESSAGE]: produce((draft, { infoMessage }) => ({ ...draft, infoMessage })),
    [SignupActionTypes.SET_DATA]: produce((draft, { data }) => ({ ...draft, data }))
});