import { call, put, select } from "redux-saga/effects";
import { StatusActions } from "../../reducer";
import { LayoutActions } from "../../../layout/reducer";
import apiHAProxy from "../../../../services/balancers/haproxy/api";
function* getHAProxyDetails({id}) {
    try {
        yield put(StatusActions.setLoading(true));
        const { accessToken } = yield select(state => state.app);
        
        let haproxy_details = yield call(apiHAProxy.getHAProxyDetails, accessToken, id);
        if(haproxy_details?.status >= 400)
        {
            yield put(StatusActions.setLoading(false));
            if(haproxy_details?.data)
            {
                 //api exception
             if(haproxy_details?.data?.detail) 
             {
 
                 yield put(StatusActions.setErrorMessage(haproxy_details.data.detail));
 
             }
             else //probably verbose, so need all data
             {
 
                 yield put(StatusActions.setErrorMessage(haproxy_details.data));
 
 
                 
             }
            
             yield put(StatusActions.setHaProxyDetails(haproxy_details.data));
            }
        }
        else
        {
            yield put(StatusActions.setHaProxyDetails(haproxy_details));
            yield put(StatusActions.setErrorMessage(""));
            yield put(StatusActions.setLoading(false));
        }
    }
    catch (e) {
        yield put(StatusActions.setLoading(false));
        yield put(LayoutActions.setErrorMessage(e.message));
    }
}
const sagasHAProxy = 
{
    getHAProxyDetails,
}
export default sagasHAProxy;