import { call, put, select } from "redux-saga/effects";
import { StatusActions } from "../reducer";
import { LayoutActions } from "../../layout/reducer";
import apiElasticSearch from "../../../services/elasticsearch/api";
function* getElasticSearchDetails({id}) {
    try {
        yield put(StatusActions.setLoading(true));
        const { accessToken } = yield select(state => state.app);
        
        let elasticsearch_details = yield call(apiElasticSearch.getElasticSearchDetails, accessToken, id);
        if(elasticsearch_details?.status >= 400)
        {
            yield put(StatusActions.setLoading(false));
            
            if(elasticsearch_details?.data)
            {
                 //api exception
             if(elasticsearch_details?.data?.detail) 
             {
 
                 yield put(StatusActions.setErrorMessage(elasticsearch_details.data.detail));
 
             }
             else //probably verbose, so need all data
             {
 
                 yield put(StatusActions.setErrorMessage(elasticsearch_details.data));
 
 
                 
             }
             yield put(StatusActions.setElasticsearchDetails(elasticsearch_details.data));
            }
        }
        else
        {
            yield put(StatusActions.setElasticsearchDetails(elasticsearch_details));
            yield put(StatusActions.setErrorMessage(""));
            yield put(StatusActions.setLoading(false));
        }
    }
    catch (e) {
        yield put(StatusActions.setLoading(false));
        yield put(LayoutActions.setErrorMessage(e.message));
    }
}
const sagasElasticSearch = 
{
    getElasticSearchDetails,
}
export default sagasElasticSearch;