import { call, put, select } from "redux-saga/effects";
import { StatusActions } from "../reducer";
import { LayoutActions } from "../../layout/reducer";
import apiMariaDB from "../../../services/mariadb/api";
function* getMariaDBDetails({id}) {
    try {
        yield put(StatusActions.setLoading(true));
        const { accessToken } = yield select(state => state.app);
        
        let mariadb_details = yield call(apiMariaDB.getMariaDBDetails, accessToken, id);
        if(mariadb_details?.status >= 400)
        {
            yield put(StatusActions.setLoading(false));
            if(mariadb_details?.data)
            {
                 //api exception
             if(mariadb_details?.data?.detail) 
             {
 
                 yield put(StatusActions.setErrorMessage(mariadb_details.data.detail));
 
             }
             else //probably verbose, so need all data
             {
 
                 yield put(StatusActions.setErrorMessage(mariadb_details.data));
 
 
                 
             }
             yield put(StatusActions.setMariaDbDetails(mariadb_details.data));
            }
        }
        else
        {
            yield put(StatusActions.setMariaDbDetails(mariadb_details));
            yield put(StatusActions.setErrorMessage(""));
            yield put(StatusActions.setLoading(false));
        }
    }
    catch (e) {
        yield put(StatusActions.setLoading(false));
        yield put(LayoutActions.setErrorMessage(e.message));
    }
}
const sagasMariaDB = 
{
    getMariaDBDetails,
}
export default sagasMariaDB;