import { call, put, select } from "redux-saga/effects";
import { StatusActions } from "../reducer";
import { LayoutActions } from "../../layout/reducer";
import apiMongo from "../../../services/mongo/api";
function* getMongoDetails({id}) {
    try {
        yield put(StatusActions.setLoading(true));
        const { accessToken } = yield select(state => state.app);
        
        let mongo_details = yield call(apiMongo.getMongoDetails, accessToken, id);
        if(mongo_details?.status >= 400)
        {
            yield put(StatusActions.setLoading(false));
            if(mongo_details?.data)
            {
                 //api exception
             if(mongo_details?.data?.detail) 
             {
 
                 yield put(StatusActions.setErrorMessage(mongo_details.data.detail));
 
             }
             else //probably verbose, so need all data
             {
 
                 yield put(StatusActions.setErrorMessage(mongo_details.data));
 
 
                 
             }
             yield put(StatusActions.setMongoDetails(mongo_details.data));
            }
        }
        else
        {
            yield put(StatusActions.setMongoDetails(mongo_details));
            yield put(StatusActions.setErrorMessage(""));
            yield put(StatusActions.setLoading(false));
        }
    }
    catch (e) {
        yield put(StatusActions.setLoading(false));
        yield put(LayoutActions.setErrorMessage(e.message));
    }
}
const sagasMongo = 
{
    getMongoDetails,
}
export default sagasMongo;