import { call, put, select } from "redux-saga/effects";
import { StatusActions } from "../reducer";
import { LayoutActions } from "../../layout/reducer";
import apiMsSQL from "../../../services/mssql/api";
function* getMsSQLDetails({id}) {
    try {
        yield put(StatusActions.setLoading(true));
        const { accessToken } = yield select(state => state.app);
        
        let mssql_details = yield call(apiMsSQL.getMsSQLDetails, accessToken, id);
        if(mssql_details?.status >= 400)
        {
            yield put(StatusActions.setLoading(false));
            if(mssql_details?.data)
            {
                 //api exception
             if(mssql_details?.data?.detail) 
             {
 
                 yield put(StatusActions.setErrorMessage(mssql_details.data.detail));
 
             }
             else //probably verbose, so need all data
             {
 
                 yield put(StatusActions.setErrorMessage(mssql_details.data));
 
 
                 
             }
             yield put(StatusActions.setMsSqlDetails(mssql_details.data));
            }
        }
        else
        {
            yield put(StatusActions.setMsSqlDetails(mssql_details));
            yield put(StatusActions.setErrorMessage(""));
            yield put(StatusActions.setLoading(false));
        }
    }
    catch (e) {
        yield put(StatusActions.setLoading(false));
        yield put(LayoutActions.setErrorMessage(e.message));
    }
}
const sagasMsSQL = 
{
    getMsSQLDetails,
}
export default sagasMsSQL;