import { call, put, select } from "redux-saga/effects";
import { StatusActions } from "../reducer";
import { LayoutActions } from "../../layout/reducer";
import apiRedis from "../../../services/redis/api";
function* getRedisDetails({id}) {
    try {
        yield put(StatusActions.setLoading(true));
        const { accessToken } = yield select(state => state.app);
        
        let redis_details = yield call(apiRedis.getRedisDetails, accessToken, id);
        if(redis_details?.status >= 400)
        {
            yield put(StatusActions.setLoading(false));
            if(redis_details?.data)
            {
                 //api exception
             if(redis_details?.data?.detail) 
             {
 
                 yield put(StatusActions.setErrorMessage(redis_details.data.detail));
 
             }
             else //probably verbose, so need all data
             {
 
                 yield put(StatusActions.setErrorMessage(redis_details.data));
 
 
                 
             }
             yield put(StatusActions.setRedisDetails(redis_details.data));
            }
        }
        else
        {
            yield put(StatusActions.setRedisDetails(redis_details));
            yield put(StatusActions.setErrorMessage(""));
            yield put(StatusActions.setLoading(false));
        }
    }
    catch (e) {
        yield put(StatusActions.setLoading(false));
        yield put(LayoutActions.setErrorMessage(e.message));
    }
}
const sagasRedis = 
{
    getRedisDetails,
}
export default sagasRedis;