import { configureStore} from '@reduxjs/toolkit'
import createSagaMiddleware from "redux-saga";
import { rootReducer } from "./rootReducer";
import sagas from "./sagas";
import {
    persistStore,
    FLUSH,
    REHYDRATE,
    PAUSE,
    PERSIST,
    PURGE,
    REGISTER,
  } from 'redux-persist'
const sagaMiddleware = createSagaMiddleware();
export const store = configureStore({ devTools: true, reducer: rootReducer, middleware: (getDefaultMiddleware) => getDefaultMiddleware({ thunk: false,  serializableCheck: {
        ignoredActions: [FLUSH, REHYDRATE, PAUSE, PERSIST, PURGE, REGISTER],
        ignoredActionPaths: ['payload.callback', 'callback']
      }
  },).concat(sagaMiddleware) })
export const persistor = persistStore(store);
sagaMiddleware.run(sagas);