import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
const initialState = {
    isLoading: false,
    errorMessage: "",
    notifications: null
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setErrorMessage: ["errorMessage"],
    getNotifications: null,
    setNotifications: ["notifications"],
    isRunningCompleted: ["data"]
}, { prefix: 'NOTIFICATION/' });
export const TaskNotificationActionTypes = Types;
export const TaskNotificationActions = Creators;
export const taskNotificationReducer = createReducer(initialState, {
    [TaskNotificationActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [TaskNotificationActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [TaskNotificationActionTypes.SET_NOTIFICATIONS]: produce((draft, { notifications }) => ({ ...draft, notifications}))
});
