import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
const initialState = {
    isLoading: false,
    errorMessage: "",
    toasts: null
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setErrorMessage: ["errorMessage"],
    getToasts: null,
    setToasts: ["toasts"]
}, { prefix: 'TOAST/' });
export const ToastsActionTypes = Types;
export const ToastsActions = Creators;
export const toastReducer = createReducer(initialState, {
    [ToastsActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [ToastsActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [ToastsActionTypes.SET_TOASTS]: produce((draft, { toasts }) => ({ ...draft, toasts}))
});
