import { call, put, takeLeading, select } from "redux-saga/effects";
import { ToastsActions, ToastsActionTypes } from "./reducer";
import api from "../../services/api";
function* getToasts() {
    try {
        yield put(ToastsActions.setToasts (null));
        yield put(ToastsActions.setLoading(true));
        const { accessToken } = yield select(state => state.app);
        
        let toasts = yield call(api.getToasts, accessToken);
        
        yield put(ToastsActions.setToasts(toasts));
        yield put(ToastsActions.setErrorMessage(""));
        yield put(ToastsActions.setLoading(false));
    }
    catch (e) {
        yield put(ToastsActions.setLoading(false));
    }
}
const sagas = [
    takeLeading(ToastsActionTypes.GET_TOASTS, getToasts)
];
export default sagas;