import {produce} from "immer";
import { createActions, createReducer } from "reduxsauce";
import config from "../../config";
const initialState = {
    isLoading: false,
    errorMessage: "",
    infoMessage: "",
    id: false,
    data: config.formDefaults,
    initial: false
};
const { Types, Creators } = createActions({
    setLoading: ["isLoading"],
    setErrorMessage: ["errorMessage"],
    userUpdate: ["payload"],
    userDelete: ["id", "callback"],
    setData: ["data"],
    setInfoMessage: ["infoMessage"],
    setInitial: ["initial"],
}, { prefix: 'USRUP/' });
export const UserUpdateActionTypes = Types;
export const UserUpdateActions = Creators;
export const userUpdateReducer = createReducer(initialState, {
    [UserUpdateActionTypes.SET_LOADING]: produce((draft, { isLoading }) => ({ ...draft, isLoading })),
    [UserUpdateActionTypes.SET_ERROR_MESSAGE]: produce((draft, { errorMessage }) => ({ ...draft, errorMessage })),
    [UserUpdateActionTypes.SET_INFO_MESSAGE]: produce((draft, { infoMessage }) => ({ ...draft, infoMessage })),
    [UserUpdateActionTypes.SET_DATA]: produce((draft, { data }) => ({ ...draft, data})),
    [UserUpdateActionTypes.SET_INITIAL]: produce((draft, { initial }) => ({ ...draft, initial}))
    
});