
// const copyToClipboard = (copyText) => {
//   let message = "REST api command was copied to clipboard.";
    
//   navigator.clipboard.writeText(copyText)
//       .catch(() => {
//         message = "Error copying to clipboard.";
//       });
//       return message;
//   };
const copyToClipBoardUniversal = (copyText) => {
  // navigator clipboard api needs a secure context (https)
  if (navigator.clipboard && window.isSecureContext) {
      // navigator clipboard api method'
      return navigator.clipboard.writeText(copyText);
  } else {
      // text area method
      let textArea = window.document.createElement("textarea");
      textArea.value = copyText;
      // make the textarea out of viewport
      textArea.style.position = "fixed";
      textArea.style.left = "-999999px";
      textArea.style.top = "-999999px";
      window.document.body.appendChild(textArea);
      textArea.focus();
      textArea.select();
      return new Promise((res, rej) => {
          // here the magic happens
          window.document.execCommand('copy') ? res() : rej();
          textArea.remove();
      });
  }
}

const copyToClipboard = async (copyText) => await copyToClipBoardUniversal(copyText)
.then(() => "REST api command was copied to clipboard.")
.catch(() => "error copying to clipboard");
export default copyToClipboard;
