import config, { types } from "../config";
function createAPIcommand(data, accessToken, endpoint) {
  const headers = [
    `-H "Authorization: Bearer ${accessToken}"`,
    `-H "Content-Type: application/json"`,
    `-H "Accept: application/json"`,
  ];
  data["rest_api"] = true;
  const app =  data?.type === types.K8S ? 'kubernetes' : 'cluster_core'
  const escapedData = JSON.stringify(data)
    .replace(/"/g, '\\"')
    .replace(/'/g, "\\'");
  const api_command = `curl -v ${headers.join(" ")} -d "${escapedData}" ${config.apiUrl}/${app}/api/${endpoint}`;
  return api_command;
}
  export default createAPIcommand;