import { toast, cssTransition } from 'react-toastify-modernize';
import "../assets/css/custom.css"


const SlideLeftTransition = cssTransition({
    enter: 'slide-left-enter',
    exit: 'slide-left-exit',
    duration: 1000, // Duration in milliseconds
  });
const autoClose = 10000;
const error = (text) =>
{
    if(!toast.isActive(text))
    {
        toast.error(text, {
            position: toast.POSITION.TOP_RIGHT,
            theme: "colored",
            role: "error",
            pauseOnFocusLoss: false,
            toastId: text,
            transition: SlideLeftTransition,
            autoClose: autoClose,
        });
    }
}
const warning = (text) => 
{
    if(!toast.isActive(text))
    {
        toast.warn(text, {
            position: toast.POSITION.TOP_RIGHT,
            theme: "colored",
            role: "warning",
            pauseOnFocusLoss: false,
            toastId: text,
            transition: SlideLeftTransition,
            autoClose: autoClose,
        });
    }
}
const info = (text) => {
    if(!toast.isActive(text))
    {
        toast.info(text, {
            position: toast.POSITION.TOP_RIGHT,
            theme: "colored",
            role: "info",
            pauseOnFocusLoss: false,
            toastId: text,
            transition: SlideLeftTransition,
            autoClose: autoClose,
        });
    }
 
}
const detailed = (template, status, id) => {
    let type;
    switch (status) {
        case "red":
            type = toast.TYPE.ERROR;
            break;
        case "green":
            type = toast.TYPE.SUCCESS;
            break;
        case "yellow":
            type = toast.TYPE.WARNING;
            break;
        default:
            type = toast.TYPE.INFO;
            break;
    }
    if(!toast.isActive(id))
    {
        toast(template, {
            position: toast.POSITION.TOP_RIGHT,
            theme: "colored",
            role: "detailed",
            transition: SlideLeftTransition,
            pauseOnFocusLoss: false,
            type: type,
            toastId: id,
            autoClose: autoClose,
        });
    }
}
const success = (text) => 
{
  
    if(!toast.isActive(text))
    {
        toast.success(text, {
            position: toast.POSITION.TOP_RIGHT,
            theme: "colored",
            role: "success",
            pauseOnFocusLoss: false,
            transition: SlideLeftTransition,
            toastId: text,
            autoClose: autoClose,
        });
        
    }
}
const alert = (text) =>
{
    if(!toast.isActive(text))
    {
        toast(text, {
            position: toast.POSITION.TOP_RIGHT,
            theme: "colored",
            pauseOnFocusLoss: false,
            transition: SlideLeftTransition,
            transitionDuration: 1000,
            toastId: text,
            autoClose: autoClose,
        });
    }
}
const notify = {
    error,
    warning,
    info,
    success,
    alert,
    detailed,
};
export default notify;
