import { Divider } from "primereact/divider";
export const passwordChecks = {
    minLength: (password) => password && password.length >= 8,
    hasLowerCase: (password) => password && /[a-z]/.test(password),
    hasUpperCase: (password) => password && /[A-Z]/.test(password),
    hasDigit: (password) => password && /\d/.test(password),
    hasSpecialChar: (password) => password && /[^\w\s]/.test(password),
  };


  export const footer = (password, useSpecial) => (
      <div>
          <Divider />
          <p className="mt-2">Suggestions</p>
          <ul className="pl-2 ml-2 mt-0" style={{ lineHeight: '1.5' }}>
              <li className={passwordChecks.hasLowerCase(password) ? '' : 'p-error'} >At least one lowercase</li>
              <li className={passwordChecks.hasUpperCase(password) ? '' : 'p-error'}> At least one uppercase</li>
              <li className={passwordChecks.hasDigit(password) ? '' : 'p-error'}>At least one numeric</li>
              {useSpecial ? <li className={passwordChecks.hasSpecialChar(password) ? '' : 'p-error'}>At least one special character</li>  : null}
              <li className={passwordChecks.minLength(password) ? '' : 'p-error'}>Minimum 8 characters</li>
          </ul>
      </div>
  );
