--
-- PostgreSQL database dump
--

-- Dumped from database version 15.7 (Ubuntu 15.7-1.pgdg20.04+1)
-- Dumped by pg_dump version 17.2

-- Started on 2025-04-02 14:35:52

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET transaction_timeout = 0;
SET client_encoding = 'SQL_ASCII';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- TOC entry 7 (class 2615 OID 16949)
-- Name: app_123monitor; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA app_123monitor;


--
-- TOC entry 513 (class 1255 OID 16950)
-- Name: analyze_monitor_result_raw(uuid); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.analyze_monitor_result_raw(in_task_run_id uuid) RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
mon_def app_123monitor.rp_monitors%rowtype;
org_def organization%rowtype;
mon_raw RECORD;
task_run_data RECORD;
task_run_log RECORD;
ad RECORD;
v_curs REFCURSOR;
vCount int :=0;
ecode VARCHAR(32):=NULL;
errmsg varchar(10000) :=NULL;
vTemp int:=null;

SUCCESS varchar(10) = 'NO ERROR';
FAILURE varchar(10) = 'ERROR';
module  varchar(100) ='analyze_monitor_result_raw';
step    varchar(1000) ='initiating';
vValue numeric = null;
vSeverity int= 1;
vSeverity_text text= null;
vStmt varchar(2000)= ' ';
vAlert_id numeric=null;
vRuntime_severity int=null;
vRuntime_message varchar(1000) :=' ';
vBycount_severity int=null;
vBycount_message varchar(1000) :=' ';
vMessage  varchar(1000) :=NULL;
v_start_time TIMESTAMP := clock_timestamp();
v_last_step_time TIMESTAMP := v_start_time;
v_debug TEXT;-- := 'N';
--vColumn1 varcha2(1000) :=NULL;

arr_col1 TEXT[];
arr_col2 TEXT[];
arr_col3 TEXT[];
arr_col4 TEXT[];
arr_col5 TEXT[];
arr_col6 TEXT[];
i INTEGER;

vRuntime_Bycount_Severity  int=null;
vRuntime_Bycount_Message  varchar(1000) :=NULL;
-- required fixes
--field names
--
c1_display_name varchar(100) :=NULL;
c2_display_name varchar(100) :=NULL;
c3_display_name varchar(100) :=NULL;
c4_display_name varchar(100) :=NULL;
c5_display_name varchar(100) :=NULL;
c6_display_name varchar(100) :=NULL;
c7_display_name varchar(100) :=NULL;
c8_display_name varchar(100) :=NULL;
c9_display_name varchar(100) :=NULL;
c10_display_name varchar(100) :=NULL;
vItems  int=null;

BEGIN

SELECT value INTO v_debug
FROM public."clusterCore_systemsettings"
WHERE name = 'debug';


step= 'get the job run data for task_run_id '||in_task_run_id;
--raise info 'step %',step;
select * into task_run_data from app_123monitor.rp_monitor_result_raw rcm where task_run_id=in_task_run_id;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();

--raise info 'task_run_data %',task_run_data;
--raise info 'task_run_data_task_id %',task_run_data.task_id;
step= 'get the job run log info (elapsed_time and return_code)';
--select * into task_run_log from app_123monitor.rp_task_run_log rl where task_run_id=in_task_run_id;
select * into task_run_log from public."clusterCore_tasklog" cct where task_log_id=in_task_run_id order by created_date desc limit 1;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();

step= 'get the monitoring definitions for '||task_run_data.task_id;
--raise info 'step %',step;
select * into mon_def from app_123monitor.rp_monitors rcm where task_id=task_run_data.task_id;
--raise info 'mon_def %',mon_def;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();

IF mon_def.monitor_name LIKE 'pg_stat_statements%' THEN
	step='pg_stat_statements monitor analyzing';

	/*CREATE TABLE IF NOT EXISTS app_123monitor.pg_stat_statement_1h (
    node_id INT,
    date_created TIMESTAMP,
    query TEXT NOT NULL,
    calls BIGINT,
    total_exec_time DOUBLE PRECISION,
    avg_exec_time NUMERIC(10, 3)
	);
	
	CREATE TABLE IF NOT EXISTS app_123monitor.pg_stat_statement_6h (
	    node_id INT,
	    date_created TIMESTAMP,
	    query TEXT NOT NULL,
	    calls BIGINT,
	    total_exec_time DOUBLE PRECISION,
	    avg_exec_time NUMERIC(10, 3)
	);
	
	CREATE TABLE IF NOT EXISTS app_123monitor.pg_stat_statement_1d (
	    node_id INT,
	    date_created TIMESTAMP,
	    query TEXT NOT NULL,
	    calls BIGINT,
	    total_exec_time DOUBLE PRECISION,
	    avg_exec_time NUMERIC(10, 3)
	);
	
	CREATE TABLE IF NOT EXISTS app_123monitor.pg_stat_statement_1w (
	    node_id INT,
	    date_created TIMESTAMP,
	    query TEXT NOT NULL,
	    calls BIGINT,
	    total_exec_time DOUBLE PRECISION,
	    avg_exec_time NUMERIC(10, 3)
	);*/

    FOR mon_raw IN
    SELECT * FROM app_123monitor.rp_monitor_result_raw
    WHERE task_run_id = in_task_run_id
	LOOP
	    BEGIN
	        IF mon_raw.col1 = '1 minute' THEN
	            INSERT INTO app_123monitor.pg_stat_statement_1h (
	                node_id,
	                date_created,
	                query,
	                calls,
	                total_exec_time,
	                avg_exec_time
	            )
	            VALUES (
	                mon_def.node_id,
	                now(),
	                mon_raw.col2,
	                mon_raw.col3::BIGINT,
	                mon_raw.col4::DOUBLE PRECISION,
	                mon_raw.col5::NUMERIC
	            );
	
	        ELSIF mon_raw.col1 = '5 minutes' THEN
	            INSERT INTO app_123monitor.pg_stat_statement_6h (
	                node_id,
	                date_created,
	                query,
	                calls,
	                total_exec_time,
	                avg_exec_time
	            )
	            VALUES (
	                mon_def.node_id,
	                now(),
	                mon_raw.col2,
	                mon_raw.col3::BIGINT,
	                mon_raw.col4::DOUBLE PRECISION,
	                mon_raw.col5::NUMERIC
	            );
	
	        ELSIF mon_raw.col1 = '15 minutes' THEN
	            INSERT INTO app_123monitor.pg_stat_statement_1d (
	                node_id,
	                date_created,
	                query,
	                calls,
	                total_exec_time,
	                avg_exec_time
	            )
	            VALUES (
	                mon_def.node_id,
	                now(),
	                mon_raw.col2,
	                mon_raw.col3::BIGINT,
	                mon_raw.col4::DOUBLE PRECISION,
	                mon_raw.col5::NUMERIC
	            );
	
	        ELSIF mon_raw.col1 = '1 hour' THEN
	            INSERT INTO app_123monitor.pg_stat_statement_1w (
	                node_id,
	                date_created,
	                query,
	                calls,
	                total_exec_time,
	                avg_exec_time
	            )
	            VALUES (
	                mon_def.node_id,
	                now(),
	                mon_raw.col2,
	                mon_raw.col3::BIGINT,
	                mon_raw.col4::DOUBLE PRECISION,
	                mon_raw.col5::NUMERIC
	            );
	        END IF;
	
	    EXCEPTION
	        WHEN OTHERS THEN
	            RAISE WARNING 'Failed to insert pg_stat_statements row for interval %: %', mon_raw.col1, SQLERRM;
	    END;
	END LOOP;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	step='update rp_monitor_result_raw';
	update app_123monitor.rp_monitor_result_raw set ind_analyzed ='Y' where task_run_id=in_task_run_id;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

    RETURN SUCCESS;
END IF;


step= 'get_monitor_column_display_name for monitor'||mon_def.monitor_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column1') into c1_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column2') into c2_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column3') into c3_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column4') into c4_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column5') into c5_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column6') into c6_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column7') into c7_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column8') into c8_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column9') into c9_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column10') into c10_display_name;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


--raise info 'at % %',step, clock_timestamp();
step='create temp tables';

/*create table if not exists app_123monitor.tmp_current(column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, line_id int);
create table if not exists app_123monitor.tmp_basic(severity int,column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text,message text, line_id int);
create table if not exists app_123monitor.tmp_previous(severity int,column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text,message text);
create table if not exists app_123monitor.tmp_added_missing(severity int,column1 text ,message text);
create table if not exists app_123monitor.tmp_compare_to_previous( severity int,column1 text ,message text);
create table if not exists app_123monitor.tmp_basic_added_missing( severity int,column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text,message text, line_id int);
create table if not exists app_123monitor.tmp_final( severity int,column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text,message text, line_id int);*/

/*CREATE UNLOGGED TABLE IF NOT EXISTS app_123monitor.tmp_current (column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, line_id int);
CREATE UNLOGGED TABLE IF NOT EXISTS app_123monitor.tmp_basic (severity int, column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, message text, line_id int);
CREATE UNLOGGED TABLE IF NOT EXISTS app_123monitor.tmp_previous (severity int, column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, message text);
CREATE UNLOGGED TABLE IF NOT EXISTS app_123monitor.tmp_added_missing (severity int, column1 text, message text);
CREATE UNLOGGED TABLE IF NOT EXISTS app_123monitor.tmp_compare_to_previous (severity int, column1 text, message text);
CREATE UNLOGGED TABLE IF NOT EXISTS app_123monitor.tmp_basic_added_missing (severity int, column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, message text, line_id int);
CREATE UNLOGGED TABLE IF NOT EXISTS app_123monitor.tmp_final (severity int, column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, message text, line_id int);*/


/*DROP TABLE IF EXISTS app_123monitor.tmp_current;
CREATE TABLE app_123monitor.tmp_current (column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, line_id int);

DROP TABLE IF EXISTS app_123monitor.tmp_basic;
CREATE TABLE app_123monitor.tmp_basic (severity int, column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, message text, line_id int) ;

DROP TABLE IF EXISTS app_123monitor.tmp_previous;
CREATE TABLE app_123monitor.tmp_previous (severity int, column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, message text);

DROP TABLE IF EXISTS app_123monitor.tmp_added_missing;
CREATE TABLE app_123monitor.tmp_added_missing (severity int, column1 text, message text);

DROP TABLE IF EXISTS app_123monitor.tmp_compare_to_previous;
CREATE TABLE app_123monitor.tmp_compare_to_previous (severity int, column1 text, message text);

DROP TABLE IF EXISTS app_123monitor.tmp_basic_added_missing;
CREATE TABLE app_123monitor.tmp_basic_added_missing (severity int, column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, message text, line_id int);

DROP TABLE IF EXISTS app_123monitor.tmp_final;
CREATE TABLE app_123monitor.tmp_final (severity int, column1 text, column2 text, column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, message text, line_id int);*/






PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


step='delete from temp tables';
PERFORM write_log(-1,'0','analyze_monitors_result_raw','analyzer','step','called from analyzer_result_raw',3);
delete from app_123monitor.tmp_current;
delete from app_123monitor.tmp_basic;
delete from app_123monitor.tmp_previous;
delete from app_123monitor.tmp_added_missing;
delete from app_123monitor.tmp_basic_added_missing;
delete from app_123monitor.tmp_final;
delete from app_123monitor.tmp_compare_to_previous;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


step='insert into tmp_current';
insert into app_123monitor.tmp_current
select  col1,col2,col3,col4,col5,col6,col7,col8,col9,col10,line_id
from 	app_123monitor.rp_monitor_result_raw
where 	task_run_id=in_task_run_id ;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


--------------------------------------------- start regular alert -------------------------------------
--raise info 'point 1 ';
step='find alert based on basic column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,line_id,red_rule and yellow_rule)'||' in_task_run_id='||in_task_run_id;

vStmt=	'insert into app_123monitor.tmp_basic select max (severity),column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,'''',line_id from (
			select 1 as severity,column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,'''' message,line_id from app_123monitor.tmp_current
			union 
			select 3 as severity,column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,'''' message,line_id from app_123monitor.tmp_current where '||mon_def.red_rule||' 
			union 
			select 2 as severity,column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,'''' message,line_id from app_123monitor.tmp_current where '||mon_def.yellow_rule||') a
			group by column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,message,line_id';
			
--raise info 'mon_def.red_rule % ',mon_def.red_rule;
--raise info 'mon_def.yellow_rule % ',mon_def.yellow_rule;
--raise info 'at % % ',step,vStmt;
if vStmt is null then return SUCCESS;end if;
--raise info 'point 1.1';
execute vStmt;
--raise info 'point 1.2';
update app_123monitor.tmp_basic set message =mon_def.yellow_rule_message where severity =2;
update app_123monitor.tmp_basic set message =mon_def.red_rule_message where severity =3;
vStmt = '';

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();

--------------------------------------------- start alerts based on count of rows -------------------------------------
step='find alert based on count of rows - we use the previously populated tmp_basic table';
--raise info 'point 2';
vBycount_severity = 1;
--vBycount_message='Number of items returned by the monitor ('||vItems||') is above the threshold ('||mon_def.red_by_row_count_items||')';
if mon_def.ind_yellow_by_row_count = 'Y' then -- check number of items returned by the monitor
	--raise info 'point 3';
	select count(*),column1 into vItems from app_123monitor.tmp_current where column1 is not null group by column1;
	if mon_def.yellow_by_row_count_option='above' and vItems > mon_def.yellow_by_row_count_items  then 
		--raise info 'point 4';
		vBycount_severity = 2;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is above the threshold ('||mon_def.yellow_by_row_count_items||')';
	end if;
	--raise info 'point 5';

	if mon_def.yellow_by_row_count_option='below' and vItems < mon_def.yellow_by_row_count_items then 
		--raise info 'point 6';
		vBycount_severity = 2;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is below the threshold ('||mon_def.yellow_by_row_count_items||')';
	end if;
	--raise info 'point 7';

	if mon_def.yellow_by_row_count_option='exactly' and vItems = mon_def.yellow_by_row_count_items then 
		--raise info 'point 8';
		vBycount_severity = 2;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is exactly the threshold ('||mon_def.yellow_by_row_count_items||')';
	end if;
end if;
--raise info 'point 5';

if mon_def.ind_red_by_row_count = 'Y' then -- check number of items returned by the monitor
	select count(*) into vItems from app_123monitor.tmp_basic where column1 is not null;
	if mon_def.red_by_row_count_option='above' and vItems > mon_def.red_by_row_count_items then 
		vBycount_severity = 3;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is above the threshold ('||mon_def.red_by_row_count_items||')';
	end if;

	if mon_def.red_by_row_count_option='below' and vItems < mon_def.red_by_row_count_items then 
		vBycount_severity = 3;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is below the threshold ('||mon_def.red_by_row_count_items||')';
	end if;

	if mon_def.red_by_row_count_option='exactly' and vItems = mon_def.red_by_row_count_items then 
		vBycount_severity = 3;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is exactly the threshold ('||mon_def.red_by_row_count_items||')';
	end if;
end if;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


step='if the added/missing rule or the compare_to_previous check were requested then get the data of previous alert';
--raise info 'at %',step;
if (mon_def.ind_first_column_unique='Y' and mon_def.ind_alert_on_added_missing='Y') or mon_def.ind_alert_compare_to_previous_check='Y' then
	insert into app_123monitor.tmp_previous
	select  severity,
			column1,column2,column3,column4,column5,column6,column7,column8,column9,column10
			message
	from 	app_123monitor.rp_alert_detail rad 
	where 	alert_id = (select max(alert_id) from app_123monitor.rp_alert where monitor_name =mon_def.monitor_name and node_type =mon_def.db_type) and message not like '%not found in current%';
end if;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


--------------------------------------------- start alerts based on added/missing rule -------------------------------------
-- changed c1_display_name to column1

step='find alert based on added/missing rule';
if (mon_def.ind_first_column_unique='Y' and mon_def.ind_alert_on_added_missing='Y') then
	insert into app_123monitor.tmp_added_missing
	select mon_def.alert_on_added_missing_severity,column1,column1||' not found in previous check' 
	from (SELECT column1 from app_123monitor.tmp_current where column1 is not null except SELECT column1 from app_123monitor.tmp_previous where column1 is not null) as a
	union 
	select mon_def.alert_on_added_missing_severity,column1,column1||' not found in current check' 
	from (SELECT column1 from app_123monitor.tmp_previous where column1 is not null except SELECT column1 from app_123monitor.tmp_current where column1 is not null) as b;
end if;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


--------------------------------------------- start alerts based on compare to previous rule -------------------------------------
step='find alert based on compare to previous rule';
if (mon_def.ind_alert_compare_to_previous_check='Y' ) then
	if (mon_def.alert_compare_to_previous_check_higher_lower='lower') then
		insert into app_123monitor.tmp_compare_to_previous
		select mon_def.alert_compare_to_previous_check_severity,c.column1,'previous column2 is over '||mon_def.alert_compare_to_previous_check_percent||' times higher then the current column2'  
		from app_123monitor.tmp_current c, app_123monitor.tmp_previous p 
		where c.column1=p.column1 and mon_def.alert_compare_to_previous_check_percent*c.column2::numeric<(p.column2::numeric);
	end if;

	if (mon_def.alert_compare_to_previous_check_higher_lower='higher') then
		insert into app_123monitor.tmp_compare_to_previous
		SELECT mon_def.alert_compare_to_previous_check_severity,c.column1,'current column2 is over '||mon_def.alert_compare_to_previous_check_percent||' times higher then the previous column2' 
		from app_123monitor.tmp_current c, app_123monitor.tmp_previous p 
		where c.column1=p.column1 and mon_def.alert_compare_to_previous_check_percent*p.column2::numeric<(c.column2::numeric);
	end if;
	
	if (mon_def.alert_compare_to_previous_check_higher_lower='different') then
		insert into app_123monitor.tmp_compare_to_previous
		SELECT mon_def.alert_compare_to_previous_check_severity,c.column1,'current column2 is different then the previous column2' 
		from app_123monitor.tmp_current c, app_123monitor.tmp_previous p 
		where c.column1=p.column1 and p.column2!=c.column2;
	end if;

end if;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


step='compute alert details based on tmp_basic tmp_added_missing';
-- compute final alert details based on tmp_basic tmp_added_missing
insert into app_123monitor.tmp_basic_added_missing 
select greatest(aseverity,bseverity),greatest(acolumn1,bcolumn1),bcolumn2,bcolumn3,bcolumn4,bcolumn5,bcolumn6,bcolumn7,bcolumn8,bcolumn9,bcolumn10,
	   coalesce (bmessage,'')||chr(10)||coalesce (amessage,'') message, bline_id
from (SELECT b.severity bseverity,b.column1 bcolumn1,b.column2 bcolumn2, b.column3 bcolumn3, b.column4 bcolumn4, b.column5 bcolumn5, 
			 b.column6 bcolumn6, b.column7 bcolumn7, b.column8 bcolumn8, b.column9 bcolumn9, b.column10 bcolumn10,b.message bmessage, b.line_id bline_id,
			 a.severity aseverity,a.column1 acolumn1,a.message amessage
	FROM app_123monitor.tmp_basic b 
	FULL JOIN app_123monitor.tmp_added_missing a on A.column1 = B.column1) as i ;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


step='merge tmp_basic_added_missing with tmp_compare_to_previous';
insert into app_123monitor.tmp_final
select greatest(fseverity,pseverity),greatest (fcolumn1,pcolumn1),fcolumn2,fcolumn3,fcolumn4,fcolumn5,fcolumn6,fcolumn7,fcolumn8,fcolumn9,fcolumn10,
	   coalesce (fmessage,'')||chr(10)||coalesce (pmessage,'') message, fline_id
from (SELECT f.severity fseverity,f.column1 fcolumn1,f.column2 fcolumn2, f.column3 fcolumn3, f.column4 fcolumn4, f.column5 fcolumn5, 
			 f.column6 fcolumn6, f.column7 fcolumn7, f.column8 fcolumn8, f.column9 fcolumn9, f.column10 fcolumn10,f.message fmessage,
	         p.severity pseverity,p.column1 pcolumn1,p.message pmessage, f.line_id fline_id
	  FROM app_123monitor.tmp_compare_to_previous p 
	  FULL JOIN app_123monitor.tmp_basic_added_missing f on f.column1 = p.column1) as i;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


-- compute final alert details based on tmp_basic tmp_added_missing
step='get the severity as a result of long runtime';
vRuntime_severity=1;

if task_run_log.duration*1000 > mon_def.runtime_yellow_threshold 
then 
	vRuntime_severity=2; 
	vRuntime_message='monitor runtime: '||(task_run_log.duration*1000)||'(ms) exceeded the yellow runtime threshold '||mon_def.runtime_yellow_threshold||'(ms)';
end if;

if task_run_log.duration*1000 > mon_def.runtime_red_threshold 
then 
	vRuntime_severity=3; 
	vRuntime_message='monitor runtime: '||(task_run_log.duration*1000)||'(ms) exceeded the red runtime threshold '||mon_def.runtime_red_threshold||'(ms)';
	-- update the counter of number of times the job ran too slow
	update app_123monitor.rp_monitors set count_long_running=count_long_running +1 where node_id=mon_def.node_id and monitor_name=mon_def.monitor_name and db_type =mon_def.db_type;

	-- if the counter of long running times is already 10 (9 before we incremented it) the break the jobs
	if mon_def.count_long_running=10 then
		update app_123monitor.rp_monitors set ind_broken='Y' where node_id=mon_def.node_id and monitor_name=mon_def.monitor_name and db_type =mon_def.db_type;
		update "clusterCore_task" set status='broken' where task_id=mon_def.task_id;
	end if;
end if;

-- reset the runtime counter if the last runtime severity was not red
if vRuntime_severity<3 then
	update app_123monitor.rp_monitors set count_long_running=0 where node_id=mon_def.node_id and monitor_name=mon_def.monitor_name and db_type =mon_def.db_type;
end if; 

select greatest(vRuntime_severity,vBycount_severity) into vRuntime_Bycount_Severity;
select vRuntime_message||vBycount_message into vRuntime_Bycount_Message;
vAlert_id = nextval('app_123monitor.alert_seq'); 

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


step='insert into rp_alert';
select greatest(max(severity),vRuntime_Bycount_Severity) into vSeverity from app_123monitor.tmp_final;
select coalesce(max(message),' ')||chr(10)||vRuntime_Bycount_Message into vMessage from app_123monitor.tmp_final;

insert into app_123monitor.rp_alert 
select vAlert_id,mon_def.node_id,mon_def.monitor_name,now(),vSeverity,vMessage,task_run_log.duration*1000,mon_def.db_type 
from app_123monitor.tmp_final
group by vAlert_id,mon_def.node_id,mon_def.monitor_name,now(),task_run_log.duration*1000,mon_def.db_type;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();

step='upsert into rp_alert_current (insert/update latest alert)';
insert into app_123monitor.rp_alert_current (alert_id,node_id,monitor_name,date_created,severity,message,runtime_duration_msec,node_type)
values (vAlert_id,mon_def.node_id,mon_def.monitor_name,now(),vSeverity,vMessage,task_run_log.duration * 1000,mon_def.db_type)
on conflict (node_id, monitor_name, node_type)
do update set
    alert_id = excluded.alert_id,
    date_created = excluded.date_created,
    severity = excluded.severity,
    message = excluded.message,
    runtime_duration_msec = excluded.runtime_duration_msec;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();

step='insert into rp_alert_detail';

select count (*) into vCount from app_123monitor.tmp_final;
--raise info 'numrows at tmp_final % ',vCount ;
insert 	into app_123monitor.rp_alert_detail 
select 	vAlert_id,nextval('app_123monitor.alert_detail_seq'), 
		CASE 
   			WHEN length(column1)<4 or column1 is null  THEN 0
   			ELSE severity 
		end ,
		column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,
		message, line_id
from app_123monitor.tmp_final where column1 is not null;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


--TO DO: select org_id from public."clusterCore_c123_node"
if vSeverity>1 and mon_def.ind_send_email_notifications ='Y' then
	select * into org_def from organization where org_id  = (select org_id from public."clusterCore_c123_node" where id=mon_def.node_id);
end if;

step='insert into rp_mail_queue';
insert into app_123monitor.rp_mail_queue
	(id,
	org_id,
	node_id,
	sender,
	mail_to,
	mail_subject,
	mail_message,
	ind_sent,
	date_created,
	date_sent,
	send_return_message,
	send_return_code)
values 
	(nextval('app_123monitor.mail_queue_seq'),
	org_def.org_id,
	mon_def.node_id,
	'123Monitor',
	null,
	mon_def.monitor_name||' status '||app_123monitor.get_color(vSeverity)||' Message is: '||vMessage,
	null,
	'P',
	now(),
	null,
	null,
	null);

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


step='update the timeline for this monitor (alert level)';
PERFORM app_123monitor.update_timeline((mon_def.node_id)::int,mon_def.monitor_name::text,vAlert_id::int);
--OLD:PERFORM app_123monitor.update_timeline((mon_def.node_id)::int,mon_def.monitor_name, mon_def.monitor_name||' status '||app_123monitor.get_color(vSeverity), vSeverity,mon_def.monitor_name||' status '||app_123monitor.get_color(vSeverity));

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


step='update the timeline for this monitor (alert detail level)';
--for ad in select * from app_123monitor.tmp_final limit 10 loop
--	PERFORM app_123monitor.update_alert_detail_timeline(mon_def.node_id,ad.column1,	ad.column1||' status '||get_color(ad.severity), ad.severity, ad.column1||' status '||get_color(ad.severity),mon_def.monitor_name);
--end loop;

step='update rp_monitor_result_raw';
update app_123monitor.rp_monitor_result_raw set ind_analyzed ='Y' where task_run_id=in_task_run_id;

PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
v_last_step_time := clock_timestamp();


return SUCCESS;
exception
    when others then
     GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,ecode := RETURNED_SQLSTATE;
    raise info 'point exception';

	PERFORM write_log(mon_def.node_id,mon_def.monitor_name,ecode,errmsg||' '||vStmt,module,step||' '||in_task_run_id::text,3);
  return FAILURE||':'||ecode||':'||errmsg;

end;
$$;


--
-- TOC entry 584 (class 1255 OID 53195484)
-- Name: analyze_monitor_result_raw_with_time(uuid); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.analyze_monitor_result_raw_with_time(in_task_run_id uuid) RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
mon_def app_123monitor.rp_monitors%rowtype;
org_def organization%rowtype;
mon_raw RECORD;
task_run_data RECORD;
task_run_log RECORD;
ad RECORD;
v_curs REFCURSOR;
vCount int :=0;
ecode VARCHAR(32):=NULL;
errmsg varchar(10000) :=NULL;
vTemp int:=null;

SUCCESS varchar(10) = 'NO ERROR';
FAILURE varchar(10) = 'ERROR';
module  varchar(100) ='analyze_monitor_result_raw_with_time';
step    varchar(1000) ='initiating';
vValue numeric = null;
vSeverity int= 1;
vSeverity_text text= null;
vStmt varchar(2000)= ' ';
vAlert_id numeric=null;
vRuntime_severity int=null;
vRuntime_message varchar(1000) :=' ';
vBycount_severity int=null;
vBycount_message varchar(1000) :=' ';
vMessage  varchar(1000) :=NULL;
--vColumn1 varcha2(1000) :=NULL;

vRuntime_Bycount_Severity  int=null;
vRuntime_Bycount_Message  varchar(1000) :=NULL;
-- required fixes
--field names
--
c1_display_name varchar(100) :=NULL;
c2_display_name varchar(100) :=NULL;
c3_display_name varchar(100) :=NULL;
c4_display_name varchar(100) :=NULL;
c5_display_name varchar(100) :=NULL;
c6_display_name varchar(100) :=NULL;
c7_display_name varchar(100) :=NULL;
c8_display_name varchar(100) :=NULL;
c9_display_name varchar(100) :=NULL;
c10_display_name varchar(100) :=NULL;
vItems  int=null;

last_time timestamp;
current__time timestamp;
time_diff numeric;

start_time timestamp;


BEGIN
step= 'get the job run data for task_run_id '||in_task_run_id;
----raise info 'step %',step;
select * into task_run_data from app_123monitor.rp_monitor_result_raw rcm where task_run_id=in_task_run_id;
----raise info 'task_run_data %',task_run_data;
----raise info 'task_run_data_task_id %',task_run_data.task_id;
step= 'get the job run log info (elapsed_time and return_code)';
--select * into task_run_log from app_123monitor.rp_task_run_log rl where task_run_id=in_task_run_id;
select * into task_run_log from public."clusterCore_tasklog" cct where task_log_id=in_task_run_id order by created_date desc limit 1;

--get time
select clock_timestamp() into start_time;
select clock_timestamp() into last_time;
select clock_timestamp() into current__time;
----raise info 'test1';
time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
----raise info 'test2';
--raise INFO '%   1   analyze_monitor_result_raw', time_diff;
last_time := current__time;

step= 'get the monitoring definitions for '||task_run_data.task_id;
----raise info 'step %',step;
select * into mon_def from app_123monitor.rp_monitors rcm where task_id=task_run_data.task_id;
----raise info '% task_id nick', task_run_data.task_id;
----raise info 'mon_def %',mon_def;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
--raise INFO '%   2   analyze_monitor_result_raw', time_diff;
last_time := current__time;

step= 'get_monitor_column_display_name for monitor'||mon_def.monitor_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column1') into c1_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column2') into c2_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column3') into c3_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column4') into c4_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column5') into c5_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column6') into c6_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column7') into c7_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column8') into c8_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column9') into c9_display_name;
select app_123monitor.get_monitor_column_display_name(mon_def.node_id,mon_def.db_type,mon_def.monitor_name,'column10') into c10_display_name;
----raise info 'mon_def_nick %', mon_def;
--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time)) * 1000;
--raise INFO '%   3   analyze_monitor_result_raw', time_diff;
last_time := current__time;

step='create temp tables';

create table if not exists app_123monitor.tmp_current(column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text, line_id int);
create table if not exists app_123monitor.tmp_basic(severity int,column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text,message text, line_id int);
create table if not exists app_123monitor.tmp_previous(severity int,column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text,message text);
create table if not exists app_123monitor.tmp_added_missing(severity int,column1 text ,message text);
create table if not exists app_123monitor.tmp_compare_to_previous( severity int,column1 text ,message text);
create table if not exists app_123monitor.tmp_basic_added_missing( severity int,column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text,message text, line_id int);
create table if not exists app_123monitor.tmp_final( severity int,column1 text ,column2 text ,column3 text, column4 text, column5 text, column6 text, column7 text, column8 text, column9 text, column10 text,message text, line_id int);

step='truncate temp tables';
--PERFORM write_log(-1,'0','analyze_monitors_result_raw','analyzer','step','called from analyzer_result_raw',3);
truncate table app_123monitor.tmp_current;
truncate table app_123monitor.tmp_basic;
truncate table app_123monitor.tmp_previous;
truncate table app_123monitor.tmp_added_missing;
truncate table app_123monitor.tmp_basic_added_missing;
truncate table app_123monitor.tmp_final;
truncate table app_123monitor.tmp_compare_to_previous;
----raise info 'got past truncate';

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time)) * 1000;
--raise INFO '%   4   analyze_monitor_result_raw', time_diff;
last_time := current__time;

step='insert into tmp_current';
insert into app_123monitor.tmp_current
select  col1,col2,col3,col4,col5,col6,col7,col8,col9,col10,line_id
from 	app_123monitor.rp_monitor_result_raw
where 	task_run_id=in_task_run_id ;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time)) * 1000 ;
--raise INFO '%   5   analyze_monitor_result_raw', time_diff;
last_time := current__time;

--------------------------------------------- start regular alert -------------------------------------
----raise info 'point 1 ';
step='find alert based on basic column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,line_id,red_rule and yellow_rule)'||' in_task_run_id='||in_task_run_id;

vStmt=	'insert into app_123monitor.tmp_basic select max (severity),column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,'''',line_id from (
			select 1 as severity,column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,'''' message,line_id from app_123monitor.tmp_current
			union
			select 3 as severity,column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,'''' message,line_id from app_123monitor.tmp_current where '||mon_def.red_rule||'
			union
			select 2 as severity,column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,'''' message,line_id from app_123monitor.tmp_current where '||mon_def.yellow_rule||') a
			group by column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,message,line_id';

----raise info 'mon_def.red_rule % ',mon_def.red_rule;
----raise info 'mon_def.yellow_rule % ',mon_def.yellow_rule;
----raise info 'at % % ',step,vStmt;
if vStmt is null then return SUCCESS;end if;
----raise info 'point 1.1';
execute vStmt;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time)) * 1000;
--raise INFO '%   6   analyze_monitor_result_raw', time_diff;
last_time := current__time;

----raise info 'point 1.2';
update app_123monitor.tmp_basic set message =mon_def.yellow_rule_message where severity =2;
update app_123monitor.tmp_basic set message =mon_def.red_rule_message where severity =3;
vStmt = '';

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   7   analyze_monitor_result_raw', time_diff;
last_time := current__time;
--------------------------------------------- start alerts based on count of rows -------------------------------------
step='find alert based on count of rows - we use the previously populated tmp_basic table';
----raise info 'point 2';
vBycount_severity = 1;
--vBycount_message='Number of items returned by the monitor ('||vItems||') is above the threshold ('||mon_def.red_by_row_count_items||')';
if mon_def.ind_yellow_by_row_count = 'Y' then -- check number of items returned by the monitor
	----raise info 'point 3';
	select count(*),column1 into vItems from app_123monitor.tmp_current where column1 is not null group by column1;
	if mon_def.yellow_by_row_count_option='above' and vItems > mon_def.yellow_by_row_count_items  then
		----raise info 'point 4';
		vBycount_severity = 2;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is above the threshold ('||mon_def.yellow_by_row_count_items||')';
	end if;
	----raise info 'point 5';

	if mon_def.yellow_by_row_count_option='below' and vItems < mon_def.yellow_by_row_count_items then
		----raise info 'point 6';
		vBycount_severity = 2;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is below the threshold ('||mon_def.yellow_by_row_count_items||')';
	end if;
	----raise info 'point 7';

	if mon_def.yellow_by_row_count_option='exactly' and vItems = mon_def.yellow_by_row_count_items then
		----raise info 'point 8';
		vBycount_severity = 2;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is exactly the threshold ('||mon_def.yellow_by_row_count_items||')';
	end if;
end if;
----raise info 'point 5';

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   8   analyze_monitor_result_raw', time_diff;
last_time := current__time;

if mon_def.ind_red_by_row_count = 'Y' then -- check number of items returned by the monitor
	select count(*) into vItems from app_123monitor.tmp_basic where column1 is not null;
	if mon_def.red_by_row_count_option='above' and vItems > mon_def.red_by_row_count_items then
		vBycount_severity = 3;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is above the threshold ('||mon_def.red_by_row_count_items||')';
	end if;

	if mon_def.red_by_row_count_option='below' and vItems < mon_def.red_by_row_count_items then
		vBycount_severity = 3;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is below the threshold ('||mon_def.red_by_row_count_items||')';
	end if;

	if mon_def.red_by_row_count_option='exactly' and vItems = mon_def.red_by_row_count_items then
		vBycount_severity = 3;
		vBycount_message='Number of items returned by the monitor ('||vItems||') is exactly the threshold ('||mon_def.red_by_row_count_items||')';
	end if;
end if;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   9   analyze_monitor_result_raw', time_diff;
last_time := current__time;

step='if the added/missing rule or the compare_to_previous check were requested then get the data of previous alert';
----raise info 'at %',step;
if (mon_def.ind_first_column_unique='Y' and mon_def.ind_alert_on_added_missing='Y') or mon_def.ind_alert_compare_to_previous_check='Y' then
	insert into app_123monitor.tmp_previous
	select  severity,
			column1,column2,column3,column4,column5,column6,column7,column8,column9,column10
			message
	from 	app_123monitor.rp_alert_detail rad
	where 	alert_id = (select max(alert_id) from app_123monitor.rp_alert where monitor_name =mon_def.monitor_name and node_type =mon_def.db_type) and message not like '%not found in current%';
end if;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   10   analyze_monitor_result_raw', time_diff;
last_time := current__time;

--------------------------------------------- start alerts based on added/missing rule -------------------------------------
-- changed c1_display_name to column1

step='find alert based on added/missing rule';
if (mon_def.ind_first_column_unique='Y' and mon_def.ind_alert_on_added_missing='Y') then
	insert into app_123monitor.tmp_added_missing
	select mon_def.alert_on_added_missing_severity,column1,column1||' not found in previous check'
	from (SELECT column1 from app_123monitor.tmp_current where column1 is not null except SELECT column1 from app_123monitor.tmp_previous where column1 is not null) as a
	union
	select mon_def.alert_on_added_missing_severity,column1,column1||' not found in current check'
	from (SELECT column1 from app_123monitor.tmp_previous where column1 is not null except SELECT column1 from app_123monitor.tmp_current where column1 is not null) as b;
end if;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   11   analyze_monitor_result_raw', time_diff;
last_time := current__time;

--------------------------------------------- start alerts based on compare to previous rule -------------------------------------
step='find alert based on compare to previous rule';
if (mon_def.ind_alert_compare_to_previous_check='Y' ) then
	if (mon_def.alert_compare_to_previous_check_higher_lower='lower') then
		insert into app_123monitor.tmp_compare_to_previous
		select mon_def.alert_compare_to_previous_check_severity,c.column1,'previous column2 is over '||mon_def.alert_compare_to_previous_check_percent||' times higher then the current column2'
		from app_123monitor.tmp_current c, app_123monitor.tmp_previous p
		where c.column1=p.column1 and mon_def.alert_compare_to_previous_check_percent*c.column2::numeric<(p.column2::numeric);
	end if;

	if (mon_def.alert_compare_to_previous_check_higher_lower='higher') then
		insert into app_123monitor.tmp_compare_to_previous
		SELECT mon_def.alert_compare_to_previous_check_severity,c.column1,'current column2 is over '||mon_def.alert_compare_to_previous_check_percent||' times higher then the previous column2'
		from app_123monitor.tmp_current c, app_123monitor.tmp_previous p
		where c.column1=p.column1 and mon_def.alert_compare_to_previous_check_percent*p.column2::numeric<(c.column2::numeric);
	end if;

	if (mon_def.alert_compare_to_previous_check_higher_lower='different') then
		insert into app_123monitor.tmp_compare_to_previous
		SELECT mon_def.alert_compare_to_previous_check_severity,c.column1,'current column2 is different then the previous column2'
		from app_123monitor.tmp_current c, app_123monitor.tmp_previous p
		where c.column1=p.column1 and p.column2!=c.column2;
	end if;

end if;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   12   analyze_monitor_result_raw', time_diff;
last_time := current__time;

step='compute alert details based on tmp_basic tmp_added_missing';
-- compute final alert details based on tmp_basic tmp_added_missing
insert into app_123monitor.tmp_basic_added_missing
select greatest(aseverity,bseverity),greatest(acolumn1,bcolumn1),bcolumn2,bcolumn3,bcolumn4,bcolumn5,bcolumn6,bcolumn7,bcolumn8,bcolumn9,bcolumn10,
	   coalesce (bmessage,'')||chr(10)||coalesce (amessage,'') message, bline_id
from (SELECT b.severity bseverity,b.column1 bcolumn1,b.column2 bcolumn2, b.column3 bcolumn3, b.column4 bcolumn4, b.column5 bcolumn5,
			 b.column6 bcolumn6, b.column7 bcolumn7, b.column8 bcolumn8, b.column9 bcolumn9, b.column10 bcolumn10,b.message bmessage, b.line_id bline_id,
			 a.severity aseverity,a.column1 acolumn1,a.message amessage
	FROM app_123monitor.tmp_basic b
	FULL JOIN app_123monitor.tmp_added_missing a on A.column1 = B.column1) as i ;


--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   13   analyze_monitor_result_raw', time_diff;
last_time := current__time;


step='merge tmp_basic_added_missing with tmp_compare_to_previous';
insert into app_123monitor.tmp_final
select greatest(fseverity,pseverity),greatest (fcolumn1,pcolumn1),fcolumn2,fcolumn3,fcolumn4,fcolumn5,fcolumn6,fcolumn7,fcolumn8,fcolumn9,fcolumn10,
	   coalesce (fmessage,'')||chr(10)||coalesce (pmessage,'') message, fline_id
from (SELECT f.severity fseverity,f.column1 fcolumn1,f.column2 fcolumn2, f.column3 fcolumn3, f.column4 fcolumn4, f.column5 fcolumn5,
			 f.column6 fcolumn6, f.column7 fcolumn7, f.column8 fcolumn8, f.column9 fcolumn9, f.column10 fcolumn10,f.message fmessage,
	         p.severity pseverity,p.column1 pcolumn1,p.message pmessage, f.line_id fline_id
	  FROM app_123monitor.tmp_compare_to_previous p
	  FULL JOIN app_123monitor.tmp_basic_added_missing f on f.column1 = p.column1) as i;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   14   analyze_monitor_result_raw', time_diff;
last_time := current__time;

-- compute final alert details based on tmp_basic tmp_added_missing
step='get the severity as a result of long runtime';
vRuntime_severity=1;

if task_run_log.duration*1000 > mon_def.runtime_yellow_threshold
then
	vRuntime_severity=2;
	vRuntime_message='monitor runtime: '||(task_run_log.duration*1000)||'(ms) exceeded the yellow runtime threshold '||mon_def.runtime_yellow_threshold||'(ms)';
end if;

if task_run_log.duration*1000 > mon_def.runtime_red_threshold
then
	vRuntime_severity=3;
	vRuntime_message='monitor runtime: '||(task_run_log.duration*1000)||'(ms) exceeded the red runtime threshold '||mon_def.runtime_red_threshold||'(ms)';
	-- update the counter of number of times the job ran too slow
	update app_123monitor.rp_monitors set count_long_running=count_long_running +1 where node_id=mon_def.node_id and monitor_name=mon_def.monitor_name and db_type =mon_def.db_type;

	-- if the counter of long running times is already 10 (9 before we incremented it) the break the jobs
	if mon_def.count_long_running=10 then
		update app_123monitor.rp_monitors set ind_broken='Y' where node_id=mon_def.node_id and monitor_name=mon_def.monitor_name and db_type =mon_def.db_type;
		update "clusterCore_task" set status='broken' where task_id=mon_def.task_id;
	end if;
end if;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   15   analyze_monitor_result_raw', time_diff;
last_time := current__time;

-- reset the runtime counter if the last runtime severity was not red
if vRuntime_severity<3 then
	update app_123monitor.rp_monitors set count_long_running=0 where node_id=mon_def.node_id and monitor_name=mon_def.monitor_name and db_type =mon_def.db_type;
end if;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time)) * 1000;
--raise INFO '%   16   analyze_monitor_result_raw', time_diff;
last_time := current__time;

select greatest(vRuntime_severity,vBycount_severity) into vRuntime_Bycount_Severity;
select vRuntime_message||vBycount_message into vRuntime_Bycount_Message;
vAlert_id = nextval('app_123monitor.alert_seq');

step='insert into rp_alert';
select greatest(max(severity),vRuntime_Bycount_Severity) into vSeverity from app_123monitor.tmp_final;
select coalesce(max(message),' ')||chr(10)||vRuntime_Bycount_Message into vMessage from app_123monitor.tmp_final;

insert into app_123monitor.rp_alert
select vAlert_id,mon_def.node_id,mon_def.monitor_name,now(),vSeverity,vMessage,task_run_log.duration*1000,mon_def.db_type
from app_123monitor.tmp_final
group by vAlert_id,mon_def.node_id,mon_def.monitor_name,now(),task_run_log.duration*1000,mon_def.db_type;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   17   analyze_monitor_result_raw', time_diff;
last_time := current__time;

step='insert into rp_alert_detail';

select count (*) into vCount from app_123monitor.tmp_final;
----raise info 'numrows at tmp_final % ',vCount ;
insert 	into app_123monitor.rp_alert_detail
select 	vAlert_id,nextval('app_123monitor.alert_detail_seq'),
		CASE
   			WHEN length(column1)<4 or column1 is null  THEN 0
   			ELSE severity
		end ,
		column1,column2,column3,column4,column5,column6,column7,column8,column9,column10,
		message, line_id
from app_123monitor.tmp_final where column1 is not null;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   18   analyze_monitor_result_raw', time_diff;
last_time := current__time;

--TO DO: select org_id from public."clusterCore_c123_node"
if vSeverity>1 and mon_def.ind_send_email_notifications ='Y' then
	select * into org_def from organization where org_id  = (select org_id from public."clusterCore_c123_node" where id=mon_def.node_id);
end if;

step='insert into rp_mail_queue';
insert into app_123monitor.rp_mail_queue
	(id,
	org_id,
	node_id,
	sender,
	mail_to,
	mail_subject,
	mail_message,
	ind_sent,
	date_created,
	date_sent,
	send_return_message,
	send_return_code)
values
	(nextval('app_123monitor.mail_queue_seq'),
	org_def.org_id,
	mon_def.node_id,
	'123Monitor',
	null,
	mon_def.monitor_name||' status '||app_123monitor.get_color(vSeverity)||' Message is: '||vMessage,
	null,
	'P',
	now(),
	null,
	null,
	null);

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   19   analyze_monitor_result_raw', time_diff;
last_time := current__time;

PERFORM app_123monitor.update_timeline_with_time((mon_def.node_id)::int,mon_def.monitor_name::text,vAlert_id::int);
--OLD:PERFORM app_123monitor.update_timeline((mon_def.node_id)::int,mon_def.monitor_name, mon_def.monitor_name||' status '||app_123monitor.get_color(vSeverity), vSeverity,mon_def.monitor_name||' status '||app_123monitor.get_color(vSeverity));

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   20   analyze_monitor_result_raw', time_diff;
last_time := current__time;

step='update the timeline for this monitor (alert detail level)';
--for ad in select * from app_123monitor.tmp_final limit 10 loop
--	PERFORM app_123monitor.update_alert_detail_timeline(mon_def.node_id,ad.column1,	ad.column1||' status '||get_color(ad.severity), ad.severity, ad.column1||' status '||get_color(ad.severity),mon_def.monitor_name);
--end loop;

step='update rp_monitor_result_raw';
update app_123monitor.rp_monitor_result_raw set ind_analyzed ='Y' where task_run_id=in_task_run_id;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time))* 1000;
--raise INFO '%   21   analyze_monitor_result_raw', time_diff;
last_time := current__time;


select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - start_time)) * 1000;
raise INFO '%   ANALYZER_MONITOR_RESULT_RAW took for  % ', time_diff, in_task_run_id;

return SUCCESS;
exception
    when others then
     GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,ecode := RETURNED_SQLSTATE;
    ----raise info 'point exception';

	PERFORM write_log(mon_def.node_id,mon_def.monitor_name,ecode,errmsg||' '||vStmt,module,step||' '||in_task_run_id::text,3);
  return FAILURE||':'||ecode||':'||errmsg;

end;
$$;


--
-- TOC entry 595 (class 1255 OID 56657935)
-- Name: analyzer(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.analyzer() RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
--mon_raw rp_monitor_result_raw%rowtype;
task_run RECORD;
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
vCount int:=NULL;

SUCCESS varchar(10) = 'NO ERROR';
FAILURE varchar(10) = 'ERROR';
module  varchar(100) ='analyzer';
step    varchar(100) ='analyzer';

begin
PERFORM write_log(-1,'0','analyzer_started','analyzer','step','called from analyzer',3);
select count(*) into vCount from pg_stat_activity where application_name='123Analyzer';
raise info 'vcount: %', vCount;
if vCount > 0 then 
	return SUCCESS;
end if;

set application_name to '123Analyzer';
-- get list of task_run_id to handle
for task_run in select distinct task_run_id,date_created from app_123monitor.rp_monitor_result_raw 
where ind_analyzed is null order by date_created limit 1000
loop
	raise info 'loop';
	update app_123monitor.rp_monitor_result_raw set ind_analyzed ='R' where task_run_id=task_run.task_run_id;
	perform app_123monitor.analyze_monitor_result_raw(task_run.task_run_id);
end loop;

set application_name = '';
--PERFORM write_log(-1,'0','analyzer_finished','analyzer','step','called from analyzer',3);
raise info 'ended analyzer :%s',clock_timestamp();

return SUCCESS;
exception
    when others then
     GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
                              ecode := RETURNED_SQLSTATE;
       raise info 'errmsg %',errmsg;
      PERFORM write_log(-1,ecode,errmsg,module,step,'test',3);
  return FAILURE;

end;
$$;


--
-- TOC entry 590 (class 1255 OID 53224994)
-- Name: analyzer_with_time(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.analyzer_with_time() RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
--mon_raw rp_monitor_result_raw%rowtype;
task_run RECORD;
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
vCount int:=NULL;

SUCCESS varchar(10) = 'NO ERROR';
FAILURE varchar(10) = 'ERROR';
module  varchar(100) ='analyzer';
step    varchar(100) ='analyzer';

last_time timestamp;
current__time timestamp;
start__time timestamp;
time_diff numeric;

begin
raise info 'start';
select clock_timestamp() into start__time;
PERFORM write_log(-1,'0','analyzer_started','analyzer','step','called from analyzer',3);
raise info '29';
select count(*) into vCount from pg_stat_activity where application_name='123Analyzer_with_time';
if vCount > 10 then
	return SUCCESS;
end if;
raise info '34';

--get time
select clock_timestamp() into last_time;
select clock_timestamp() into start__time;
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
--RAISE INFO 'select count(*) into vCount completed in % seconds.', time_diff;
last_time := current__time;

set application_name to '123Analyzer_with_time';
-- get list of task_run_id to handle
for task_run in select distinct task_run_id,date_created from app_123monitor.rp_monitor_result_raw order by date_created DESC limit 100
loop
	update app_123monitor.rp_monitor_result_raw set ind_analyzed ='R' where task_run_id=task_run.task_run_id;
	perform app_123monitor.analyze_monitor_result_raw_with_time(task_run.task_run_id);
end loop;

--get time
select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
--RAISE INFO 'perform analyze_monitor_result_raw completed in % seconds.', time_diff;
last_time := current__time;

select clock_timestamp() into current__time;
time_diff := EXTRACT(EPOCH FROM (current__time - start__time));
RAISE INFO 'perform analyzer in % seconds.', time_diff;

set application_name = '';
raise info 'ended analyzer :%s',clock_timestamp();


return SUCCESS;
exception
    when others then
     GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
                              ecode := RETURNED_SQLSTATE;
       raise info 'errmsg %',errmsg;
      PERFORM write_log(-1,ecode,errmsg,module,step,'test',3);
  return FAILURE;

end;
$$;


--
-- TOC entry 526 (class 1255 OID 16953)
-- Name: check_monitor_name_exists(integer, integer, character varying, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.check_monitor_name_exists(in_org_id integer, in_node_id integer, in_monitor_name character varying, in_type character varying) RETURNS character varying
    LANGUAGE plpgsql STABLE SECURITY DEFINER
    AS $$
DECLARE
v_curs REFCURSOR:='check_monitor_name_exists_cursor';
vCount int :=0;
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;

SUCCESS int :=0;
FAILURE varchar(10) = 'ERROR';
module  varchar(100) :='check_monitor_name_exists';
step    varchar(100) :=NULL;
BEGIN
--PERFORM report_procedure_call(module,'start');

if in_org_id > 0 then
	select  count(*)   into STRICT vCount
	from    app_123monitor.rp_monitors
	where   monitor_name = in_monitor_name and org_id=in_org_id and db_type=in_type;
end if;

if in_node_id > 0 then
	select  count(*)   into STRICT vCount
	from    app_123monitor.rp_monitors
	where   monitor_name = in_monitor_name and node_id=in_node_id and db_type=in_type;
end if;

if vCount >0 THEN
  return 'EXISTS';
else
  return 'DOES_NOT_EXIST';
END IF;
  exception
    when others then
     GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
                              ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
  return FAILURE;

end;
$$;


--
-- TOC entry 543 (class 1255 OID 36434961)
-- Name: check_monitor_status(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.check_monitor_status(in_node_id integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
    monitor_record RECORD;
    task_log_count INT;
    result_raw_count INT;
    alert_count INT;
    alert_detail_count INT;
    timeline_chunks_count INT;
BEGIN
	RAISE INFO 'MONITOR NAME,TASK ID,TASK LOG COUNT,RESULT RAW COUNT,ALERT COUNT,ALERT DETAIL COUNT,timeline_chunks_count'; 
    FOR monitor_record IN
        SELECT task_id, monitor_name 
        FROM public."clusterCore_task" cct 
        WHERE target_id = in_node_id AND monitor_name IS NOT NULL 
        GROUP BY task_id, monitor_name
    LOOP
        task_log_count := NULL;
        result_raw_count := NULL;
        alert_count := NULL;
        alert_detail_count := NULL;
        timeline_chunks_count := NULL;

        IF monitor_record.task_id IS NOT NULL THEN
            SELECT COUNT(*) INTO task_log_count
            FROM public."clusterCore_tasklog" cct2 
            WHERE cct2.task_id = monitor_record.task_id;
        END IF;

        IF monitor_record.task_id IS NOT NULL THEN
            SELECT COUNT(*) INTO result_raw_count
            FROM app_123monitor.rp_monitor_result_raw rmrr 
            WHERE rmrr.node_id = in_node_id AND rmrr.task_id = monitor_record.task_id;
        END IF;

        SELECT COUNT(*) INTO alert_count
        FROM app_123monitor.rp_alert ra 
        WHERE ra.node_id = in_node_id AND ra.monitor_name = monitor_record.monitor_name;

        IF alert_count > 0 THEN
            SELECT COUNT(*) INTO alert_detail_count
            FROM app_123monitor.rp_alert_detail rad 
            WHERE rad.alert_id IN (
                SELECT alert_id 
                FROM app_123monitor.rp_alert ra 
                WHERE ra.node_id = in_node_id AND ra.monitor_name = monitor_record.monitor_name
            );
        END IF;

        SELECT COUNT(*) INTO timeline_chunks_count
        FROM app_123monitor.rp_timeline_chunks rtc 
        WHERE rtc.node_id = in_node_id AND rtc.timeline_name = monitor_record.monitor_name;

        RAISE INFO '%, %, %, %, %, %, %', 
            monitor_record.monitor_name, 
            monitor_record.task_id, 
            task_log_count, 
            result_raw_count, 
            alert_count, 
            alert_detail_count, 
            timeline_chunks_count;
    END LOOP;
END;
$$;


--
-- TOC entry 528 (class 1255 OID 16954)
-- Name: create_host_monitor(integer, integer, integer, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.create_host_monitor(in_org_id integer, in_host_id integer, created_by integer, in_db_type character varying) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS varchar(1000):='';
FAILURE varchar(1000):='Error';
module  varchar(100) :='create_host_monitor';
step    varchar(100) :=NULL;
host_json json;
params json;
task_name varchar(100):='monitor_task';
--in_db_type varchar(100) :='LINUX';
task_record record;

BEGIN
--select "type" from public."clusterCore_c123_host" where id = in_host_id into in_db_type;

step:='insert host thresholds';
insert into app_123monitor.rp_monitors (
org_id,
node_id,
db_type,
monitor_name,
monitor_description,
pre_script,
monitor_script,
ind_enabled,
red_rule,
yellow_rule,
red_rule_message,
yellow_rule_message,
ind_send_email_notifications,
monitor_interval,
runtime_red_threshold,
runtime_yellow_threshold,
return_code_threshold,
ind_status_graph,
ind_create_timeline,
ind_timeline_full_impact,
cmd_type,
ind_first_column_unique,
ind_alert_on_added_missing,
alert_on_added_missing_severity,
ind_alert_compare_to_previous_check,
alert_compare_to_previous_check_severity,
alert_compare_to_previous_check_higher_lower,
alert_compare_to_previous_check_percent,
ind_break_long_running,
ind_compute_baseline,
data_reduction_function,
renew_alert_every,
ind_red_by_row_count,
red_by_row_count_option,
red_by_row_count_items,
ind_yellow_by_row_count,
yellow_by_row_count_option,
yellow_by_row_count_items,
graph_aggregation,
graph_aggregation_column,
snoozed_until,
count_long_running,
ind_broken,
num_weeks_in_baseline,
task_id)
select 	
		org_id,
in_host_id,
db_type,
monitor_name,
monitor_description,
pre_script,
monitor_script,
ind_enabled,
red_rule,
yellow_rule,
red_rule_message,
yellow_rule_message,
ind_send_email_notifications,
monitor_interval,
runtime_red_threshold,
runtime_yellow_threshold,
return_code_threshold,
ind_status_graph,
ind_create_timeline,
ind_timeline_full_impact,
cmd_type,
ind_first_column_unique,
ind_alert_on_added_missing,
alert_on_added_missing_severity,
ind_alert_compare_to_previous_check,
alert_compare_to_previous_check_severity,
alert_compare_to_previous_check_higher_lower,
alert_compare_to_previous_check_percent,
ind_break_long_running,
ind_compute_baseline,
data_reduction_function,
renew_alert_every,
ind_red_by_row_count,
red_by_row_count_option,
red_by_row_count_items,
ind_yellow_by_row_count,
yellow_by_row_count_option,
yellow_by_row_count_items,
graph_aggregation,
graph_aggregation_column,
snoozed_until,
count_long_running,
ind_broken,
num_weeks_in_baseline,
task_id
from app_123monitor.rp_monitors 
where db_type=in_db_type and node_id is null;

step:='create timelines for this host';
insert into app_123monitor.rp_timelines select in_org_id,in_host_id,node_type,timeline_name,timeline_desc,ind_full_impact,ind_visible,'user defined'
from app_123monitor.rp_timelines
where node_type=in_db_type and node_id is null;

step:='create tasks for this host';
select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = in_host_id::int) h;

insert into public."clusterCore_task" (created_date,status,task,target_type,target_id,schedule,parameters,created_by_id,displayment,monitor_name, org_id) 
	select now(),'ready',task,target_type,in_host_id,schedule,jsonb_set(parameters, '{host_data}', host_json::jsonb),created_by_id,displayment,monitor_name, org_id
	from public."clusterCore_task"
	where task='monitor_task' and target_type=in_db_type and target_id is null;

step:='update monitors tasks id for this host';
for task_record in
	select task_id, monitor_name from public."clusterCore_task" t where task='monitor_task' and target_id=in_host_id and target_type=in_db_type
	loop
		update public."clusterCore_task" set parameters = jsonb_set(parameters, '{host_data}', host_json::jsonb) where task_id=task_record.task_id;
		update app_123monitor.rp_monitors m set task_id=task_record.task_id where org_id=in_org_id and node_id=in_host_id and db_type=in_db_type and monitor_name=task_record.monitor_name;
	end loop;
	
return in_host_id;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_host_id,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return in_host_id;
end;
$$;


--
-- TOC entry 587 (class 1255 OID 637398)
-- Name: create_node_monitor(integer, integer, integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.create_node_monitor(in_org_id integer, in_node_id integer, in_created_by integer) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS varchar(1000):='';
FAILURE varchar(1000):='Error';
module  varchar(100) :='create_node_monitor';
step    varchar(100) :=NULL;
node_json json;
host_json json;
params json;
task_name varchar(100):='monitor_task';
in_db_type varchar(100) :=NULL;
task_record record;

BEGIN
--PERFORM report_procedure_call(module,'start');
select "type" from public."clusterCore_c123_node" where id = in_node_id into in_db_type;

step:='insert node thresholds';
insert into app_123monitor.rp_monitors (
org_id,
node_id,
db_type,
monitor_name,
monitor_description,
pre_script,
monitor_script,
ind_enabled,
red_rule,
yellow_rule,
red_rule_message,
yellow_rule_message,
ind_send_email_notifications,
monitor_interval,
runtime_red_threshold,
runtime_yellow_threshold,
return_code_threshold,
ind_status_graph,
ind_create_timeline,
ind_timeline_full_impact,
cmd_type,
ind_first_column_unique,
ind_alert_on_added_missing,
alert_on_added_missing_severity,
ind_alert_compare_to_previous_check,
alert_compare_to_previous_check_severity,
alert_compare_to_previous_check_higher_lower,
alert_compare_to_previous_check_percent,
ind_break_long_running,
ind_compute_baseline,
data_reduction_function,
renew_alert_every,
ind_red_by_row_count,
red_by_row_count_option,
red_by_row_count_items,
ind_yellow_by_row_count,
yellow_by_row_count_option,
yellow_by_row_count_items,
graph_aggregation,
graph_aggregation_column,
snoozed_until,
count_long_running,
ind_broken,
num_weeks_in_baseline,
task_id)
select 
org_id,
in_node_id,
db_type,
monitor_name,
monitor_description,
pre_script,
monitor_script,
ind_enabled,
red_rule,
yellow_rule,
red_rule_message,
yellow_rule_message,
ind_send_email_notifications,
monitor_interval,
runtime_red_threshold,
runtime_yellow_threshold,
return_code_threshold,
ind_status_graph,
ind_create_timeline,
ind_timeline_full_impact,
cmd_type,
ind_first_column_unique,
ind_alert_on_added_missing,
alert_on_added_missing_severity,
ind_alert_compare_to_previous_check,
alert_compare_to_previous_check_severity,
alert_compare_to_previous_check_higher_lower,
alert_compare_to_previous_check_percent,
ind_break_long_running,
ind_compute_baseline,
data_reduction_function,
renew_alert_every,
ind_red_by_row_count,
red_by_row_count_option,
red_by_row_count_items,
ind_yellow_by_row_count,
yellow_by_row_count_option,
yellow_by_row_count_items,
graph_aggregation,
graph_aggregation_column,
snoozed_until,
count_long_running,
ind_broken,
num_weeks_in_baseline,
task_id
from app_123monitor.rp_monitors 
where db_type=in_db_type and node_id is null;
PERFORM write_log(in_node_id,NULL,NULL,NULL,module,step,3);

step:='create timelines for this node';
/*insert into app_123monitor.rp_timelines select in_org_id,in_node_id,node_type,timeline_name,timeline_desc,ind_full_impact,ind_visible,'user defined'
from app_123monitor.rp_timelines
where node_type=in_db_type and node_id is null;*/

step:='create tasks for this node';
select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = (node_json->>'host_id')::int) h;
raise info 'node: %', node_json;
raise info 'host: %', host_json;

insert into public."clusterCore_task" (created_date,status,task,target_type,target_id,schedule,parameters,created_by_id,displayment,monitor_name, org_id) 
select now(),'ready',task,target_type,in_node_id,schedule,jsonb_set(parameters, '{host_data}', host_json::jsonb),in_created_by,displayment,monitor_name,in_org_id
from public."clusterCore_task"
where task='monitor_task' and target_type=in_db_type and target_id is null;

step:='update monitors tasks id for this node';
for task_record in
select task_id, monitor_name from public."clusterCore_task" t where task='monitor_task' and target_id=in_node_id and target_type=in_db_type
loop
raise info '%', task_record;
update public."clusterCore_task" set parameters = jsonb_set(parameters, '{node_data}', node_json::jsonb) where task_id=task_record.task_id;
update app_123monitor.rp_monitors m set task_id=task_record.task_id where org_id=in_org_id and node_id=in_node_id and db_type=in_db_type and monitor_name=task_record.monitor_name;
end loop;

return in_node_id;
exception
    when others then
		raise info 'here';
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,NULL,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return in_node_id;
end;
$$;


--
-- TOC entry 534 (class 1255 OID 16956)
-- Name: day_stats(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.day_stats() RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode varchar(32):=NULL;
errmsg varchar(1000) :=NULL;
module  varchar(100) :='day_stats';
step    varchar(500) :=NULL;
vStart timestamp:=NULL;
vEnd timestamp:=NULL;
vLog text :='';
vOrg   int :=NULL;
vStr text:=NULL;
organizations CURSOR FOR SELECT * from organization;
rec RECORD;
monitor record;
col record;
deleted_rows int:=null;
col_counter INT;

BEGIN
    -- Capturing the function execution start time.
    SELECT statement_timestamp() INTO STRICT vStart;

    -- Iterating through each organization.
    FOR org IN organizations LOOP
        -- Iterating through each monitor associated with the organization.
        FOR monitor IN (
            SELECT * FROM app_123monitor.rp_monitors m 
            WHERE org_id = org.org_id 
            AND node_id IS NOT NULL
			AND node_id = 53
            --AND monitor_name IN ('memcheck unique', 'mongo all database sizes') -- Filtering specific monitors
        ) LOOP
            --RAISE NOTICE 'Processing monitor: % (node_id: %)', monitor.monitor_name, monitor.node_id;
            

            INSERT INTO app_123monitor.rp_alert_day 
            SELECT 
                nextval('app_123monitor.alert_day_seq'),
                node_id,
                monitor_name,
                NOW() AS date_created,
                MAX(severity),
                MAX(message),
                AVG(runtime_duration_msec),
                node_type 
            FROM app_123monitor.rp_alert a 
            WHERE monitor_name = monitor.monitor_name
                AND node_id = monitor.node_id
                AND a.date_created >= date_trunc('minute', now()) - interval '15 minutes'
  				AND a.date_created < date_trunc('minute', now())

            GROUP BY node_id, monitor_name, NOW(), node_type;


			-- !!! STEP-1: add to avg table
            vStr := 'INSERT INTO app_123monitor.rp_alert_detail_avg_day
                     SELECT 
                     currval(''app_123monitor.alert_day_seq''),
                     nextval(''app_123monitor.alert_detail_day_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'round(avg(' || col.column_name || '::numeric),1),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND a.date_created >= date_trunc(''minute'', now()) - interval ''15 minutes''
  					 AND a.date_created < date_trunc(''minute'', now())
                     GROUP BY currval(''app_123monitor.alert_day_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


			-- !!! STEP-2: add to max table
			vStr := 'INSERT INTO app_123monitor.rp_alert_detail_max_day
                     SELECT 
                     currval(''app_123monitor.alert_day_seq''),
                     nextval(''app_123monitor.alert_detail_day_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'max(' || col.column_name || '::numeric),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND a.date_created >= date_trunc(''minute'', now()) - interval ''15 minutes''
  					 AND a.date_created < date_trunc(''minute'', now())
                     GROUP BY currval(''app_123monitor.alert_day_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


			-- !!! STEP-3: add to min table
			vStr := 'INSERT INTO app_123monitor.rp_alert_detail_min_day
                     SELECT 
                     currval(''app_123monitor.alert_day_seq''),
                     nextval(''app_123monitor.alert_detail_day_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'min(' || col.column_name || '::numeric),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND a.date_created >= date_trunc(''minute'', now()) - interval ''15 minutes''
  					 AND a.date_created < date_trunc(''minute'', now())
                     GROUP BY currval(''app_123monitor.alert_day_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


        END LOOP;
    END LOOP;




select statement_timestamp() into STRICT vEnd;


step:='';
RAISE info 'completed time :%',vEnd-vStart;

  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM public.write_log(1,'','day_stats: '||vLog||chr(10)||' in '||vEnd-vStart||' seconds',module,step,1);
        RAISE NOTICE 'hour_stats error:% %', ecode, errmsg;
        PERFORM public.write_log(1,ecode,errmsg,module,step,3);

end;
$$;


--
-- TOC entry 529 (class 1255 OID 16957)
-- Name: delete_agent(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.delete_agent(in_agent_id integer) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='delete_agent';
step    varchar(100) :=NULL;
vStatus int:=null;

begin
step:='update rp_agent';
delete from app_123monitor.rp_agent where agent_id=in_agent_id;

step:='distribute_connections_to_agents';
select app_123monitor.distribute_connections_to_agents() into vStatus;
return vStatus;

return SUCCESS;
exception
	when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_agent_id,ecode,errmsg,module,step,3);
        return FAILURE;
end;
$$;


--
-- TOC entry 533 (class 1255 OID 16958)
-- Name: delete_monitor(integer, integer, character varying, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.delete_monitor(in_org_id integer, in_node_id integer, in_monitor_name character varying, in_type character varying) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='delete_monitor';
step    varchar(100) :=NULL;
vStatus varchar(10) :=null;
begin
	
if in_node_id is null then 
	create temp table tmp_monitor_node_ids as
	select target_id 
	from "clusterCore_task"
	where task_id 
	in (select task_id 
		from app_123monitor.rp_monitors 
		where monitor_name = in_monitor_name and org_id=in_org_id and db_type=in_type);
end if;
step = 'delete the monitor task for this node';
	delete from "clusterCore_task"
	where task_id
	in (select task_id 
		from app_123monitor.rp_monitors 
		where monitor_name = in_monitor_name and db_type=in_type and org_id=in_org_id and (node_id=in_node_id or in_node_id is null));
	
	delete from "clusterCore_task"
	where monitor_name = in_monitor_name and status = 'done' and target_id is null and target_type = in_type;
	 
step = 'delete the monitor columns for this node';	
select app_123monitor.delete_monitor_columns(in_org_id, in_node_id, in_monitor_name, in_type) into vStatus;
	  
	step = 'delete the monitor timelines for this node';
if in_node_id is null then 
--	delete from app_123monitor.rp_timelines where timeline_name = in_monitor_name and node_id in (select node_id from app_123monitor.rp_nodes where org_id=in_org_id);
--  delete from app_123monitor.rp_timelines where timeline_name = in_monitor_name and node_id in (select target_id from tmp_monitor_node_ids);
	drop table tmp_monitor_node_ids;
else
--    delete from app_123monitor.rp_timelines where timeline_name = in_monitor_name and node_id=in_node_id and node_type=in_type;
end if;
    step = 'delete the monitor for this node';
    delete from app_123monitor.rp_monitors where monitor_name = in_monitor_name and db_type=in_type and (node_id=in_node_id or org_id=in_org_id);
   
return SUCCESS;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_org_id,NULL,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 530 (class 1255 OID 16959)
-- Name: delete_monitor_columns(integer, integer, character varying, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.delete_monitor_columns(in_org_id integer, in_node_id integer, in_monitor_name character varying, in_type character varying) RETURNS integer
    LANGUAGE plpgsql
    AS $$
DECLARE
tmpjson json;
ecode text :=NULL;
errmsg  text :=NULL;
SUCCESS INTEGER:=0;
FAILURE INTEGER:=1;
module  text :='delete_monitor_columns';
step    text :=NULL;

begin

delete from app_123monitor.rp_monitor_columns where (node_id = in_node_id OR in_node_id IS NULL) AND node_type = in_type AND org_id = in_org_id AND monitor_name = in_monitor_name;
return SUCCESS;

exception
    when others then
      GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
      ecode := RETURNED_SQLSTATE;
      PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
      return FAILURE;
end;
$$;


--
-- TOC entry 531 (class 1255 OID 16960)
-- Name: distribute_connections_to_agents(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.distribute_connections_to_agents() RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
v_curs REFCURSOR;
c1 RECORD;
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='distribute_connections_to_agents';
step    varchar(100) :=NULL;
vCountConnections int:=null;
vCountAgents int:=null;
vCountConnectionsPerAegnt int :=null;

BEGIN
step:='get count connections running a collector';
SELECT count(*) into vCountConnections from "clusterCore_c123_node" where ind_deleted='false';

step:='get count healthy active agents';
--SELECT count(*) into vCountAgents from rp_agent where ind_active='Y' and last_update > now() - interval '1 minute';
SELECT count(*) into vCountAgents from app_123monitor.rp_agent where ind_active='Y' and last_update is not null and last_update > now() - interval '1 minute';
raise info 'agents_count %', vCountAgents;
if vCountAgents=0 then
	PERFORM write_log(-1,ecode,errmsg,module,'No agents are available',1);
	--update rp_connections set agent_ip = null,agent_port=null;
	return SUCCESS;
end if;

vCountConnectionsPerAegnt = ceil(vCountConnections/vCountAgents);

update "clusterCore_c123_node" set agent_id = null;

step:='allocate each agent a vCountConnectionsPerAegnt connections ';
for c1 in (SELECT * from app_123monitor.rp_agent where IND_active='Y' and last_update is not null and last_update > now() - interval '1 minute') loop 
	update "clusterCore_c123_node" set agent_id = c1.agent_id
	where id in (select id from "clusterCore_c123_node" where ind_deleted='false' and agent_id is null order by id limit vCountConnectionsPerAegnt);
end loop;
return SUCCESS;
exception
	when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        --open v_curs for EXECUTE 'SELECT $1 ,$2 ' using ecode ,errmsg;
        return FAILURE;
end;
$_$;


--
-- TOC entry 569 (class 1255 OID 16961)
-- Name: get_agent_connections(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_agent_connections(in_agent_id integer) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
 v_curs REFCURSOR:='get_agent_connections_cursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_agent_connections';
step    varchar(100) :=NULL;

BEGIN
step:='select from "clusterCore_c123_node"';

--open v_curs for select app_123monitor.get_node_display_name(in_agent_id) from "clusterCore_c123_node" where agent_id = in_agent_id;

open v_curs for select case 
			when n."type" like 'ORACLE%' then n."type"||' '||n."name"||'@'||(select "name" from "clusterCore_c123_host" where id=n.host_id)||':'||n.port
			else (select "type"||' '||"name" from "clusterCore_c123_host" where id=n.host_id)||':'||n.port 
		end as display_name
	from "clusterCore_c123_node" n where agent_id = in_agent_id;
return v_curs;

exception
	when others then
		GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_agent_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
	return v_curs;
end;
$_$;


--
-- TOC entry 535 (class 1255 OID 16962)
-- Name: get_agents(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_agents() RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
 v_curs REFCURSOR:='get_agents_cursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_agents';
step    varchar(100) :=NULL;

BEGIN
step:='select from rp_agents';
open v_curs for 
	SELECT agent_id, ip,agent_key,last_update "Last heartbeat",ind_active, 
	CASE
           WHEN last_update<now()-interval '1 minute' or last_update is null THEN 'Agent is down'
           WHEN last_update<now()-interval '10 seconds' THEN 'No heartbean in the last 10 seconds'
          else	 'Agent is ok'
    END status_text,
    CASE
          WHEN last_update<now()-interval '1 minute'  or last_update is null THEN 'red'
          WHEN last_update<now()-interval '10 seconds' THEN 'yellow'
          else	 'blue'
    END status_color, role , ind_default 
	FROM app_123monitor.rp_agent;
return v_curs;

  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
  return v_curs;
end;
$_$;


--
-- TOC entry 536 (class 1255 OID 16963)
-- Name: get_agents_graph(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_agents_graph(ind_interval integer) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
v_curs refcursor:='get_agents_graph_cursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
module  varchar(100) :='get_agents_graph';
step    varchar(100) :=NULL;
vMinutes int	:=0;

BEGIN
	vMinutes:=36000000;

	step:='select from clusterCore_tasklog';
	open v_curs for 
	select 	count(distinct(task_log_id)) "Total monitors",date_trunc('minute',created_date) "Time" 
    from 	"clusterCore_tasklog" 
    where 	date_trunc('minute',created_date) > (current_timestamp - (vMinutes || 'minutes')::INTERVAL) and 
    		date_trunc('minute',created_date) < (current_timestamp - (1 || 'minutes')::INTERVAL)
    group by date_trunc('minute',created_date)
    order by date_trunc('minute',created_date)  ;
   
	return v_curs;
  exception
    when others then
     GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
                              ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
         open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
  return v_curs;

END;
$_$;


--
-- TOC entry 580 (class 1255 OID 16964)
-- Name: get_agents_summary(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_agents_summary() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
-- v_curs REFCURSOR:='get_agents_summary_cursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS varchar(10)='SUCCESS';
FAILURE varchar(10)='FAILURE';
module  varchar(100) :='get_agents_summary';
step    varchar(100) :=NULL;
vCountAgents	int:=null;
vCountActiveAgents	int:=null;
vCountActiveAgentsLB	int:=null;
vTotalActivity varchar(200):=null;

BEGIN
step:='get agents total acivity';
select 'Total monitors per last minute:'||count(distinct(task_log_id)) into vTotalActivity 
from "clusterCore_tasklog" where created_date >now()-interval '1 minute';

step:='get count agents';
select count (*) into vCountAgents from app_123monitor.rp_agent ra ;
if vCountAgents=0 then 
	return 'No agents configured. 
	You need to register new agents by clicking + button in order to add the agent. '||chr(10)||vTotalActivity;
end if;
raise info '1';
if vCountAgents=1 then 
	return 'Only 1 agent is configured. 
	In order to enable high availability and load balancing between the agents, please use the + button in order to add the agent. '||chr(10)||vTotalActivity;
end if;
raise info '2';

step:='get count active agents';
select count (*) into vCountActiveAgents from app_123monitor.rp_agent ra where ind_active ='Y';
if vCountActiveAgents=0 then 
	return 'No active agents. Use the check box to make an agent active. '||chr(10)||vTotalActivity;
raise info '3';

end if;
raise info '4';

step:='get count active agents in load balancer mode';
select count (*) into vCountActiveAgentsLB from app_123monitor.rp_agent ra where role ='Load Balancer';
if vCountActiveAgentsLB < 2 then 
raise info '5';
	return 'Not enough agents configured in load balancer mode. '||chr(10)||vTotalActivity;
end if;
return vCountAgents||' agents configured. '||vCountActiveAgents||' active. '||vCountActiveAgentsLB||' in load balancer mode. '||chr(10)||vTotalActivity;
  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        return FAILURE;
end;
 
$$;


--
-- TOC entry 592 (class 1255 OID 16965)
-- Name: get_alert_details(integer, integer, character varying, integer, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_alert_details(in_org_id integer, in_node_id integer, in_monitor_name character varying, in_alert_id integer, in_node_type character varying) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE

v_curs REFCURSOR := 'get_alert_details_cursor'; 
ecode VARCHAR(32) := null;
errmsg varchar(1000) := null;
step varchar(100) := null;
module varchar(100) := 'get_alert_details';
vMinutes int	:=0;
vExist INT :=0;
vName varchar(100) := null;
vValue varchar(100) := null;
vInfo varchar(100) := null;
vStmt  varchar(1000) := null;
vCount INT:=null;  
col RECORD;
begin
	step := 'get count columns for monitor '||in_monitor_name;
--and node_id = in_node_id
if in_node_id is not null then
	select count (*) into vCount from app_123monitor.rp_monitor_columns rmc where org_id = in_org_id and monitor_name = in_monitor_name and node_type = in_node_type;
	if vCount =0 or vCount >10 then 
		errmsg = 'count columns for monitor is '||vCount;
		PERFORM write_log(-1,ecode,errmsg,module,step,3); 
		open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
		return v_curs;
	end if;
else
	select count (*) into vCount from app_123monitor.rp_monitor_columns rmc where org_id = in_org_id and monitor_name = in_monitor_name and node_type = in_node_type;
	if vCount =0 or vCount >10 then 
		errmsg = 'count columns for monitor is '||vCount;
		PERFORM write_log(-1,ecode,errmsg,module,step,3); 
		open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
		return v_curs;
	end if;
end if;

	step := 'build sql for '||in_monitor_name;
	vStmt = 'select app_123monitor.get_color(severity) "color"';
if in_node_id is not null then
	for col in (select * from app_123monitor.rp_monitor_columns rmc where org_id = in_org_id and monitor_name = in_monitor_name and node_type = in_node_type) loop 
		raise info 'display name:%',col.display_name;
		vStmt := vStmt||','||col.column_name||' as "'||col.display_name||'"';
	end loop;
else
	for col in (select * from app_123monitor.rp_monitor_columns rmc where org_id = in_org_id and monitor_name = in_monitor_name and node_type = in_node_type) loop 
		raise info 'display name:%',col.display_name;
		vStmt := vStmt||','||col.column_name||' as "'||col.display_name||'"';
	end loop;
end if;
	vStmt := vStmt||',message from app_123monitor.rp_alert_detail where alert_id='||in_alert_id||' order by severity desc';
	raise info 'vStmt:%',vStmt;
	open v_curs for execute vStmt using in_alert_id;
	return v_curs; 
	 
execute vStmt;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        errmsg := errmsg||' input parameters: in_alert_id = '||in_alert_id;
        PERFORM write_log(in_org_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
    return v_curs;
end;
$_$;


--
-- TOC entry 597 (class 1255 OID 56670157)
-- Name: get_alert_details_new(character varying, integer, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_alert_details_new(in_monitor_name character varying, in_alert_id integer, in_node_type character varying) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE

v_curs REFCURSOR := 'get_alert_details_cursor'; 
ecode VARCHAR(32) := null;
errmsg varchar(1000) := null;
step varchar(100) := null;
module varchar(100) := 'get_alert_details';
vMinutes int	:=0;
vExist INT :=0;
vName varchar(100) := null;
vValue varchar(100) := null;
vInfo varchar(100) := null;
vStmt  varchar(1000) := null;
vCount INT:=null;  
col RECORD;
begin
	step := 'get count columns for monitor '||in_monitor_name;
--and node_id = in_node_id

step := 'build sql for '||in_monitor_name;
vStmt = 'select app_123monitor.get_color(severity) "color"';

for col in (select * from app_123monitor.rp_monitor_columns rmc where monitor_name = in_monitor_name and node_type = in_node_type) loop 
	raise info 'display name:%',col.display_name;
	vStmt := vStmt||','||col.column_name||' as "'||col.display_name||'"';
end loop;

vStmt := vStmt||',message from app_123monitor.rp_alert_detail where alert_id='||in_alert_id||' order by severity desc';
raise info 'vStmt:%',vStmt;
open v_curs for execute vStmt using in_alert_id;
return v_curs; 
	 
execute vStmt;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        errmsg := errmsg||' input parameters: in_alert_id = '||in_alert_id;
        PERFORM write_log(in_org_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
    return v_curs;
end;
$_$;


--
-- TOC entry 537 (class 1255 OID 16966)
-- Name: get_alert_history(integer, character varying, character varying, integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_alert_history(in_node_id integer, in_monitor_name character varying, in_node_type character varying, ind_interval integer) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE

  v_curs REFCURSOR:='get_alert_history_cursor';
  ecode VARCHAR(32) := null;
  errmsg varchar(1000) := null;
  step varchar(100) := null; 
  module varchar(100) := 'get_alert_history';
  vMinutes int	:=0;
  vExist INT :=0;
  vName varchar(100) := null;
  vValue varchar(100) := null;
  vInfo varchar(100) := null;
 
BEGIN

  vMinutes:=app_123monitor.get_minutes_by_interval(ind_interval);

  open v_curs for 
 	select alert_id,
 		node_id,
 		monitor_name Monitor,
 		date_created Date,
		date_created at time zone current_setting('TIMEZONE') as date_created_with_tz,
		app_123monitor.get_color(severity),	
		message,
		runtime_duration_msec duration from app_123monitor.rp_alert a 
 	where a.node_id =in_node_id  and node_type =in_node_type and
 	monitor_name =in_monitor_name and 
 	date_created >(current_timestamp-(vMinutes ||'minutes')::INTERVAL)
 	order by date_created desc;
	return v_curs;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        errmsg := errmsg||' input parameters: in_node_id = '||in_node_id||' in_monitor_name ='||in_monitor_name||'  ind_interval ='||ind_interval;
        PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
    return v_curs;
end;
$_$;


--
-- TOC entry 599 (class 1255 OID 56687649)
-- Name: get_alerts(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_alerts() RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
--return alerts for status and layout pages
v_curs REFCURSOR := 'get_alerts_cursor'; 
ecode VARCHAR(32) := null;
errmsg varchar(1000) := null;
step varchar(100) := null;
module varchar(100) := 'get_alerts';

begin
	step := 'get alerts';
open v_curs for
  SELECT *
  FROM (
	SELECT *, date_created AT TIME ZONE current_setting('TIMEZONE') AS date_created_with_tz,
			   ROW_NUMBER() OVER (PARTITION BY monitor_name, node_id, node_type ORDER BY date_created DESC, alert_id DESC) AS rn
	FROM app_123monitor.rp_alert
   ) AS ranked
   WHERE rn = 1;						 
return v_curs;	 
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        errmsg := errmsg;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
    return v_curs;
end;
$_$;


--
-- TOC entry 538 (class 1255 OID 16967)
-- Name: get_alerts_old(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_alerts_old() RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
--return alerts for status and layout pages
v_curs REFCURSOR := 'get_alerts_cursor'; 
ecode VARCHAR(32) := null;
errmsg varchar(1000) := null;
step varchar(100) := null;
module varchar(100) := 'get_alerts';

begin
	step := 'get alerts';
open v_curs for
  SELECT *
  FROM (
	SELECT *, date_created AT TIME ZONE current_setting('TIMEZONE') AS date_created_with_tz,
			   ROW_NUMBER() OVER (PARTITION BY monitor_name, node_id, node_type ORDER BY date_created DESC, alert_id DESC) AS rn
	FROM app_123monitor.rp_alert
   ) AS ranked
   WHERE rn = 1;						 
return v_curs;	 
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        errmsg := errmsg;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
    return v_curs;
end;
$_$;


--
-- TOC entry 539 (class 1255 OID 16968)
-- Name: get_alerts_with_details(integer, character varying, character varying, integer, integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_alerts_with_details(in_node_id integer, in_monitor_name character varying, in_node_type character varying, ind_interval integer, in_org_id integer) RETURNS refcursor
    LANGUAGE plpgsql
    AS $_$
DECLARE
    alert_history_cursor REFCURSOR;
    alert_details_cursor REFCURSOR;
    alert_rec RECORD;
    detail_rec RECORD;
    detail_row JSON;
    details JSON[];
    temp_table_name TEXT; -- Variable to store the temporary table name
    v_curs REFCURSOR := 'get_alerts_with_details_cursor';
BEGIN
    -- Generate a unique name for the temporary table
    temp_table_name := 'temp_alert_details_' || gen_random_uuid();

    -- Open cursor for alert history
    SELECT app_123monitor.get_alert_history(in_node_id, in_monitor_name, in_node_type, ind_interval) INTO alert_history_cursor;

    -- Create temporary table to store results
    EXECUTE FORMAT('CREATE TEMP TABLE %I (
        alert_id INT,
        node_id INT,
        monitor VARCHAR,
        date TIMESTAMP,
        date_created_with_tz TIMESTAMP WITH TIME ZONE,
        get_color VARCHAR,
        message VARCHAR,
        duration INT,
        details JSON[]
    )', temp_table_name);

    -- Fetch each record from the cursor for alert history
    LOOP
        FETCH NEXT FROM alert_history_cursor INTO alert_rec;
        EXIT WHEN NOT FOUND;

        -- Initialize the details array for each alert record
        details := ARRAY[]::JSON[];

        -- Open cursor for alert details for the current alert
        SELECT app_123monitor.get_alert_details(in_org_id, NULL, in_monitor_name, alert_rec.alert_id, in_node_type) INTO alert_details_cursor;

        -- Fetch each detail record for the current alert
        LOOP
            FETCH NEXT FROM alert_details_cursor INTO detail_rec;
            EXIT WHEN NOT FOUND;

            -- Convert detail record to JSON and append to details array
            detail_row := row_to_json(detail_rec);
            details := details || ARRAY[detail_row];
        END LOOP;

        -- Close cursor for alert details
        CLOSE alert_details_cursor;

        -- Insert combined record into temporary table
        EXECUTE FORMAT('INSERT INTO %I VALUES ($1, $2, $3, $4, $5, $6, $7, $8, $9)', temp_table_name)
        USING alert_rec.alert_id, alert_rec.node_id, alert_rec.monitor, alert_rec.date, alert_rec.date_created_with_tz,
              alert_rec.get_color, alert_rec.message, alert_rec.duration, details;
    END LOOP;

    -- Close cursor for alert history
    CLOSE alert_history_cursor;

    -- Open cursor for the temporary table and return it
    OPEN v_curs FOR EXECUTE FORMAT('SELECT * FROM %I', temp_table_name);
    RETURN v_curs;
END;
$_$;


--
-- TOC entry 540 (class 1255 OID 16969)
-- Name: get_color(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_color(in_status integer) RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_color';
step    varchar(100) :=NULL;
 
BEGIN

case in_status
    when -2 then return 'ORANGE';
    when -1 then return 'GREEN';
    when 0 then return 'GRAY';
    when 1 then return 'GREEN';
    when 2 then return 'ORANGE';
    when 3 then return 'RED';
    else return 'GREEN';
end case;


  exception
    when others then
      GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
                                ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);

END;
$$;


--
-- TOC entry 541 (class 1255 OID 16970)
-- Name: get_conn_monitors(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_conn_monitors(in_target_id integer) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$DECLARE
 v_curs REFCURSOR  := 'mycursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_conn_monitors';
step    varchar(100) :=NULL;

BEGIN
--PERFORM report_procedure_call(module,'start');

step:='select from app_conn_monitors';
open v_curs for 
  SELECT * 
  FROM app_123monitor.app_conn_monitors o
  WHERE in_target_id = o.target_id;
return v_curs;

  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_target_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
  return v_curs;
end;
$_$;


--
-- TOC entry 567 (class 1255 OID 8639718)
-- Name: get_graph_details(integer, integer, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_graph_details(in_org_id integer, in_node_id integer, in_monitor_name character varying, in_node_type character varying, in_time_period character varying, in_column_display_name character varying) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE

v_curs REFCURSOR := 'get_graph_details_cursor'; 
ecode VARCHAR(32) := null;
errmsg varchar(1000) := null;
step varchar(100) := null;
module varchar(100) := 'get_graph_details';
col_name varchar(1000) := null;

begin
	-- return timestamp and numeric value for dashboard
	step := 'get column name';
	select column_name into col_name from app_123monitor.rp_monitor_columns mc 
	where org_id=in_org_id and monitor_name=in_monitor_name and node_type=in_node_type and display_name=in_column_display_name;

	step := 'get graph data';
	
	-- Case 1: If in_time_period is one of the valid intervals, apply the time filter
	IF in_time_period IN ('10 minutes', '1 hour', '6 hours', '1 day', '1 week') THEN
		open v_curs for
			select row_number() over(order by a.date_created desc) as index,
			column1||':'||in_column_display_name as column1,
			CASE 
				WHEN col_name = 'column1' THEN column1
				WHEN col_name = 'column2' THEN column2
				WHEN col_name = 'column3' THEN column3
				WHEN col_name = 'column4' THEN column4
				WHEN col_name = 'column5' THEN column5
				WHEN col_name = 'column6' THEN column6
				WHEN col_name = 'column7' THEN column7
				WHEN col_name = 'column8' THEN column8
				WHEN col_name = 'column9' THEN column9
				WHEN col_name = 'column10' THEN column10
		   END as col_name,
		   date_created at time zone current_setting('TIMEZONE') as dc
		   from app_123monitor.rp_alert a, app_123monitor.rp_alert_detail ad 
			where a.node_type = in_node_type 
			and a.node_id = in_node_id 
			and a.alert_id = ad.alert_id 
			and a.monitor_name = in_monitor_name
			-- Apply the time filter
			and a.date_created between now() - cast(in_time_period as interval) and now()
			order by 1, dc desc;
		
	-- Case 2: If in_time_period is invalid or empty, do not apply the time filter
	ELSE
		open v_curs for
			select row_number() over(order by a.date_created desc) as index,
			column1||':'||in_column_display_name as column1,
			CASE 
				WHEN col_name = 'column1' THEN column1
				WHEN col_name = 'column2' THEN column2
				WHEN col_name = 'column3' THEN column3
				WHEN col_name = 'column4' THEN column4
				WHEN col_name = 'column5' THEN column5
				WHEN col_name = 'column6' THEN column6
				WHEN col_name = 'column7' THEN column7
				WHEN col_name = 'column8' THEN column8
				WHEN col_name = 'column9' THEN column9
				WHEN col_name = 'column10' THEN column10
		   END as col_name,
		   date_created at time zone current_setting('TIMEZONE') as dc
		   from app_123monitor.rp_alert a, app_123monitor.rp_alert_detail ad 
			where a.node_type = in_node_type 
			and a.node_id = in_node_id 
			and a.alert_id = ad.alert_id 
			and a.monitor_name = in_monitor_name
			-- No time filter applied
			order by 1, dc desc;
	END IF;
	
	return v_curs;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        errmsg := errmsg||' input parameters: in_node_id = '||in_node_id||' in_org_id = '||in_org_id;
        PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode;
    return v_curs;
end;
$_$;


--
-- TOC entry 542 (class 1255 OID 16972)
-- Name: get_minutes_by_interval(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_minutes_by_interval(ind_interval integer) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_minutes_by_interval';
step    varchar(100) :=NULL;

BEGIN
--PERFORM report_procedure_call(module,'start');
case ind_interval
    when 0 then return 10;
    when 1 then return 60;
    when 2 then return 360;
    when 3 then return 1440;
    when 4 then return 10080;
end case;

  exception
    when others then
      GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
                                ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,NULL,ecode,errmsg,module,step,3);

END;
$$;


--
-- TOC entry 568 (class 1255 OID 16973)
-- Name: get_monitor(integer, integer, text, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_monitor(in_org_id integer, in_node_id integer, in_monitor_name text, in_type text) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
v_curs REFCURSOR:='get_monitor_cursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_monitor';
step    varchar(100) :=NULL;

BEGIN

step:='select from rp_monitors';
if in_node_id is null then
	open v_curs for 
	SELECT * 
	FROM app_123monitor.rp_monitors o 
	WHERE in_monitor_name = o.monitor_name
		AND in_org_id = o.org_id and in_type = o.db_type;
return v_curs;
else
	open v_curs for 
	SELECT * 
	FROM app_123monitor.rp_monitors o 
	WHERE in_monitor_name = o.monitor_name
		AND in_node_id = o.node_id and in_type = o.db_type;
return v_curs;
end if;

  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_org_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
  return v_curs;
end;
$_$;


--
-- TOC entry 544 (class 1255 OID 16974)
-- Name: get_monitor_column_display_name(integer, character varying, character varying, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_monitor_column_display_name(in_node_id integer, in_node_type character varying, in_monitor_name character varying, in_column_name character varying) RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
v_curs REFCURSOR:='get_monitor_column_display_name_cursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_monitor_column_display_name';
step    varchar(100) :=NULL;
vDisplayName  varchar(100) :=NULL;

BEGIN
--PERFORM report_procedure_call(module,'start');

step:='select from rp_monitor_columns';
--open v_curs for 
--SELECT display_name 
--from rp_monitor_columns 
--where node_id =in_node_id and monitor_name = in_monitor_name and column_name =in_column_name;
--return v_curs;
SELECT display_name into vDisplayName
from app_123monitor.rp_monitor_columns 
where node_id =in_node_id and monitor_name = in_monitor_name and column_name =in_column_name and node_type=in_node_type;

return vDisplayName;

  exception
    when others then
      GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
                               ecode := RETURNED_SQLSTATE;
       PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
       open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
  return v_curs;
end;
$_$;


--
-- TOC entry 549 (class 1255 OID 16975)
-- Name: get_monitor_columns(integer, character varying, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_monitor_columns(in_org_id integer, in_monitor_name character varying, in_node_type character varying) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
    v_curs REFCURSOR := 'get_monitor_columns_cursor';  -- Named cursor
    ecode VARCHAR(32) := NULL;
    errmsg VARCHAR(1000) := NULL;
    module VARCHAR(100) := 'get_monitor_columns';
    step VARCHAR(100) := NULL;

BEGIN
    -- Close the cursor if it's already in use (to prevent conflicts)
    BEGIN
        CLOSE v_curs;
    EXCEPTION
        WHEN OTHERS THEN
            -- Ignore the exception if the cursor doesn't exist yet
            NULL;
    END;

    -- Open the cursor with the required name and perform query logic
    step := 'select from rp_monitor_columns';

    IF in_monitor_name IS NULL THEN
        OPEN v_curs FOR 
        SELECT * FROM app_123monitor.rp_monitor_columns 
        WHERE org_id = in_org_id;
    ELSE
        OPEN v_curs FOR 
        SELECT * FROM app_123monitor.rp_monitor_columns 
        WHERE org_id = in_org_id 
        AND monitor_name = in_monitor_name 
        AND node_type = in_node_type;
    END IF;

    -- Return the named cursor
    RETURN v_curs;

EXCEPTION
    WHEN OTHERS THEN
        -- Handle the error, log the error details
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
                                 ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_org_id, ecode, errmsg, module, step, 3);

        -- Reraise the exception with a custom error message
        RAISE EXCEPTION 'Error occurred: %', errmsg USING ERRCODE = ecode;
END;
$$;


--
-- TOC entry 575 (class 1255 OID 44590770)
-- Name: get_monitors(integer, integer, text, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_monitors(in_org_id integer, in_node_id integer DEFAULT NULL::integer, in_node_type text DEFAULT NULL::text, in_monitor_name text DEFAULT NULL::text) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
v_curs REFCURSOR:='get_monitors_cursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_monitors';
step    varchar(100) :=NULL;

BEGIN
--PERFORM report_procedure_call(module,'start');

step:='select from rp_monitors';
if in_node_id is null then
	open v_curs for 
		SELECT * 
		FROM app_123monitor.rp_monitors o
		WHERE in_org_id = o.org_id and o.node_id is null;
	return v_curs;
else
    if in_monitor_name is null then
		open v_curs for 
			SELECT * 
			FROM app_123monitor.rp_monitors o
			WHERE in_org_id = o.org_id and in_node_id = o.node_id and in_node_type = o.db_type;
		return v_curs;
	else
	   open v_curs for 
			SELECT * 
			FROM app_123monitor.rp_monitors o
			WHERE in_org_id = o.org_id and in_node_id = o.node_id and in_node_type = o.db_type and in_monitor_name = o.monitor_name;
		return v_curs;
	end if;
	
end if;
  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
  return v_curs;
end;
$_$;


--
-- TOC entry 546 (class 1255 OID 16977)
-- Name: get_monitors_by_db_type(integer, integer, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_monitors_by_db_type(in_org_id integer, in_node_id integer, in_db_type text) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
v_curs REFCURSOR:='get_monitors_by_db_type_cursor';
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_monitors_by_db_type';
step    varchar(100) :=NULL;

BEGIN
--PERFORM report_procedure_call(module,'start');

step:='select from rp_monitors';
if in_node_id is null then
	open v_curs for 
		SELECT * 
		FROM app_123monitor.rp_monitors o
	 	where org_id=in_org_id and o.node_id in (select node_id from app_123monitor.rp_nodes where org_id=in_org_id and ind_base='Y' and db_type=in_db_type);
	return v_curs;
else
	open v_curs for 
		SELECT * 
		FROM app_123monitor.rp_monitors o
		where node_id=in_node_id and o.node_id in (select node_id from app_123monitor.rp_nodes where node_id=in_node_id and ind_base='Y' and db_type=in_db_type);
	return v_curs;
end if;
  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_org_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
  return v_curs;
end;
$_$;


--
-- TOC entry 547 (class 1255 OID 16978)
-- Name: get_node_alert_agg(integer, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_node_alert_agg(in_node_id integer, in_node_type text) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
--return alerts for status and layout pages
v_curs REFCURSOR := 'get_node_alert_agg_cursor'; 
ecode VARCHAR(32) := null;
errmsg varchar(1000) := null;
step varchar(100) := null;
module varchar(100) := 'get_node_alert_agg';

begin
step := 'get alerts for node '||in_node_id;
open v_curs for
	select string_agg(monitor_name,',') 
	from app_123monitor.rp_alert as out 
	where node_id=in_node_id and node_type = in_node_type and severity in (2,3) 
	and date_created = (select max(date_created) from app_123monitor.rp_alert where monitor_name=out.monitor_name and node_id=out.node_id and node_type=out.node_type);
return v_curs;	 
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        errmsg := errmsg;
        PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
    return v_curs;
end;
$_$;


--
-- TOC entry 593 (class 1255 OID 56670388)
-- Name: get_node_alert_severity_counts(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_node_alert_severity_counts(p_node_id integer, OUT severity_2_count integer, OUT severity_3_count integer) RETURNS record
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
    ecode VARCHAR(32) := null;
    errmsg VARCHAR(1000) := null;
    step VARCHAR(100) := null;
    module VARCHAR(100) := 'get_node_alert_severity_counts';
BEGIN
    step := 'initialize counts';
    severity_2_count := 0; 
    severity_3_count := 0;

    step := 'count severities for node_id: ' || COALESCE(p_node_id::TEXT, 'NULL');

    SELECT
        COUNT(*) FILTER (WHERE severity = 2),
        COUNT(*) FILTER (WHERE severity = 3)
    INTO
        severity_2_count, 
        severity_3_count 
    FROM
        app_123monitor.rp_alert_current rac
    WHERE
        rac.node_id = p_node_id;


EXCEPTION
    WHEN others THEN
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM app_123monitor.write_log(-1, ecode, errmsg, module, step, 3);
        severity_2_count := -1;
        severity_3_count := -1;
END;
$$;


--
-- TOC entry 548 (class 1255 OID 16979)
-- Name: get_node_alerts(integer, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_node_alerts(in_node_id integer, in_node_type text) RETURNS refcursor
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
--return alerts for status and layout pages
v_curs REFCURSOR := 'get_node_alerts_cursor'; 
ecode VARCHAR(32) := null;
errmsg varchar(1000) := null;
step varchar(100) := null;
module varchar(100) := 'get_node_alerts';

begin
step := 'get alerts for node '||in_node_id;
open v_curs for
	select * 
	from app_123monitor.rp_alert as out 
	where node_id=in_node_id and node_type = in_node_type
	and date_created = (select max(date_created) from app_123monitor.rp_alert where monitor_name=out.monitor_name and node_id=out.node_id and node_type=out.node_type);
return v_curs;	 
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        errmsg := errmsg;
        PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
        open v_curs for EXECUTE 'select $1 ,$2' using errmsg, ecode ;
    return v_curs;
end;
$_$;


--
-- TOC entry 545 (class 1255 OID 16980)
-- Name: get_node_display_name(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_node_display_name(in_agent_id integer) RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_node_display_name';
step    varchar(100) :=NULL;
vName varchar(1000):=null;

begin
step:='get node by agent_id';
select case 
			when n."type" like 'ORACLE%' then n."type"||' '||n."name"||'@'||(select "name" from "clusterCore_c123_host" where id=n.host_id)||':'||n.port
			else (select "name" from "clusterCore_c123_host" where id=n.host_id)||':'||n.port 
		end as display_name
from "clusterCore_c123_node" n into vName
where agent_id=in_agent_id;
	
return vName;
exception
	when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_agent_id,ecode,errmsg,module,step,3);
        return FAILURE;
end;
$$;


--
-- TOC entry 511 (class 1255 OID 16981)
-- Name: get_text(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_text(in_id integer) RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

vText varchar(1000):=NULL;
ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='get_text';
step    varchar(100) :=NULL;


BEGIN
--PERFORM report_procedure_call(module,'start');
select text into STRICT vText from app_123monitor.monitor_text where id=in_id;
return vText;
  exception
    when no_data_found then
        return 'No text for id:'||in_id;
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);

end;
$$;


--
-- TOC entry 600 (class 1255 OID 56690509)
-- Name: get_timeline_chunks(text, integer, text, integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.get_timeline_chunks(in_cluster_name text DEFAULT NULL::text, in_node_id integer DEFAULT NULL::integer, in_monitor_name text DEFAULT NULL::text, ind_interval integer DEFAULT NULL::integer) RETURNS refcursor
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_curs REFCURSOR := 'get_timeline_chunks_cursor';
    v_minutes INT;
    v_now TIMESTAMP := CURRENT_TIMESTAMP;
    v_start TIMESTAMP;
BEGIN
	IF ind_interval IS NULL THEN
	    RAISE EXCEPTION 'ind_interval must be provided';
	END IF;

    v_minutes := app_123monitor.get_minutes_by_interval(ind_interval);
    v_start := v_now - (v_minutes || ' minutes')::INTERVAL;

    -- DETAIL LEVEL
    /*IF in_detail_name IS NOT NULL THEN
        OPEN v_curs FOR
        SELECT rtc.*, 'd' AS param
        FROM app_123monitor.rp_timeline_chunks rtc
        JOIN app_123monitor.rp_timeline rt
          ON rt.id = rtc.timeline_id
        WHERE rt.cluster_name = in_cluster_name
          AND rt.node_id = in_node_id
          AND rt.monitor_name = in_monitor_name
          AND rt.detail_1st_column = in_detail_name
          AND rtc.to_date > v_start
        ORDER BY rtc.from_date DESC;

        RETURN v_curs;
    END IF;*/

    -- MONITOR LEVEL
	IF in_monitor_name IS NOT NULL THEN
	    OPEN v_curs FOR
	    SELECT rtc.*,
	           rt.detail_1st_column AS param
	    FROM app_123monitor.rp_timeline_chunks rtc
	    JOIN app_123monitor.rp_timeline rt
	      ON rt.id = rtc.timeline_id
	    WHERE rt.cluster_name = in_cluster_name
	      AND rt.node_id = in_node_id
	      AND rt.monitor_name = in_monitor_name
	      AND rtc.to_date > v_start
	    ORDER BY rtc.from_date DESC;
	
	    RETURN v_curs;
	END IF;

    -- NODE LEVEL
    IF in_node_id IS NOT NULL THEN
        OPEN v_curs FOR
        SELECT rtc.*, NULL AS param
        FROM app_123monitor.rp_timeline_chunks rtc
        JOIN app_123monitor.rp_timeline rt
          ON rt.id = rtc.timeline_id
        WHERE rt.cluster_name = in_cluster_name
          AND rt.node_id = in_node_id
          AND rt.monitor_name IS NULL
          AND rtc.to_date > v_start
        ORDER BY rtc.from_date DESC;

        RETURN v_curs;
    END IF;

    -- CLUSTER LEVEL
    IF in_cluster_name IS NOT NULL THEN
        OPEN v_curs FOR
        SELECT rtc.*, NULL AS param
        FROM app_123monitor.rp_timeline_chunks rtc
        JOIN app_123monitor.rp_timeline rt
          ON rt.id = rtc.timeline_id
        WHERE rt.cluster_name = in_cluster_name
          AND rt.node_id IS NULL
          AND rt.monitor_name IS NULL
          AND rtc.to_date > v_start
        ORDER BY rtc.from_date DESC;

        RETURN v_curs;
    END IF;

    -- If all parameters are NULL — return an empty cursor.
    OPEN v_curs FOR SELECT NULL::TEXT AS no_data WHERE FALSE;
    RETURN v_curs;

EXCEPTION
    WHEN OTHERS THEN
        DECLARE
            v_errmsg TEXT;
            v_sqlstate TEXT;
        BEGIN
            GET STACKED DIAGNOSTICS
                v_errmsg := MESSAGE_TEXT,
                v_sqlstate := RETURNED_SQLSTATE;

            /*PERFORM public.write_log(
                NULL, NULL, v_sqlstate, v_errmsg, 'get_timeline_chunks', NULL, 3
            );*/

            OPEN v_curs FOR SELECT v_errmsg AS error, v_sqlstate AS sqlstate;
            RETURN v_curs;
        END;
END;
$$;


--
-- TOC entry 579 (class 1255 OID 16982)
-- Name: hour_stats(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.hour_stats() RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode varchar(32):=NULL;
errmsg varchar(1000) :=NULL;
module  varchar(100) :='hour_stats';
step    varchar(500) :=NULL;
vStart timestamp:=NULL;
vEnd timestamp:=NULL;
vLog text :='';
vOrg   int :=NULL;
vStr text:=NULL;
organizations CURSOR FOR SELECT * FROM organization;
rec RECORD;
monitor RECORD;
col RECORD;
deleted_rows INT := NULL;
col_counter INT;

BEGIN
    -- Capturing the function execution start time.
    SELECT statement_timestamp() INTO STRICT vStart;

    -- Iterating through each organization.
    FOR org IN organizations LOOP
        -- Iterating through each monitor associated with the organization.
        FOR monitor IN (
            SELECT * FROM app_123monitor.rp_monitors m 
            WHERE org_id = org.org_id 
            AND node_id IS NOT NULL
			AND node_id = 53
            --AND monitor_name IN ('memcheck unique') -- Filtering specific monitors
        ) LOOP
            --RAISE NOTICE 'Processing monitor: % (node_id: %)', monitor.monitor_name, monitor.node_id;
            

            INSERT INTO app_123monitor.rp_alert_hour   
            SELECT 
                nextval('app_123monitor.alert_hour_seq'),
                node_id,
                monitor_name,
                NOW() AS date_created,
                MAX(severity),
                MAX(message),
                AVG(runtime_duration_msec),
                node_type 
            FROM app_123monitor.rp_alert a 
            WHERE monitor_name = monitor.monitor_name
                AND node_id = monitor.node_id
                AND date_created >= date_trunc('minute', NOW() - INTERVAL '1 minute') 
                AND date_created < date_trunc('minute', NOW()) 
            GROUP BY node_id, monitor_name, NOW(), node_type;


			-- !!! STEP-1: add to avg table
            vStr := 'INSERT INTO app_123monitor.rp_alert_detail_avg_hour
                     SELECT 
                     currval(''app_123monitor.alert_hour_seq''),
                     nextval(''app_123monitor.alert_detail_hour_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'round(avg(' || col.column_name || '::numeric),1),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND date_created >= date_trunc(''minute'', NOW() - INTERVAL ''1 minute'') 
                     AND date_created < date_trunc(''minute'', NOW()) 
                     GROUP BY date_trunc(''minute'', a.date_created), 
                     currval(''app_123monitor.alert_hour_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


			-- !!! STEP-2: add to max table
			vStr := 'INSERT INTO app_123monitor.rp_alert_detail_max_hour
                     SELECT 
                     currval(''app_123monitor.alert_hour_seq''),
                     nextval(''app_123monitor.alert_detail_hour_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'max(' || col.column_name || '::numeric),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND date_created >= date_trunc(''minute'', NOW() - INTERVAL ''1 minute'') 
                     AND date_created < date_trunc(''minute'', NOW()) 
                     GROUP BY date_trunc(''minute'', a.date_created), 
                     currval(''app_123monitor.alert_hour_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


			-- !!! STEP-3: add to min table
			vStr := 'INSERT INTO app_123monitor.rp_alert_detail_min_hour
                     SELECT 
                     currval(''app_123monitor.alert_hour_seq''),
                     nextval(''app_123monitor.alert_detail_hour_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'min(' || col.column_name || '::numeric),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND date_created >= date_trunc(''minute'', NOW() - INTERVAL ''1 minute'') 
                     AND date_created < date_trunc(''minute'', NOW()) 
                     GROUP BY date_trunc(''minute'', a.date_created), 
                     currval(''app_123monitor.alert_hour_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


        END LOOP;
    END LOOP;




select statement_timestamp() into STRICT vEnd;


step:='';
RAISE info 'completed time :%',vEnd-vStart;

  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM public.write_log(1,'','hour_stats: '||vLog||chr(10)||' in '||vEnd-vStart||' seconds',module,step,1);
        RAISE NOTICE 'hour_stats error:% %', ecode, errmsg;
        PERFORM public.write_log(1,ecode,errmsg,module,step,3);

end;
$$;


--
-- TOC entry 566 (class 1255 OID 16983)
-- Name: housekeeper(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.housekeeper() RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode varchar(32):=NULL;
errmsg varchar(1000) :=NULL;
module  varchar(100) :='housekeeper';
step    varchar(500) :=NULL;
vStart timestamp:=NULL;
vEnd timestamp:=NULL;
vLog text :='';
vVeryShort INTERVAL:=interval '15 minute' ;
vShort INTERVAL :=interval '1 hour';
vMed INTERVAL :=interval '1 day';
vLong  INTERVAL :=interval '1 week';
vVerLong INTERVAL:=interval '1 week';
vOrg   int :=NULL;
vStr varchar(1000):=NULL;
organizations CURSOR FOR SELECT * from organization where ind_housekeeper='Y';
rec RECORD;
deleted_rows int:=null;
monitor_task varchar(20) := 'monitor task';

BEGIN
select statement_timestamp() into STRICT vStart;

FOR org IN organizations LOOP
    vLog:=vLog||chr(10)||' Current org is '||org.org_id||
          'Short retentions is '||org.housekeeper_short_retention||' days.'||chr(10)||
          'Long retentions is '||org.housekeeper_long_retention||' days.'||chr(10);

    vOrg   :=org.org_id;

    -- clusterCore_tasksteplog will keep only the last 6 hours
    step := 'delete from clusterCore_tasksteplog for organization: '||vOrg||' with retention: '||vShort;
    DELETE from "clusterCore_tasksteplog" where task_log_id=ANY(select task_log_id from "clusterCore_tasklog" 
                                               where task_id=ANY(select task_id from "clusterCore_task" 
                                                 where schedule='NOW' and status='done' and created_date < current_timestamp-vLong));
	DELETE from "clusterCore_tasksteplog" where task_log_id=ANY(select task_log_id from "clusterCore_tasklog" 
												where task=monitor_task and created_date < current_timestamp-vLong);
	deleted_rows:=0;
    GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    vLog:=vLog||chr(10)||' "clusterCore_tasksteplog": '||deleted_rows||' deleted - time :'||clock_timestamp();

    step := 'delete from clusterCore_tasklog for organization: '||vOrg||' with retention: '||vShort;
    DELETE from "clusterCore_tasklog" where task_id=ANY(select task_id from "clusterCore_task" 
                                                  where schedule='NOW' and status='done' and created_date < current_timestamp-vLong);
	DELETE from "clusterCore_tasklog" where task=monitor_task and created_date < current_timestamp-vLong;
    deleted_rows:=0;
    GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    vLog:=vLog||chr(10)||' "clusterCore_tasklog": '||deleted_rows||' deleted - time :'||clock_timestamp();

    step := 'delete from clusterCore_task for organization: '||vOrg||' with retention: '||vShort;
    DELETE from "clusterCore_task" where schedule='NOW' and status='done' and created_date < current_timestamp-vLong;
    deleted_rows:=0;
    GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    vLog:=vLog||chr(10)||' "clusterCore_task": '||deleted_rows||' deleted - time :'||clock_timestamp();

    step := 'delete from RP_MONITOR_RESULT_RAW for organization: '||vOrg||' with retention: '||vShort;
    DELETE from app_123monitor.RP_MONITOR_RESULT_RAW where date_created < current_timestamp-vShort;
    deleted_rows:=0;
    GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    vLog:=vLog||chr(10)||'RP_MONITOR_RESULT_RAW: '||deleted_rows||' deleted - time :'||statement_timestamp();

   
    step := 'delete from RP_ALERT_DETAIL for organization: '||vOrg||' with retention: '||vLong;
    DELETE from app_123monitor.RP_ALERT_DETAIL 
   	where alert_id  in (SELECT alert_id from app_123monitor.RP_ALERT
   						where node_id in (SELECT id from "clusterCore_c123_node" where org_id=vOrg union SELECT host_id from "clusterCore_c123_node" where org_id=vOrg) 
                        and date_created < current_timestamp-vLong);
    deleted_rows:=0;
    GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    vLog:=vLog||chr(10)||'RP_ALERT: '||deleted_rows||' deleted - time :'||statement_timestamp();

    step := 'delete from RP_ALERT for organization: '||vOrg||' with retention: '||vLong;
    DELETE from app_123monitor.RP_ALERT where node_id in (SELECT id from "clusterCore_c123_node" where org_id=vOrg union SELECT host_id from "clusterCore_c123_node" where org_id=vOrg) 
                                        and date_created < current_timestamp-vLong;
    deleted_rows:=0;
    GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    vLog:=vLog||chr(10)||'RP_ALERT: '||deleted_rows||' deleted - time :'||statement_timestamp();

    step := 'delete from RP_MAIL_QUEUE for organization: '||vOrg||' with retention: '||vLong;
    DELETE from app_123monitor.RP_MAIL_QUEUE
    where (node_id in (SELECT id from "clusterCore_c123_node" where org_id=vOrg union SELECT host_id from "clusterCore_c123_node" where org_id=vOrg) or org_id=vOrg) 
                    and date_created < current_timestamp-vLong;
    deleted_rows:=0;
    GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    vLog:=vLog||chr(10)||'RP_MAIL_QUEUE: '||deleted_rows||' deleted - time :'||statement_timestamp();

    step := 'delete from RP_TIMELINE_CHUNKS for organization: '||vOrg||' with retention: '||vVerLong;
    DELETE from app_123monitor.RP_TIMELINE_CHUNKS where node_id in (SELECT id from "clusterCore_c123_node" where org_id=vOrg union SELECT host_id from "clusterCore_c123_node" where org_id=vOrg) 
                                                    and to_date < current_timestamp-vVerLong;
    deleted_rows:=0;
    GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    vLog:=vLog||chr(10)||'RP_TIMELINE_CHUNKS: '||deleted_rows||' deleted - time :'||statement_timestamp();

    -- step := 'delete from RP_MAIL_QUEUE COMPLETLY (By user request)for organization: '||vOrg;
    -- delete from app_123monitor.RP_MAIL_QUEUE where ind_sent='Y' and org_id in (SELECT org_id from organization where IND_DEL_NOTIFICATIONS='Y');
    -- deleted_rows:=0;
    -- GET DIAGNOSTICS deleted_rows:=ROW_COUNT;
    -- vLog:=vLog||chr(10)||'RP_MAIL_QUEUE: '||deleted_rows||' deleted - time :'||statement_timestamp();
end loop;
select statement_timestamp() into STRICT vEnd;

step:='';
PERFORM write_log(1,'','HouseKeeper deleted rows:'||vLog||chr(10)||' in '||vEnd-vStart ||' seconds',module,step,1);
RAISE NOTICE 'HouseKeeper deleted rows:%', vLog;
RAISE info 'completed time :%',vEnd-vStart;

  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(1,'','HouseKeeper deleted rows:'||vLog||chr(10)||' in '||vEnd-vStart||' seconds',module,step,1);
        RAISE NOTICE 'HouseKeeper error:% %', ecode, errmsg;
        PERFORM write_log(1,ecode,errmsg,module,step,3);

end;
$$;


--
-- TOC entry 551 (class 1255 OID 16984)
-- Name: insert_agent(character varying, text, character, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.insert_agent(in_agent_ip character varying, in_agent_key text, in_ind_enabled character, in_role character varying) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='insert_agent';
step    varchar(100) :=NULL;
vIndDefault char(1):='N';
vCount int:=null;
vStatus int:=null;

begin
--PERFORM report_procedure_call(module,'start');
-- if this is the first agent then make it the default
select count(*) into vCount from app_123monitor.rp_agent;
if vCount=0 then vIndDefault='Y'; end if;

step:='insert rp_agent';
insert into app_123monitor.rp_agent (ip,agent_key,last_update,ind_active,"role",ind_default) 
values (in_agent_ip,in_agent_key,null,in_ind_enabled, in_role,vIndDefault);

step:='distribute_connections_to_agents';
select app_123monitor.distribute_connections_to_agents() into vStatus;
return vStatus;

exception
	when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        return FAILURE;
end;
$$;


--
-- TOC entry 553 (class 1255 OID 16985)
-- Name: insert_monitor(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.insert_monitor(in_org_id integer, in_node_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='insert_monitor';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
--vMonitorResultRawId INTEGER := nextval('rp_monitor_result_raw_seq');
vIntervalInSeconds INTEGER :=NULL;
base_node_id integer :=NULL;
c_node_id integer :=NULL;
rec_node RECORD;
node_json json;
host_json json;
params json;
task_name varchar(100):='monitor_task';
t_id integer :=NULL;
created_by integer:=1;
vStep int:=1;
vStatus int:=null;
begin

case in_monitor_interval
  when '15 seconds' then vIntervalInSeconds = 15;
  when '1 minute' then vIntervalInSeconds = 60;
  when '5 minutes' then vIntervalInSeconds = 300;
  when '15 minutes' then vIntervalInSeconds = 900;
  when '1 hour' then vIntervalInSeconds = 3600;
  when '1 day' then vIntervalInSeconds = 86400;
end case;

step:='insert into rp_monitors';
insert into app_123monitor.rp_monitors
	values (
	  	in_org_id,
		NULL,
  		in_db_type,
  		in_monitor_name,
  		in_monitor_description,
  		in_pre_script,
  		in_monitor_script,
  		in_ind_enabled,
  		in_red_rule,
  		in_yellow_rule,
  		in_red_rule_message,
		in_yellow_rule_message,		
  		in_ind_send_email_notifications,
  		in_monitor_interval,
  		in_runtime_red_threshold,
		in_runtime_yellow_threshold,
		in_return_code_threshold,
		in_ind_status_graph,
		in_ind_create_timeline,
		in_ind_timeline_full_impact,
		in_cmd_type,
		in_ind_first_column_unique,
		in_ind_alert_on_added_missing,
		in_alert_on_added_missing_severity,
		in_ind_alert_compare_to_previous_check,
		in_alert_compare_to_previous_check_severity,
		in_alert_compare_to_previous_check_higher_lower,
		in_alert_compare_to_previous_check_percent,
		in_ind_break_long_running,
		in_ind_compute_baseline,
		in_data_reduction_function,
		in_renew_alert_every,
		in_ind_red_by_row_count,
		in_red_by_row_count_option ,
		in_red_by_row_count_items,
		in_ind_yellow_by_row_count,
		in_yellow_by_row_count_option,
		in_yellow_by_row_count_items,
		in_graph_aggregation,		
		in_graph_aggregation_column,
		null,-- snoozed_until
		null,-- count_long_running
		null,-- ind_broken
		null,-- num_weeks_in_baseline
		t_id --vJobId	
		);

step:='select from insert_monitor_columns';
-- create columns for this monitor
select app_123monitor.insert_monitor_columns (in_org_id,NULL,in_monitor_name,in_columns,in_db_type) into vStatus;
if vStatus >0 then return FAILURE; end if;
    							    
step:='insert into rp_timelines';
--create a timeline 
insert into app_123monitor.rp_timelines (org_id, 
									node_id,
    								node_type,
    								timeline_name,
    								timeline_desc,
    								ind_full_impact,
    								ind_visible,
    								category) values (
    								in_org_id,
    								NULL,
    								in_db_type, 
    								in_monitor_name,
    								in_monitor_description,
    								in_ind_timeline_full_impact,
    								'Y',
    								'user defined');
    							
--select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
--select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = (node_json->>'host_id')::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', '', 'node_data', '', 'created_by', created_by, 'org_id', in_org_id) into params;
step:='call insert_task';
select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, null, in_org_id, created_by, in_monitor_name) into t_id;

return SUCCESS;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 582 (class 1255 OID 51068998)
-- Name: insert_monitor(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.insert_monitor(in_org_id integer, in_node_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_monitor_module character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='insert_monitor';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
--vMonitorResultRawId INTEGER := nextval('rp_monitor_result_raw_seq');
vIntervalInSeconds INTEGER :=NULL;
base_node_id integer :=NULL;
c_node_id integer :=NULL;
rec_node RECORD;
node_json json;
host_json json;
params json;
task_name varchar(100):='monitor_task';
t_id integer :=NULL;
created_by integer:=1;
vStep int:=1;
vStatus int:=null;
begin

case in_monitor_interval
  when '15 seconds' then vIntervalInSeconds = 15;
  when '1 minute' then vIntervalInSeconds = 60;
  when '5 minutes' then vIntervalInSeconds = 300;
  when '15 minutes' then vIntervalInSeconds = 900;
  when '1 hour' then vIntervalInSeconds = 3600;
  when '1 day' then vIntervalInSeconds = 86400;
end case;

step:='insert into rp_monitors';
insert into app_123monitor.rp_monitors
	values (
	  	in_org_id,
		NULL,
  		in_db_type,
  		in_monitor_name,
  		in_monitor_description,
  		in_pre_script,
  		in_monitor_script,
  		in_ind_enabled,
  		in_red_rule,
  		in_yellow_rule,
  		in_red_rule_message,
		in_yellow_rule_message,		
  		in_ind_send_email_notifications,
  		in_monitor_interval,
  		in_runtime_red_threshold,
		in_runtime_yellow_threshold,
		in_return_code_threshold,
		in_ind_status_graph,
		in_ind_create_timeline,
		in_ind_timeline_full_impact,
		in_cmd_type,
		in_ind_first_column_unique,
		in_ind_alert_on_added_missing,
		in_alert_on_added_missing_severity,
		in_ind_alert_compare_to_previous_check,
		in_alert_compare_to_previous_check_severity,
		in_alert_compare_to_previous_check_higher_lower,
		in_alert_compare_to_previous_check_percent,
		in_ind_break_long_running,
		in_ind_compute_baseline,
		in_data_reduction_function,
		in_renew_alert_every,
		in_ind_red_by_row_count,
		in_red_by_row_count_option ,
		in_red_by_row_count_items,
		in_ind_yellow_by_row_count,
		in_yellow_by_row_count_option,
		in_yellow_by_row_count_items,
		in_graph_aggregation,		
		in_graph_aggregation_column,
		null,-- snoozed_until
		null,-- count_long_running
		null,-- ind_broken
		null,-- num_weeks_in_baseline
		t_id, --vJobId	
		in_monitor_module
		);

step:='select from insert_monitor_columns';
-- create columns for this monitor
select app_123monitor.insert_monitor_columns (in_org_id,NULL,in_monitor_name,in_columns,in_db_type) into vStatus;
if vStatus >0 then return FAILURE; end if;
    							    
step:='insert into rp_timelines';
/*create a timeline insert into app_123monitor.rp_timelines (org_id, 
									node_id,
    								node_type,
    								timeline_name,
    								timeline_desc,
    								ind_full_impact,
    								ind_visible,
    								category) values (
    								in_org_id,
    								NULL,
    								in_db_type, 
    								in_monitor_name,
    								in_monitor_description,
    								in_ind_timeline_full_impact,
    								'Y',
    								'user defined');*/
    							
--select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
--select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = (node_json->>'host_id')::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', '', 'node_data', '', 'created_by', created_by, 'org_id', in_org_id) into params;
step:='call insert_task';
select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, null, in_org_id, created_by, in_monitor_name) into t_id;

return SUCCESS;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,NULL,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 552 (class 1255 OID 16987)
-- Name: insert_monitor_columns(integer, integer, character varying, json, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.insert_monitor_columns(in_org_id integer, in_node_id integer, in_monitor_name character varying, in_columns json, in_type character varying) RETURNS integer
    LANGUAGE plpgsql
    AS $$
DECLARE
tmpjson json;
ecode text :=NULL;
errmsg  text :=NULL;
SUCCESS INTEGER:=0;
FAILURE INTEGER:=1;
module  text :='insert_monitor_columns';
step    text :=NULL;

begin


tmpjson:=in_columns->>'column1';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column1',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column2';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column2',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column3';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column3',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column4';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column4',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column5';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column5',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column6';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column6',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column7';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column7',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column8';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column8',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column9';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column9',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

tmpjson:=in_columns->>'column10';
if tmpjson->>'displayName' !='' then
	insert into app_123monitor.rp_monitor_columns values (in_org_id,in_node_id,in_monitor_name,'column10',tmpjson->>'displayName',tmpjson->>'type', in_type);
end if;

return SUCCESS;

exception
    when others then
      GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
      ecode := RETURNED_SQLSTATE;
      PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
      return FAILURE;
end;
$$;


--
-- TOC entry 565 (class 1255 OID 16988)
-- Name: insert_monitor_host(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.insert_monitor_host(in_org_id integer, in_host_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='insert_monitor_host1';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
vIntervalInSeconds INTEGER :=NULL;
base_node_id integer :=NULL;
c_node_id integer :=NULL;
rec_node RECORD;
host_json json;
params json;
task_name varchar(100):='monitor_task';
t_id integer :=NULL;
created_by integer:=1;
vStep int:=1;
vStatus int:=null;
begin
PERFORM write_log(in_host_id,in_monitor_name,'insert_monitor_host_started','insert_monitor_host','step','called from insert_monitor_host',3);

case in_monitor_interval
  when '15 Seconds' then vIntervalInSeconds = 15;
  when '1 Minute' then vIntervalInSeconds = 60;
  when '5 Minutes' then vIntervalInSeconds = 300;
  when '15 Minutes' then vIntervalInSeconds = 900;
  when '1 Hour' then vIntervalInSeconds = 3600;
  when '1 Day' then vIntervalInSeconds = 86400;
end case;

select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = in_host_id::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', host_json, 'node_data', '', 'created_by', created_by, 'org_id', in_org_id) into params;

select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, in_host_id, in_org_id, created_by, in_monitor_name) into t_id;

insert into app_123monitor.rp_monitors
	values (
	  	in_org_id,
		in_host_id,
  		in_db_type,
  		in_monitor_name,
  		in_monitor_description,
  		in_pre_script,
  		in_monitor_script,
  		in_ind_enabled,
  		in_red_rule,
  		in_yellow_rule,
  		in_red_rule_message,
		in_yellow_rule_message,		
  		in_ind_send_email_notifications,
  		in_monitor_interval,
  		in_runtime_red_threshold,
		in_runtime_yellow_threshold,
		in_return_code_threshold,
		in_ind_status_graph,
		in_ind_create_timeline,
		in_ind_timeline_full_impact,
		in_cmd_type,
		in_ind_first_column_unique,
		in_ind_alert_on_added_missing,
		in_alert_on_added_missing_severity,
		in_ind_alert_compare_to_previous_check,
		in_alert_compare_to_previous_check_severity,
		in_alert_compare_to_previous_check_higher_lower,
		in_alert_compare_to_previous_check_percent,
		in_ind_break_long_running,
		in_ind_compute_baseline,
		in_data_reduction_function,
		in_renew_alert_every,
		in_ind_red_by_row_count,
		in_red_by_row_count_option ,
		in_red_by_row_count_items,
		in_ind_yellow_by_row_count,
		in_yellow_by_row_count_option,
		in_yellow_by_row_count_items,
		in_graph_aggregation,		
		in_graph_aggregation_column,
		null,-- snoozed_until
		null,-- count_long_running
		null,-- ind_broken
		null,-- num_weeks_in_baseline
		t_id --vJobId
		);
    
--create a timeline 
/*insert into app_123monitor.rp_timelines (org_id, node_id,
    								node_type,
    								timeline_name,
    								timeline_desc,
    								ind_full_impact,
    								ind_visible,
    								category) values (
    								in_org_id,
    								in_host_id,
    								in_db_type, 
    								in_monitor_name,
    								in_monitor_description,
    								in_ind_timeline_full_impact,
    								'Y',
    								'user defined');*/
    								
return SUCCESS;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_host_id,in_monitor_name,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 581 (class 1255 OID 51069005)
-- Name: insert_monitor_host(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.insert_monitor_host(in_org_id integer, in_host_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_monitor_module character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='insert_monitor_host2';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
vIntervalInSeconds INTEGER :=NULL;
base_node_id integer :=NULL;
c_node_id integer :=NULL;
rec_node RECORD;
host_json json;
params json;
task_name varchar(100):='monitor_task';
t_id integer :=NULL;
created_by integer:=1;
vStep int:=1;
vStatus int:=null;
begin
PERFORM write_log(in_host_id,in_monitor_name,'insert_monitor_host_started','insert_monitor_host','step','called from insert_monitor_host',3);

case in_monitor_interval
  when '15 Seconds' then vIntervalInSeconds = 15;
  when '1 Minute' then vIntervalInSeconds = 60;
  when '5 Minutes' then vIntervalInSeconds = 300;
  when '15 Minutes' then vIntervalInSeconds = 900;
  when '1 Hour' then vIntervalInSeconds = 3600;
  when '1 Day' then vIntervalInSeconds = 86400;
end case;

select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = in_host_id::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', host_json, 'node_data', '', 'created_by', created_by, 'org_id', in_org_id) into params;

select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, in_host_id, in_org_id, created_by, in_monitor_name) into t_id;

insert into app_123monitor.rp_monitors
	values (
	  	in_org_id,
		in_host_id,
  		in_db_type,
  		in_monitor_name,
  		in_monitor_description,
  		in_pre_script,
  		in_monitor_script,
  		in_ind_enabled,
  		in_red_rule,
  		in_yellow_rule,
  		in_red_rule_message,
		in_yellow_rule_message,		
  		in_ind_send_email_notifications,
  		in_monitor_interval,
  		in_runtime_red_threshold,
		in_runtime_yellow_threshold,
		in_return_code_threshold,
		in_ind_status_graph,
		in_ind_create_timeline,
		in_ind_timeline_full_impact,
		in_cmd_type,
		in_ind_first_column_unique,
		in_ind_alert_on_added_missing,
		in_alert_on_added_missing_severity,
		in_ind_alert_compare_to_previous_check,
		in_alert_compare_to_previous_check_severity,
		in_alert_compare_to_previous_check_higher_lower,
		in_alert_compare_to_previous_check_percent,
		in_ind_break_long_running,
		in_ind_compute_baseline,
		in_data_reduction_function,
		in_renew_alert_every,
		in_ind_red_by_row_count,
		in_red_by_row_count_option ,
		in_red_by_row_count_items,
		in_ind_yellow_by_row_count,
		in_yellow_by_row_count_option,
		in_yellow_by_row_count_items,
		in_graph_aggregation,		
		in_graph_aggregation_column,
		null,-- snoozed_until
		null,-- count_long_running
		null,-- ind_broken
		null,-- num_weeks_in_baseline
		t_id, --vJobId
		in_monitor_module
		);
    
--create a timeline 
/*insert into app_123monitor.rp_timelines (org_id, node_id,
    								node_type,
    								timeline_name,
    								timeline_desc,
    								ind_full_impact,
    								ind_visible,
    								category) values (
    								in_org_id,
    								in_host_id,
    								in_db_type, 
    								in_monitor_name,
    								in_monitor_description,
    								in_ind_timeline_full_impact,
    								'Y',
    								'user defined');*/
    								
return SUCCESS;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_host_id,in_monitor_name,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 586 (class 1255 OID 16990)
-- Name: insert_monitor_node(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.insert_monitor_node(in_org_id integer, in_node_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='insert_monitor_node';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
--vMonitorResultRawId INTEGER := nextval('rp_monitor_result_raw_seq');
vIntervalInSeconds INTEGER :=NULL;
base_node_id integer :=NULL;
c_node_id integer :=NULL;
rec_node RECORD;
node_json json;
host_json json;
params json;
task_name varchar(100):='monitor_task';
t_id integer :=NULL;
created_by integer:=1;
--db_type varchar(20) :=NULL;
vStep int:=1;
vStatus int:=null;
begin

case in_monitor_interval
  when '15 seconds' then vIntervalInSeconds = 15;
  when '1 minute' then vIntervalInSeconds = 60;
  when '5 minutes' then vIntervalInSeconds = 300;
  when '15 minutes' then vIntervalInSeconds = 900;
  when '1 hour' then vIntervalInSeconds = 3600;
  when '1 day' then vIntervalInSeconds = 86400;
end case;

select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = (node_json->>'host_id')::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', host_json, 'node_data', node_json, 'created_by', created_by, 'org_id', in_org_id) into params;

select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, in_node_id, in_org_id, created_by, in_monitor_name) into t_id;

--t_id := (select max(task_id) from public."clusterCore_task" cct 
--where task=task_name 
--and target_type=db_type and target_id=in_node_id);

insert into app_123monitor.rp_monitors
	values (
	  	in_org_id,
		in_node_id,
  		in_db_type,
  		in_monitor_name,
  		in_monitor_description,
  		in_pre_script,
  		in_monitor_script,
  		in_ind_enabled,
  		in_red_rule,
  		in_yellow_rule,
  		in_red_rule_message,
		in_yellow_rule_message,		
  		in_ind_send_email_notifications,
  		in_monitor_interval,
  		in_runtime_red_threshold,
		in_runtime_yellow_threshold,
		in_return_code_threshold,
		in_ind_status_graph,
		in_ind_create_timeline,
		in_ind_timeline_full_impact,
		in_cmd_type,
		in_ind_first_column_unique,
		in_ind_alert_on_added_missing,
		in_alert_on_added_missing_severity,
		in_ind_alert_compare_to_previous_check,
		in_alert_compare_to_previous_check_severity,
		in_alert_compare_to_previous_check_higher_lower,
		in_alert_compare_to_previous_check_percent,
		in_ind_break_long_running,
		in_ind_compute_baseline,
		in_data_reduction_function,
		in_renew_alert_every,
		in_ind_red_by_row_count,
		in_red_by_row_count_option ,
		in_red_by_row_count_items,
		in_ind_yellow_by_row_count,
		in_yellow_by_row_count_option,
		in_yellow_by_row_count_items,
		in_graph_aggregation,		
		in_graph_aggregation_column,
		null,-- snoozed_until
		null,-- count_long_running
		null,-- ind_broken
		null,-- num_weeks_in_baseline
		t_id --vJobId
		);

-- create columns for this monitor
--select app_123monitor.insert_monitor_columns (in_org_id,in_node_id,in_monitor_name,in_columns) into vStatus;
--if vStatus >0 then return FAILURE; end if;
   
    								
return SUCCESS;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM public.write_log(in_node_id,in_monitor_name,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 583 (class 1255 OID 51069008)
-- Name: insert_monitor_node(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.insert_monitor_node(in_org_id integer, in_node_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_monitor_module character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='insert_monitor_node';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
--vMonitorResultRawId INTEGER := nextval('rp_monitor_result_raw_seq');
vIntervalInSeconds INTEGER :=NULL;
base_node_id integer :=NULL;
c_node_id integer :=NULL;
rec_node RECORD;
node_json json;
host_json json;
params json;
task_name varchar(100):='monitor_task';
t_id integer :=NULL;
created_by integer:=1;
--db_type varchar(20) :=NULL;
vStep int:=1;
vStatus int:=null;
begin

case in_monitor_interval
  when '15 seconds' then vIntervalInSeconds = 15;
  when '1 minute' then vIntervalInSeconds = 60;
  when '5 minutes' then vIntervalInSeconds = 300;
  when '15 minutes' then vIntervalInSeconds = 900;
  when '1 hour' then vIntervalInSeconds = 3600;
  when '1 day' then vIntervalInSeconds = 86400;
end case;

select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = (node_json->>'host_id')::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', host_json, 'node_data', node_json, 'created_by', created_by, 'org_id', in_org_id) into params;

select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, in_node_id, in_org_id, created_by, in_monitor_name) into t_id;

--t_id := (select max(task_id) from public."clusterCore_task" cct 
--where task=task_name 
--and target_type=db_type and target_id=in_node_id);

insert into app_123monitor.rp_monitors
	values (
	  	in_org_id,
		in_node_id,
  		in_db_type,
  		in_monitor_name,
  		in_monitor_description,
  		in_pre_script,
  		in_monitor_script,
  		in_ind_enabled,
  		in_red_rule,
  		in_yellow_rule,
  		in_red_rule_message,
		in_yellow_rule_message,		
  		in_ind_send_email_notifications,
  		in_monitor_interval,
  		in_runtime_red_threshold,
		in_runtime_yellow_threshold,
		in_return_code_threshold,
		in_ind_status_graph,
		in_ind_create_timeline,
		in_ind_timeline_full_impact,
		in_cmd_type,
		in_ind_first_column_unique,
		in_ind_alert_on_added_missing,
		in_alert_on_added_missing_severity,
		in_ind_alert_compare_to_previous_check,
		in_alert_compare_to_previous_check_severity,
		in_alert_compare_to_previous_check_higher_lower,
		in_alert_compare_to_previous_check_percent,
		in_ind_break_long_running,
		in_ind_compute_baseline,
		in_data_reduction_function,
		in_renew_alert_every,
		in_ind_red_by_row_count,
		in_red_by_row_count_option ,
		in_red_by_row_count_items,
		in_ind_yellow_by_row_count,
		in_yellow_by_row_count_option,
		in_yellow_by_row_count_items,
		in_graph_aggregation,		
		in_graph_aggregation_column,
		null,-- snoozed_until
		null,-- count_long_running
		null,-- ind_broken
		null,-- num_weeks_in_baseline
		t_id, --vJobId
		in_monitor_module
		);

-- create columns for this monitor
--select app_123monitor.insert_monitor_columns (in_org_id,in_node_id,in_monitor_name,in_columns) into vStatus;
--if vStatus >0 then return FAILURE; end if;
    
--create a timeline 
/*insert into app_123monitor.rp_timelines (org_id, node_id,
    								node_type,
    								timeline_name,
    								timeline_desc,
    								ind_full_impact,
    								ind_visible,
    								category) values (
    								in_org_id,
    								in_node_id,
    								in_db_type, --get_node_type(in_node_id),
    								in_monitor_name,
    								in_monitor_description,
    								in_ind_timeline_full_impact,
    								'Y',
    								'user defined');*/
    								
return SUCCESS;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM public.write_log(in_node_id,in_monitor_name,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 589 (class 1255 OID 56263434)
-- Name: print_debug(text, text, timestamp without time zone, timestamp without time zone, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.print_debug(in_module text, in_step text, in_start_time timestamp without time zone, in_prev_time timestamp without time zone, in_debug text) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
    now_time TIMESTAMP := clock_timestamp();
    total_elapsed INTERVAL;
    step_elapsed INTERVAL;
BEGIN
    IF in_debug = 'Y' THEN
        total_elapsed := now_time - in_start_time;
        step_elapsed := now_time - in_prev_time;

        RAISE INFO '% >>> MODULE: % | STEP: % | Elapsed: total=% ms, step=% ms | Time: %',
            EXTRACT(MILLISECONDS FROM step_elapsed),
			in_module,
            in_step,
            EXTRACT(MILLISECONDS FROM total_elapsed),
            EXTRACT(MILLISECONDS FROM step_elapsed),
            TO_CHAR(now_time, 'HH24:MI:SS.MS');
    END IF;
END;
$$;


--
-- TOC entry 514 (class 1255 OID 16992)
-- Name: set_agent_active(integer, character); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.set_agent_active(in_agent_id integer, in_ind_active character) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='set_agent_active';
step    varchar(100) :=NULL;
vStatus int:=null;

begin
step:='update rp_agent';
update app_123monitor.rp_agent set ind_active=in_ind_active where agent_id=in_agent_id;

step:='distribute_connections_to_agents';
select app_123monitor.distribute_connections_to_agents() into vStatus;
return vStatus;

exception
	when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_agent_id,ecode,errmsg,module,step,3);
        return FAILURE;
end;
$$;


--
-- TOC entry 554 (class 1255 OID 16993)
-- Name: set_agent_default(integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.set_agent_default(in_agent_id integer) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='set_agent_default';
step    varchar(100) :=NULL;
vStatus int:=null;
	BEGIN
	--PERFORM report_procedure_call(module,'start');
	step:='update rp_agent';

	update 	app_123monitor.rp_agent  
	set 	ind_default = 'Y'
	where 	agent_id=in_agent_id;
	
	update 	app_123monitor.rp_agent rpa 
	set 	ind_default = 'N'
	where 	agent_id!=in_agent_id;

	step:='distribute_connections_to_agents';
	select app_123monitor.distribute_connections_to_agents() into vStatus;
	return vStatus;

exception
	when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(in_agent_id,ecode,errmsg,module,step,3);
        return FAILURE;
	END;
$$;


--
-- TOC entry 550 (class 1255 OID 45907341)
-- Name: six_hours_stats(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.six_hours_stats() RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode varchar(32):=NULL;
errmsg varchar(1000) :=NULL;
module  varchar(100) :='six_hours_stats';
step    varchar(500) :=NULL;
vStart timestamp:=NULL;
vEnd timestamp:=NULL;
vLog text :='';
vOrg   int :=NULL;
vStr text:=NULL;
organizations CURSOR FOR SELECT * FROM organization;
rec RECORD;
monitor RECORD;
col RECORD;
deleted_rows INT := NULL;
col_counter INT;

BEGIN
    -- Capturing the function execution start time.
    SELECT statement_timestamp() INTO STRICT vStart;

    -- Iterating through each organization.
    FOR org IN organizations LOOP
        -- Iterating through each monitor associated with the organization.
        FOR monitor IN (
            SELECT * FROM app_123monitor.rp_monitors m 
            WHERE org_id = org.org_id 
            AND node_id IS NOT NULL
			AND node_id = 53
            --AND monitor_name IN ('memcheck unique') -- Filtering specific monitors
        ) LOOP
            --RAISE NOTICE 'Processing monitor: % (node_id: %)', monitor.monitor_name, monitor.node_id;
            

            INSERT INTO app_123monitor.rp_alert_six_hours   
            SELECT 
                nextval('app_123monitor.alert_six_hours_seq'),
                node_id,
                monitor_name,
                NOW() AS date_created,
                MAX(severity),
                MAX(message),
                AVG(runtime_duration_msec),
                node_type 
            FROM app_123monitor.rp_alert a 
            WHERE monitor_name = monitor.monitor_name
                AND node_id = monitor.node_id
                AND date_created >= date_trunc('minute', NOW() - INTERVAL '5 minutes') 
				AND date_created < date_trunc('minute', NOW())

            GROUP BY node_id, monitor_name, NOW(), node_type;


			-- !!! STEP-1: add to avg table
            vStr := 'INSERT INTO app_123monitor.rp_alert_detail_avg_six_hours
                     SELECT 
                     currval(''app_123monitor.alert_six_hours_seq''),
                     nextval(''app_123monitor.alert_detail_six_hours_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'round(avg(' || col.column_name || '::numeric),1),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND date_created >= date_trunc(''minute'', NOW() - INTERVAL ''5 minutes'') 
					 AND date_created < date_trunc(''minute'', NOW())
                     GROUP BY currval(''app_123monitor.alert_six_hours_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


			-- !!! STEP-2: add to max table
			vStr := 'INSERT INTO app_123monitor.rp_alert_detail_max_six_hours
                     SELECT 
                     currval(''app_123monitor.alert_six_hours_seq''),
                     nextval(''app_123monitor.alert_detail_six_hours_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'max(' || col.column_name || '::numeric),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND date_created >= date_trunc(''minute'', NOW() - INTERVAL ''5 minutes'') 
					 AND date_created < date_trunc(''minute'', NOW())
                     GROUP BY currval(''app_123monitor.alert_six_hours_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


			-- !!! STEP-3: add to min table
			vStr := 'INSERT INTO app_123monitor.rp_alert_detail_min_six_hours
                     SELECT 
                     currval(''app_123monitor.alert_six_hours_seq''),
                     nextval(''app_123monitor.alert_detail_six_hours_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'min(' || col.column_name || '::numeric),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND date_created >= date_trunc(''minute'', NOW() - INTERVAL ''5 minutes'') 
					 AND date_created < date_trunc(''minute'', NOW())
                     GROUP BY currval(''app_123monitor.alert_six_hours_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


        END LOOP;
    END LOOP;




select statement_timestamp() into STRICT vEnd;


step:='';
RAISE info 'completed time :%',vEnd-vStart;

  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM public.write_log(1,'','six_hours_stats: '||vLog||chr(10)||' in '||vEnd-vStart||' seconds',module,step,1);
        RAISE NOTICE 'hour_stats error:% %', ecode, errmsg;
        PERFORM public.write_log(1,ecode,errmsg,module,step,3);

end;
$$;


--
-- TOC entry 555 (class 1255 OID 16994)
-- Name: snooze_monitor(integer, character varying, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.snooze_monitor(in_node_id integer, in_monitor_name character varying, in_type character varying) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='snooze_monitor';
step    varchar(100) :=NULL;
BEGIN

	update  app_123monitor.rp_monitors set snoozed_until=current_timestamp + interval '1 day' 
	where monitor_name = in_monitor_name and node_id=in_node_id and db_type=in_type;
  
return SUCCESS;
exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 556 (class 1255 OID 16995)
-- Name: unbreak_monitor(integer, integer, character varying, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.unbreak_monitor(in_org_id integer, in_node_id integer, in_monitor_name character varying, in_type character varying) RETURNS character varying
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
mon_def app_123monitor.rp_monitors%rowtype;
--mon_raw rp_monitor_result_raw%rowtype;
--mon_raw RECORD;
--job_run_data RECORD;
--job_run_log RECORD;
--v_curs REFCURSOR;
--vCount int :=0;
ecode VARCHAR(32):=NULL;
errmsg varchar(10000) :=NULL;

SUCCESS varchar(10) = 'NO ERROR';
FAILURE varchar(10) = 'ERROR';
module  varchar(100) ='unbreak_monitor';
step    varchar(1000) ='';
--vValue numeric = null;
--vSeverity int= 1;
--vSeverity_text text= null;
--vStmt varchar(2000)= ' ';
--vAlert_id numeric=null;
--vRuntime_severity int=null;
--vMessage  varchar(1000) :=NULL;
--vCount int:=null;
--vJob_id int:=null;
BEGIN

--step= 'get the monitoring definitions for '||job_run_data.job_id;
--PERFORM write_log(-1,ecode,errmsg,module,step,3);

select * into mon_def from app_123monitor.rp_monitors rcm 	where node_id =in_node_id and db_type =in_type and monitor_name =in_monitor_name;
update app_123monitor.rp_monitors set count_long_running =0 ,ind_broken='N' where node_id =in_node_id and db_type =in_type and monitor_name =in_monitor_name;
	-- if the counter of long running times is already 10 (9 before we oncremnted it) the break the jobs
--update app_123monitor.rp_worker_jobs set ind_enabled ='Y' where job_id =mon_def.job_id ;

return SUCCESS;
exception
    when others then
     GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,ecode := RETURNED_SQLSTATE;
	PERFORM write_log(-1,ecode,errmsg,module,step,3);
  return FAILURE;

end;
$$;


--
-- TOC entry 557 (class 1255 OID 16996)
-- Name: update_agent_role(integer, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_agent_role(in_agent_id integer, in_role character varying) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='update_agent_role';
step    varchar(100) :=NULL;
vStatus int:=null;

begin
step:='update rp_agent';
update  app_123monitor.rp_agent
set     role=in_role
where   agent_id=in_agent_id;

step:='distribute_connections_to_agents';
select app_123monitor.distribute_connections_to_agents() into vStatus;
return vStatus;

exception
	when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        return FAILURE;
end;
$$;


--
-- TOC entry 558 (class 1255 OID 16997)
-- Name: update_agent_status(character varying, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_agent_status(in_agent_ip character varying, in_agent_key text) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='update_agent_status';
step    varchar(100) :=NULL;
vStatus int:=null;

begin
step:='update rp_agent';
update  app_123monitor.rp_agent
set     last_update=now()
where   ip=in_agent_ip and agent_key=in_agent_key;

step:='distribute_connections_to_agents';
--select app_123monitor.distribute_connections_to_agents() into vStatus;
return vStatus;

if not found then 
	PERFORM write_log(-1,'','unregistered agent trying to send heartbeat. agent_ip: '||in_agent_ip||' agent port: '||in_agent_port,module,step,3);
end if;
return SUCCESS;
exception
	when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(-1,ecode,errmsg,module,step,3);
        return FAILURE;
end;
$$;


--
-- TOC entry 564 (class 1255 OID 16998)
-- Name: update_monitor(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_monitor(in_org_id integer, in_node_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
 
errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='update_monitor';
task_name varchar(100):='monitor_task';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
vJobId int :=null;
vStep int:=1;
vIntervalInSeconds INTEGER :=NULL;
vStatus int:=null;
params json;
db_type_chosen varchar(20) :=NULL;
t_id integer :=NULL;
created_by integer:=1;
begin

case in_monitor_interval
  when '15 seconds' then vIntervalInSeconds = 15;
  when '1 minute' then vIntervalInSeconds = 60;
  when '5 minutes' then vIntervalInSeconds = 300;
  when '15 minutes' then vIntervalInSeconds = 900;
  when '1 hour' then vIntervalInSeconds = 3600;
  when '1 day' then vIntervalInSeconds = 86400;
end case;
 
update app_123monitor.rp_monitors 
	set monitor_name = in_monitor_name,
	red_rule = in_red_rule,
	yellow_rule = in_yellow_rule,
	ind_enabled = in_ind_enabled,
	ind_send_email_notifications = in_ind_send_email_notifications,
	monitor_description = in_monitor_description,
	monitor_script = in_monitor_script,
	runtime_red_threshold = in_runtime_red_threshold,
	runtime_yellow_threshold = in_runtime_yellow_threshold,
	return_code_threshold = in_return_code_threshold,
	monitor_interval = in_monitor_interval,
	--"module" = in_monitor_module,
	ind_status_graph = in_ind_status_graph,
	ind_create_timeline = in_ind_create_timeline,
    ind_timeline_full_impact = in_ind_timeline_full_impact,
    cmd_type = in_cmd_type,
	ind_first_column_unique = in_ind_first_column_unique,
	ind_alert_on_added_missing = in_ind_alert_on_added_missing,
	alert_on_added_missing_severity = in_alert_on_added_missing_severity,
	ind_alert_compare_to_previous_check = in_ind_alert_compare_to_previous_check,
	alert_compare_to_previous_check_severity = in_alert_compare_to_previous_check_severity,
	alert_compare_to_previous_check_higher_lower = in_alert_compare_to_previous_check_higher_lower,
	alert_compare_to_previous_check_percent = in_alert_compare_to_previous_check_percent,
	ind_break_long_running = in_ind_break_long_running,
	ind_compute_baseline = in_ind_compute_baseline,
	data_reduction_function = in_data_reduction_function,
	renew_alert_every = in_renew_alert_every,	
	ind_red_by_row_count = in_ind_red_by_row_count , 
	red_by_row_count_option = in_red_by_row_count_option,
	red_by_row_count_items = in_red_by_row_count_items,
	ind_yellow_by_row_count = in_ind_yellow_by_row_count,
	yellow_by_row_count_option = in_yellow_by_row_count_option,
	yellow_by_row_count_items = in_yellow_by_row_count_items,
	graph_aggregation = in_graph_aggregation,
	pre_script = in_pre_script,
	graph_aggregation_column = in_graph_aggregation_column,
	red_rule_message = in_red_rule_message,
	yellow_rule_message = in_yellow_rule_message
	where 
	org_id = in_org_id and 
	node_id is null and
	monitor_name = in_monitor_name and 
	db_type = in_db_type;

-- create columns for this monitor
select app_123monitor.update_monitor_columns (in_org_id,NULL,in_monitor_name,in_columns,in_db_type) into vStatus;
if vStatus >0 then return FAILURE; end if;

--select job_id into vJobId from app_123monitor.rp_monitors where node_id = in_node_id and monitor_name = in_monitor_name;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', '', 'node_data', '', 'created_by', created_by, 'org_id', in_org_id) into params;
select public.update_task(lower(in_monitor_interval), params, task_name, in_db_type, null, in_org_id, created_by, in_monitor_name) into t_id;

return SUCCESS;

exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 577 (class 1255 OID 51067219)
-- Name: update_monitor(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_monitor(in_org_id integer, in_node_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_monitor_module character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
 
errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;

module  varchar(100) :='update_monitor';
task_name varchar(100):='monitor_task';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
vJobId int :=null;
vStep int:=1;
vIntervalInSeconds INTEGER :=NULL;
vStatus int:=null;
params json;
db_type_chosen varchar(20) :=NULL;
t_id integer :=NULL;
created_by integer:=1;
begin

case in_monitor_interval
  when '15 seconds' then vIntervalInSeconds = 15;
  when '1 minute' then vIntervalInSeconds = 60;
  when '5 minutes' then vIntervalInSeconds = 300;
  when '15 minutes' then vIntervalInSeconds = 900;
  when '1 hour' then vIntervalInSeconds = 3600;
  when '1 day' then vIntervalInSeconds = 86400;
end case;
 
update app_123monitor.rp_monitors 
	set monitor_name = in_monitor_name,
	red_rule = in_red_rule,
	yellow_rule = in_yellow_rule,
	ind_enabled = in_ind_enabled,
	ind_send_email_notifications = in_ind_send_email_notifications,
	monitor_description = in_monitor_description,
	monitor_script = in_monitor_script,
	runtime_red_threshold = in_runtime_red_threshold,
	runtime_yellow_threshold = in_runtime_yellow_threshold,
	return_code_threshold = in_return_code_threshold,
	monitor_interval = in_monitor_interval,
	"module" = in_monitor_module,
	ind_status_graph = in_ind_status_graph,
	ind_create_timeline = in_ind_create_timeline,
    ind_timeline_full_impact = in_ind_timeline_full_impact,
    cmd_type = in_cmd_type,
	ind_first_column_unique = in_ind_first_column_unique,
	ind_alert_on_added_missing = in_ind_alert_on_added_missing,
	alert_on_added_missing_severity = in_alert_on_added_missing_severity,
	ind_alert_compare_to_previous_check = in_ind_alert_compare_to_previous_check,
	alert_compare_to_previous_check_severity = in_alert_compare_to_previous_check_severity,
	alert_compare_to_previous_check_higher_lower = in_alert_compare_to_previous_check_higher_lower,
	alert_compare_to_previous_check_percent = in_alert_compare_to_previous_check_percent,
	ind_break_long_running = in_ind_break_long_running,
	ind_compute_baseline = in_ind_compute_baseline,
	data_reduction_function = in_data_reduction_function,
	renew_alert_every = in_renew_alert_every,	
	ind_red_by_row_count = in_ind_red_by_row_count , 
	red_by_row_count_option = in_red_by_row_count_option,
	red_by_row_count_items = in_red_by_row_count_items,
	ind_yellow_by_row_count = in_ind_yellow_by_row_count,
	yellow_by_row_count_option = in_yellow_by_row_count_option,
	yellow_by_row_count_items = in_yellow_by_row_count_items,
	graph_aggregation = in_graph_aggregation,
	pre_script = in_pre_script,
	graph_aggregation_column = in_graph_aggregation_column,
	red_rule_message = in_red_rule_message,
	yellow_rule_message = in_yellow_rule_message
	where 
	org_id = in_org_id and 
	node_id is null and
	monitor_name = in_monitor_name and 
	db_type = in_db_type;

-- create columns for this monitor
select app_123monitor.update_monitor_columns (in_org_id,NULL,in_monitor_name,in_columns,in_db_type) into vStatus;
if vStatus >0 then return FAILURE; end if;

--select job_id into vJobId from app_123monitor.rp_monitors where node_id = in_node_id and monitor_name = in_monitor_name;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', '', 'node_data', '', 'created_by', created_by, 'org_id', in_org_id) into params;
select public.update_task(lower(in_monitor_interval), params, task_name, in_db_type, null, in_org_id, created_by, in_monitor_name) into t_id;

return SUCCESS;

exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 559 (class 1255 OID 17000)
-- Name: update_monitor_columns(integer, integer, character varying, json, character varying); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_monitor_columns(in_org_id integer, in_node_id integer, in_monitor_name character varying, in_columns json, in_type character varying) RETURNS integer
    LANGUAGE plpgsql
    AS $$
DECLARE
tmpjson json;
ecode text :=NULL;
errmsg  text :=NULL;
SUCCESS INTEGER:=0;
FAILURE INTEGER:=1;
module  text :='update_monitor_columns';
step    text :=NULL;
vStatus int:=0;

begin
step:='delete from monitor_columns';
delete from app_123monitor.rp_monitor_columns where (node_id is null or node_id = in_node_id) and node_type = in_type and org_id=in_org_id and monitor_name = in_monitor_name;

--delete from app_123monitor.rp_monitor_columns where node_id = in_node_id and node_type = in_type and org_id=in_org_id and monitor_name = in_monitor_name;
step:='insert into monitor_columns';
select app_123monitor.insert_monitor_columns(in_org_id, in_node_id, in_monitor_name, in_columns, in_type) into vStatus;
return vStatus;

exception
    when others then
      GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
      ecode := RETURNED_SQLSTATE;
      PERFORM write_log(in_node_id,ecode,errmsg,module,step,3);
      return FAILURE;
end;
$$;


--
-- TOC entry 562 (class 1255 OID 17001)
-- Name: update_monitor_host(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_monitor_host(in_org_id integer, in_host_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
 
errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='update_monitor_host';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
vJobId int :=null;
vStep int:=1;
vIntervalInSeconds INTEGER :=NULL;
vStatus int:=null;
task_name varchar(100):='monitor_task';
node_json json;
host_json json;
created_by integer:=1;
params json;
t_id integer :=NULL;
begin

delete from "clusterCore_task"
	where task_id
	in (select task_id 
	from app_123monitor.rp_monitors 
	where monitor_name = in_monitor_name and node_id=in_host_id and db_type=in_db_type);

case in_monitor_interval
  when '15 Seconds' then vIntervalInSeconds = 15;
  when '1 Minute' then vIntervalInSeconds = 60;
  when '5 Minutes' then vIntervalInSeconds = 300;
  when '15 Minutes' then vIntervalInSeconds = 900;
  when '1 Hour' then vIntervalInSeconds = 3600;
  when '1 Day' then vIntervalInSeconds = 86400;
end case;

--select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = in_host_id::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', host_json, 'node_data', '', 'created_by', created_by, 'org_id', in_org_id) into params;

select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, in_host_id, in_org_id, created_by, in_monitor_name) into t_id;
 
update app_123monitor.rp_monitors 
	set monitor_name = in_monitor_name,
	red_rule = in_red_rule,
	yellow_rule = in_yellow_rule,
	ind_enabled = in_ind_enabled,
	ind_send_email_notifications = in_ind_send_email_notifications,
	monitor_description = in_monitor_description,
	monitor_script = in_monitor_script,
	runtime_red_threshold = in_runtime_red_threshold,
	runtime_yellow_threshold = in_runtime_yellow_threshold,
	return_code_threshold = in_return_code_threshold,
	monitor_interval = in_monitor_interval,
	--"module" = in_monitor_module,
	ind_status_graph = in_ind_status_graph,
	ind_create_timeline = in_ind_create_timeline,
    ind_timeline_full_impact = in_ind_timeline_full_impact,
	ind_first_column_unique = in_ind_first_column_unique,
	ind_alert_on_added_missing = in_ind_alert_on_added_missing,
	alert_on_added_missing_severity = in_alert_on_added_missing_severity,
	ind_alert_compare_to_previous_check = in_ind_alert_compare_to_previous_check,
	alert_compare_to_previous_check_severity = in_alert_compare_to_previous_check_severity,
	alert_compare_to_previous_check_higher_lower = in_alert_compare_to_previous_check_higher_lower,
	alert_compare_to_previous_check_percent = in_alert_compare_to_previous_check_percent,
	ind_break_long_running = in_ind_break_long_running,
	ind_compute_baseline = in_ind_compute_baseline,
	data_reduction_function = in_data_reduction_function,
	renew_alert_every = in_renew_alert_every,	
	ind_red_by_row_count = in_ind_red_by_row_count , 
	red_by_row_count_option = in_red_by_row_count_option,
	red_by_row_count_items = in_red_by_row_count_items,
	ind_yellow_by_row_count = in_ind_yellow_by_row_count,
	yellow_by_row_count_option = in_yellow_by_row_count_option,
	yellow_by_row_count_items = in_yellow_by_row_count_items,
	graph_aggregation = in_graph_aggregation,
	pre_script = in_pre_script,
	graph_aggregation_column = in_graph_aggregation_column,
	red_rule_message = in_red_rule_message,
	yellow_rule_message = in_yellow_rule_message,
	cmd_type = in_cmd_type,
	task_id = t_id
	where 
	org_id = in_org_id and
	node_id = in_host_id and 
	monitor_name = in_monitor_name and 
	db_type = in_db_type; 

-- create columns for this monitor
--select app_123monitor.update_monitor_columns (in_org_id,in_node_id,in_monitor_name,in_columns) into vStatus;
--if vStatus >0 then return FAILURE; end if;

--select job_id into vJobId from app_123monitor.rp_monitors where node_id = in_node_id and monitor_name = in_monitor_name;

return SUCCESS;

exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 578 (class 1255 OID 51067216)
-- Name: update_monitor_host(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_monitor_host(in_org_id integer, in_host_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_monitor_module character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
 
errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='update_monitor_host';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
vJobId int :=null;
vStep int:=1;
vIntervalInSeconds INTEGER :=NULL;
vStatus int:=null;
task_name varchar(100):='monitor_task';
node_json json;
host_json json;
created_by integer:=1;
params json;
t_id integer :=NULL;
begin

delete from "clusterCore_task"
	where task_id
	in (select task_id 
	from app_123monitor.rp_monitors 
	where monitor_name = in_monitor_name and node_id=in_host_id and db_type=in_db_type);

case in_monitor_interval
  when '15 Seconds' then vIntervalInSeconds = 15;
  when '1 Minute' then vIntervalInSeconds = 60;
  when '5 Minutes' then vIntervalInSeconds = 300;
  when '15 Minutes' then vIntervalInSeconds = 900;
  when '1 Hour' then vIntervalInSeconds = 3600;
  when '1 Day' then vIntervalInSeconds = 86400;
end case;

--select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = in_host_id::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', host_json, 'node_data', '', 'created_by', created_by, 'org_id', in_org_id) into params;

select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, in_host_id, in_org_id, created_by, in_monitor_name) into t_id;
 
update app_123monitor.rp_monitors 
	set monitor_name = in_monitor_name,
	red_rule = in_red_rule,
	yellow_rule = in_yellow_rule,
	ind_enabled = in_ind_enabled,
	ind_send_email_notifications = in_ind_send_email_notifications,
	monitor_description = in_monitor_description,
	monitor_script = in_monitor_script,
	runtime_red_threshold = in_runtime_red_threshold,
	runtime_yellow_threshold = in_runtime_yellow_threshold,
	return_code_threshold = in_return_code_threshold,
	monitor_interval = in_monitor_interval,
	"module" = in_monitor_module,
	ind_status_graph = in_ind_status_graph,
	ind_create_timeline = in_ind_create_timeline,
    ind_timeline_full_impact = in_ind_timeline_full_impact,
	ind_first_column_unique = in_ind_first_column_unique,
	ind_alert_on_added_missing = in_ind_alert_on_added_missing,
	alert_on_added_missing_severity = in_alert_on_added_missing_severity,
	ind_alert_compare_to_previous_check = in_ind_alert_compare_to_previous_check,
	alert_compare_to_previous_check_severity = in_alert_compare_to_previous_check_severity,
	alert_compare_to_previous_check_higher_lower = in_alert_compare_to_previous_check_higher_lower,
	alert_compare_to_previous_check_percent = in_alert_compare_to_previous_check_percent,
	ind_break_long_running = in_ind_break_long_running,
	ind_compute_baseline = in_ind_compute_baseline,
	data_reduction_function = in_data_reduction_function,
	renew_alert_every = in_renew_alert_every,	
	ind_red_by_row_count = in_ind_red_by_row_count , 
	red_by_row_count_option = in_red_by_row_count_option,
	red_by_row_count_items = in_red_by_row_count_items,
	ind_yellow_by_row_count = in_ind_yellow_by_row_count,
	yellow_by_row_count_option = in_yellow_by_row_count_option,
	yellow_by_row_count_items = in_yellow_by_row_count_items,
	graph_aggregation = in_graph_aggregation,
	pre_script = in_pre_script,
	graph_aggregation_column = in_graph_aggregation_column,
	red_rule_message = in_red_rule_message,
	yellow_rule_message = in_yellow_rule_message,
	cmd_type = in_cmd_type,
	task_id = t_id
	where 
	org_id = in_org_id and
	node_id = in_host_id and 
	monitor_name = in_monitor_name and 
	db_type = in_db_type; 

-- create columns for this monitor
--select app_123monitor.update_monitor_columns (in_org_id,in_node_id,in_monitor_name,in_columns) into vStatus;
--if vStatus >0 then return FAILURE; end if;

--select job_id into vJobId from app_123monitor.rp_monitors where node_id = in_node_id and monitor_name = in_monitor_name;

return SUCCESS;

exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 576 (class 1255 OID 17003)
-- Name: update_monitor_node(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_monitor_node(in_org_id integer, in_node_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
 
errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='update_monitor_node';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
vJobId int :=null;
vStep int:=1;
vIntervalInSeconds INTEGER :=NULL;
vStatus int:=null;
task_name varchar(100):='monitor_task';
node_json json;
host_json json;
created_by integer:=1;
params json;
t_id integer :=NULL;
begin

delete from "clusterCore_task"
	where task_id
	in (select task_id 
	from app_123monitor.rp_monitors 
	where monitor_name = in_monitor_name and node_id=in_node_id and db_type=in_db_type);

case in_monitor_interval
  when '15 seconds' then vIntervalInSeconds = 15;
  when '1 minute' then vIntervalInSeconds = 60;
  when '5 minutes' then vIntervalInSeconds = 300;
  when '15 minutes' then vIntervalInSeconds = 900;
  when '1 hour' then vIntervalInSeconds = 3600;
  when '1 day' then vIntervalInSeconds = 86400;
end case;

select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = (node_json->>'host_id')::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', host_json, 'node_data', node_json, 'created_by', created_by, 'org_id', in_org_id) into params;

select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, in_node_id, in_org_id, created_by, in_monitor_name) into t_id;

update app_123monitor.rp_monitors 
	set monitor_name = in_monitor_name,
	red_rule = in_red_rule,
	yellow_rule = in_yellow_rule,
	ind_enabled = in_ind_enabled,
	ind_send_email_notifications = in_ind_send_email_notifications,
	monitor_description = in_monitor_description,
	monitor_script = in_monitor_script,
	runtime_red_threshold = in_runtime_red_threshold,
	runtime_yellow_threshold = in_runtime_yellow_threshold,
	return_code_threshold = in_return_code_threshold,
	monitor_interval = in_monitor_interval,
	--"module" = in_monitor_module,
	ind_status_graph = in_ind_status_graph,
	ind_create_timeline = in_ind_create_timeline,
    ind_timeline_full_impact = in_ind_timeline_full_impact,
	ind_first_column_unique = in_ind_first_column_unique,
	ind_alert_on_added_missing = in_ind_alert_on_added_missing,
	alert_on_added_missing_severity = in_alert_on_added_missing_severity,
	ind_alert_compare_to_previous_check = in_ind_alert_compare_to_previous_check,
	alert_compare_to_previous_check_severity = in_alert_compare_to_previous_check_severity,
	alert_compare_to_previous_check_higher_lower = in_alert_compare_to_previous_check_higher_lower,
	alert_compare_to_previous_check_percent = in_alert_compare_to_previous_check_percent,
	ind_break_long_running = in_ind_break_long_running,
	ind_compute_baseline = in_ind_compute_baseline,
	data_reduction_function = in_data_reduction_function,
	renew_alert_every = in_renew_alert_every,	
	ind_red_by_row_count = in_ind_red_by_row_count , 
	red_by_row_count_option = in_red_by_row_count_option,
	red_by_row_count_items = in_red_by_row_count_items,
	ind_yellow_by_row_count = in_ind_yellow_by_row_count,
	yellow_by_row_count_option = in_yellow_by_row_count_option,
	yellow_by_row_count_items = in_yellow_by_row_count_items,
	graph_aggregation = in_graph_aggregation,
	pre_script = in_pre_script,
	graph_aggregation_column = in_graph_aggregation_column,
	red_rule_message = in_red_rule_message,
	yellow_rule_message = in_yellow_rule_message,
	cmd_type = in_cmd_type,
	task_id = t_id
	where 
	org_id = in_org_id and
	node_id = in_node_id and 
	monitor_name = in_monitor_name and 
	db_type = in_db_type; 

-- create columns for this monitor
--select app_123monitor.update_monitor_columns (in_org_id,in_node_id,in_monitor_name,in_columns) into vStatus;
--if vStatus >0 then return FAILURE; end if;

--select job_id into vJobId from app_123monitor.rp_monitors where node_id = in_node_id and monitor_name = in_monitor_name;

return SUCCESS;

exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,in_monitor_name,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 574 (class 1255 OID 51067242)
-- Name: update_monitor_node(integer, integer, character varying, character varying, character varying, character varying, character varying, character, character varying, character varying, character varying, character varying, character, character varying, character varying, integer, integer, character varying, character, character, character, character varying, character, character, integer, character, integer, character varying, integer, character, character, character varying, character varying, character, character varying, integer, character, character varying, integer, character varying, character varying, json); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_monitor_node(in_org_id integer, in_node_id integer, in_db_type character varying, in_monitor_name character varying, in_monitor_description character varying, in_pre_script character varying, in_monitor_script character varying, in_ind_enabled character, in_red_rule character varying, in_yellow_rule character varying, in_red_rule_message character varying, in_yellow_rule_message character varying, in_ind_send_email_notifications character, in_monitor_interval character varying, in_monitor_module character varying, in_runtime_red_threshold integer, in_runtime_yellow_threshold integer, in_return_code_threshold character varying, in_ind_status_graph character, in_ind_create_timeline character, in_ind_timeline_full_impact character, in_cmd_type character varying, in_ind_first_column_unique character, in_ind_alert_on_added_missing character, in_alert_on_added_missing_severity integer, in_ind_alert_compare_to_previous_check character, in_alert_compare_to_previous_check_severity integer, in_alert_compare_to_previous_check_higher_lower character varying, in_alert_compare_to_previous_check_percent integer, in_ind_break_long_running character, in_ind_compute_baseline character, in_data_reduction_function character varying, in_renew_alert_every character varying, in_ind_red_by_row_count character, in_red_by_row_count_option character varying, in_red_by_row_count_items integer, in_ind_yellow_by_row_count character, in_yellow_by_row_count_option character varying, in_yellow_by_row_count_items integer, in_graph_aggregation character varying, in_graph_aggregation_column character varying, in_columns json) RETURNS integer
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
 
errcode VARCHAR(32):=NULL;
errmsg varchar(1000) :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar(100) :='update_monitor_node';
step    varchar(100) :=NULL;
vTemp int :=NULL;
vVal varchar(1000):=NULL;
vJobId int :=null;
vStep int:=1;
vIntervalInSeconds INTEGER :=NULL;
vStatus int:=null;
task_name varchar(100):='monitor_task';
node_json json;
host_json json;
created_by integer:=1;
params json;
t_id integer :=NULL;
begin

delete from "clusterCore_task"
	where task_id
	in (select task_id 
	from app_123monitor.rp_monitors 
	where monitor_name = in_monitor_name and node_id=in_node_id and db_type=in_db_type);

case in_monitor_interval
  when '15 seconds' then vIntervalInSeconds = 15;
  when '1 minute' then vIntervalInSeconds = 60;
  when '5 minutes' then vIntervalInSeconds = 300;
  when '15 minutes' then vIntervalInSeconds = 900;
  when '1 hour' then vIntervalInSeconds = 3600;
  when '1 day' then vIntervalInSeconds = 86400;
end case;

select (row_to_json(n)::jsonb) into node_json from (select * from public."clusterCore_c123_node" where id = in_node_id) n;
select (row_to_json(h)::jsonb) into host_json from (select * from public."clusterCore_c123_host" where id = (node_json->>'host_id')::int) h;
select json_build_object('pre_script', in_pre_script, 'cmd_type', in_cmd_type, 'cmd', in_monitor_script, 'host_data', host_json, 'node_data', node_json, 'created_by', created_by, 'org_id', in_org_id) into params;

select public.insert_task(lower(in_monitor_interval), params, task_name, in_db_type, in_node_id, in_org_id, created_by, in_monitor_name) into t_id;

update app_123monitor.rp_monitors 
	set monitor_name = in_monitor_name,
	red_rule = in_red_rule,
	yellow_rule = in_yellow_rule,
	ind_enabled = in_ind_enabled,
	ind_send_email_notifications = in_ind_send_email_notifications,
	monitor_description = in_monitor_description,
	monitor_script = in_monitor_script,
	runtime_red_threshold = in_runtime_red_threshold,
	runtime_yellow_threshold = in_runtime_yellow_threshold,
	return_code_threshold = in_return_code_threshold,
	monitor_interval = in_monitor_interval,
	"module" = in_monitor_module,
	ind_status_graph = in_ind_status_graph,
	ind_create_timeline = in_ind_create_timeline,
    ind_timeline_full_impact = in_ind_timeline_full_impact,
	ind_first_column_unique = in_ind_first_column_unique,
	ind_alert_on_added_missing = in_ind_alert_on_added_missing,
	alert_on_added_missing_severity = in_alert_on_added_missing_severity,
	ind_alert_compare_to_previous_check = in_ind_alert_compare_to_previous_check,
	alert_compare_to_previous_check_severity = in_alert_compare_to_previous_check_severity,
	alert_compare_to_previous_check_higher_lower = in_alert_compare_to_previous_check_higher_lower,
	alert_compare_to_previous_check_percent = in_alert_compare_to_previous_check_percent,
	ind_break_long_running = in_ind_break_long_running,
	ind_compute_baseline = in_ind_compute_baseline,
	data_reduction_function = in_data_reduction_function,
	renew_alert_every = in_renew_alert_every,	
	ind_red_by_row_count = in_ind_red_by_row_count , 
	red_by_row_count_option = in_red_by_row_count_option,
	red_by_row_count_items = in_red_by_row_count_items,
	ind_yellow_by_row_count = in_ind_yellow_by_row_count,
	yellow_by_row_count_option = in_yellow_by_row_count_option,
	yellow_by_row_count_items = in_yellow_by_row_count_items,
	graph_aggregation = in_graph_aggregation,
	pre_script = in_pre_script,
	graph_aggregation_column = in_graph_aggregation_column,
	red_rule_message = in_red_rule_message,
	yellow_rule_message = in_yellow_rule_message,
	cmd_type = in_cmd_type,
	task_id = t_id
	where 
	org_id = in_org_id and
	node_id = in_node_id and 
	monitor_name = in_monitor_name and 
	db_type = in_db_type; 

-- create columns for this monitor
--select app_123monitor.update_monitor_columns (in_org_id,in_node_id,in_monitor_name,in_columns) into vStatus;
--if vStatus >0 then return FAILURE; end if;

--select job_id into vJobId from app_123monitor.rp_monitors where node_id = in_node_id and monitor_name = in_monitor_name;

return SUCCESS;

exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        errcode := RETURNED_SQLSTATE;
        PERFORM write_log(in_node_id,in_monitor_name,errcode,errmsg,module,step,3);
        RAISE NOTICE '% %',errmsg,errcode;
        return FAILURE;
end;
$$;


--
-- TOC entry 598 (class 1255 OID 51246772)
-- Name: update_timeline(integer, text, integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_timeline(in_node_id integer, in_monitor_name text, in_alert_id integer) RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR:=NULL;
errmsg varchar :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar :='update_timeline';
step    varchar :=NULL;
vCount int :=null;
vDate timestamp :=NULL;
vClusterName TEXT;
vClusterID INT;
vColumn1 TEXT;
vSeverity INT;
vMessage TEXT;
vIsFirstColumnUnique CHAR;
v_start_time TIMESTAMP := clock_timestamp();
v_last_step_time TIMESTAMP := v_start_time;
v_debug TEXT;-- := 'N';


BEGIN

	SELECT value INTO v_debug
	FROM public."clusterCore_systemsettings"
	WHERE name = 'debug';

	-- 1.1. get the cluster_name by the node_id
	step := 'get the cluster_name by the node_id';

	SELECT cc.name, cc.id
    INTO vClusterName, vClusterID
    FROM public."clusterCore_c123_node" AS cn 
    JOIN public."clusterCore_c123_cluster" AS cc ON cn.cluster_id = cc.id 
    WHERE cn.id = in_node_id;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	-- 1.2. check if the monitor has a unique first column
	step := 'check if the monitor has a unique first column';

	SELECT ind_first_column_unique 
    INTO vIsFirstColumnUnique
    FROM app_123monitor.rp_monitors m
    WHERE m.node_id = in_node_id AND m.monitor_name = in_monitor_name;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	-- 2.1. detail_timeline
	step := 'add to detail_timeline';

	IF vIsFirstColumnUnique = 'Y' THEN
		FOR vColumn1, vSeverity, vMessage IN 
	        SELECT column1, severity, message
	        FROM app_123monitor.rp_alert_detail rad 
	        WHERE rad.alert_id = in_alert_id
	    LOOP
	        PERFORM app_123monitor.update_timeline_chunk(
	            vClusterName,
	            in_node_id,
	            in_monitor_name,
	            vColumn1,
	            vSeverity,
	            vMessage
	        );
	    END LOOP;
	END IF;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	-- 2.2. monitor_timeline
	step := 'add to monitor_timeline';

	SELECT severity, message
	INTO vSeverity, vMessage
	FROM app_123monitor.rp_alert a
	WHERE a.alert_id = in_alert_id;

	PERFORM app_123monitor.update_timeline_chunk(
	            vClusterName,
	            in_node_id,
	            in_monitor_name,
	            NULL,
	            vSeverity,
	            vMessage
	        );

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	-- 2.3. node_timeline
	step := 'add to node_timeline';

	/*SELECT 
	    MAX(subquery.severity),
	    SUBSTRING(string_agg(subquery.message, E'\n') FOR 300)
	INTO vSeverity, vMessage
	FROM (
	    SELECT DISTINCT ON (ra.monitor_name) ra.severity, ra.message
	    FROM app_123monitor.rp_alert ra
	    JOIN app_123monitor.rp_monitors rm 
	        ON ra.node_id = rm.node_id 
	        AND ra.monitor_name = rm.monitor_name
	    WHERE ra.node_id = in_node_id 
	      AND rm.task_id IS NOT NULL
	    ORDER BY ra.monitor_name, ra.alert_id DESC
	) subquery;*/

	SELECT 
	    MAX(severity),
	    SUBSTRING(string_agg(message, E'\n') FOR 300)
	INTO vSeverity, vMessage
	FROM app_123monitor.rp_alert_current
	WHERE node_id = in_node_id
		AND severity = (
		      SELECT MAX(severity)
		      FROM app_123monitor.rp_alert_current
		      WHERE node_id = in_node_id
		  );

	PERFORM app_123monitor.update_timeline_chunk(
	            vClusterName,
	            in_node_id,
	            NULL,
	            NULL,
	            vSeverity,
	            vMessage
	        );


	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	-- 2.4. cluster_timeline
	step := 'add to cluster_timeline';

	/*SELECT 
	    MAX(subquery.severity),
	    SUBSTRING(string_agg(subquery.message, E'\n') FOR 300)
	INTO vSeverity, vMessage
	FROM (
	    SELECT DISTINCT ON (ra.monitor_name) ra.severity, ra.message
	    FROM app_123monitor.rp_alert ra
	    JOIN app_123monitor.rp_monitors rm 
	        ON ra.node_id = rm.node_id 
	        AND ra.monitor_name = rm.monitor_name
		JOIN public."clusterCore_c123_node" cn 
        	ON ra.node_id = cn.id
	    WHERE cn.cluster_id = vClusterID
	      AND rm.task_id IS NOT NULL
	    ORDER BY ra.monitor_name, ra.alert_id DESC
	) subquery;*/

	SELECT 
	    MAX(ac.severity) AS severity,
	    SUBSTRING(string_agg(ac.message, E'\n') FOR 300) AS message
	INTO vSeverity, vMessage
	FROM app_123monitor.rp_alert_current ac
	JOIN public."clusterCore_c123_node" cn 
	    ON ac.node_id = cn.id
	WHERE cn.cluster_id = vClusterID
	  AND ac.severity = (
	      SELECT MAX(ac2.severity)
	      FROM app_123monitor.rp_alert_current ac2
	      JOIN public."clusterCore_c123_node" cn2 
	          ON ac2.node_id = cn2.id
	      WHERE cn2.cluster_id = vClusterID
	  );

	PERFORM app_123monitor.update_timeline_chunk(
	            vClusterName,
	            NULL,
	            NULL,
	            NULL,
	            vSeverity,
	            vMessage
	        );

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	EXCEPTION 
	    WHEN OTHERS THEN

	        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
	        ecode := RETURNED_SQLSTATE;
	        PERFORM write_log(in_node_id,in_monitor_name,ecode,errmsg,module,step,3);
	        RAISE info 'update_timeline % %',errmsg,ecode;
END;
$$;


--
-- TOC entry 585 (class 1255 OID 51429238)
-- Name: update_timeline_chunk(text, integer, text, text, integer, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_timeline_chunk(in_cluster_name text, in_node_id integer, in_monitor_name text, in_detail_name text, in_severity integer, in_tooltip text) RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR:=NULL;
errmsg varchar :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar :='update_timeline_chunk';
step    varchar :=NULL;
vCount int :=null;
vDate timestamp :=NULL;
vSeverity int :=0;
vTimelineID INT;
vNodeName TEXT;
vName TEXT;
v_start_time TIMESTAMP := clock_timestamp();
v_last_step_time TIMESTAMP := v_start_time;
v_debug TEXT;-- := 'N';


BEGIN    

	SELECT value INTO v_debug
	FROM public."clusterCore_systemsettings"
	WHERE name = 'debug';

	-- 1. Fetch the node name to a variable
	step := 'Fetch the node name to a variable';

	IF in_detail_name IS NULL AND in_monitor_name IS NULL THEN
        SELECT name INTO vNodeName
        FROM public."clusterCore_c123_node"
        WHERE id = in_node_id
        LIMIT 1;
    ELSE
        vNodeName := NULL;
    END IF;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	-- 2. Determine the value for name depending on the hierarchy level
	step := 'Determine the value for name depending on the hierarchy level';
	vName := COALESCE(in_detail_name, in_monitor_name, vNodeName, in_cluster_name);

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	-- 3. Check whether there is a corresponding record in the rp_timeline table
	step := 'Check whether there is a corresponding record in the rp_timeline table';

	SELECT id INTO vTimelineID
    FROM app_123monitor.rp_timeline
    WHERE (name = vName OR (name IS NULL AND vName IS NULL))
      AND (cluster_name = in_cluster_name OR (cluster_name IS NULL AND in_cluster_name IS NULL))
      AND (node_id = in_node_id OR (node_id IS NULL AND in_node_id IS NULL))
      AND (monitor_name = in_monitor_name OR (monitor_name IS NULL AND in_monitor_name IS NULL))
      AND (detail_1st_column = in_detail_name OR (detail_1st_column IS NULL AND in_detail_name IS NULL))
    LIMIT 1;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	-- 4. If the record does not exist, we create it
	step := 'Create the record in the rp_timeline table if does not exist';

	IF vTimelineID IS NULL THEN
        INSERT INTO app_123monitor.rp_timeline (
            name, date_created, cluster_name, node_id, monitor_name, detail_1st_column, impact_on_father_timeline
        ) VALUES (
            vName,
            NOW(),
            in_cluster_name,
            in_node_id,
            in_monitor_name,
            in_detail_name,
            TRUE
        )
        RETURNING id INTO vTimelineID;
    END IF;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();
	

    IF in_severity IS NULL
    THEN vSeverity=-2;
    ELSE vSeverity=in_severity;
    END IF;

    SELECT date_trunc('minute', current_timestamp)
	INTO STRICT vDate;

    -- 5. Check if the last chunk is of the received severity.
	--    If the last chunk is of the received severity then update the to_date.
	--    If not close the previous chunk and create a new one with the updates severity and tooltip.
    BEGIN
      --RAISE info 'point exception 2';
	  step := 'Check if severity is still the same for the item';
        SELECT  count(*)
        INTO STRICT vCount
        FROM    app_123monitor.rp_timeline_chunks
        WHERE   timeline_id = vTimelineID AND
                severity=vSeverity AND
                to_date= (SELECT max(to_date) FROM app_123monitor.rp_timeline_chunks WHERE timeline_id = vTimelineID);
    EXCEPTION
        WHEN no_data_found THEN
            vCount:=0;
            --RAISE info 'point exception 3';
        WHEN OTHERS THEN NULL;
    END;

	PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
	v_last_step_time := clock_timestamp();

	--RAISE info 'point exception 4';
	    IF vCount>0 then -- if the last chunk is of the received severity then update the to_date
	--RAISE info 'point exception 41';
		step := 'Update to_date to a new one, severity wan not changed';
	        UPDATE  app_123monitor.rp_timeline_chunks
	        SET     to_date= vDate
	        WHERE   timeline_id = vTimelineID AND
	                severity=vSeverity AND
	                to_date= (SELECT max(to_date) FROM app_123monitor.rp_timeline_chunks WHERE timeline_id = vTimelineID);

		PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
		v_last_step_time := clock_timestamp();
	--RAISE info 'point exception 42';
	    ELSE -- close the previous chunk and create a new one with the updates severity and tooltip
	        --RAISE info 'point exception 5';
			step := 'Set to_date - 1min (in case when severity is diff)';
	        UPDATE  app_123monitor.rp_timeline_chunks
	        SET     to_date= vDate-interval '1 minute'
	        WHERE   timeline_id = vTimelineID AND
	                to_date= (SELECT max(to_date) FROM app_123monitor.rp_timeline_chunks WHERE timeline_id = vTimelineID);

			PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
			v_last_step_time := clock_timestamp();
	        --RAISE info 'point exception 6';
			
			step := 'Insert a new row for the item with a new severity value';
	        INSERT INTO app_123monitor.rp_timeline_chunks (timeline_id, from_date, to_date, severity, tooltip)
				VALUES (vTimelineID,vDate-interval '1 minute',vDate,vSeverity,in_tooltip);
			
			PERFORM app_123monitor.print_debug(module, step, v_start_time, v_last_step_time, v_debug);
			v_last_step_time := clock_timestamp();
	    END IF;

	EXCEPTION
	    WHEN OTHERS THEN
	            RAISE info 'point exception 7';
	
	        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
	        ecode := RETURNED_SQLSTATE;
	        PERFORM write_log(in_node_id,in_monitor_name,ecode,errmsg,module,step,3);
	        RAISE info 'update_timeline % %',errmsg,ecode;
end;
$$;


--
-- TOC entry 588 (class 1255 OID 53343076)
-- Name: update_timeline_chunk_with_time(text, integer, text, text, integer, text); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_timeline_chunk_with_time(in_cluster_name text, in_node_id integer, in_monitor_name text, in_detail_name text, in_severity integer, in_tooltip text) RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR:=NULL;
errmsg varchar :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar :='update_timeline_chunk_with_time';
step    varchar :=NULL;
vCount int :=null;
vDate timestamp :=NULL;
vSeverity int :=0;
vTimelineID INT;
vNodeName TEXT;
vName TEXT;

last_time timestamp;
current__time timestamp;
time_diff numeric;

BEGIN
  ----raise INFO 'START';
  select clock_timestamp() into last_time;
	-- 1. Fetch the node name to a variable
	step := '1';
	
	IF in_detail_name IS NULL AND in_monitor_name IS NULL THEN
        SELECT name INTO vNodeName
        FROM public."clusterCore_c123_node"
        WHERE id = in_node_id
        LIMIT 1;
    ELSE
        vNodeName := NULL;
    END IF;

      --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
  ----raise INFO 'complete_chunk % in % seconds.', step, time_diff;
  last_time := current__time;

	-- 2. Determine the value for name depending on the hierarchy level
	vName := COALESCE(in_detail_name, in_monitor_name, vNodeName, in_cluster_name);

	-- 3. Check whether there is a corresponding record in the rp_timeline table
	step := '3';

	SELECT id INTO vTimelineID
    FROM app_123monitor.rp_timeline
    WHERE (name = vName OR (name IS NULL AND vName IS NULL))
      AND (cluster_name = in_cluster_name OR (cluster_name IS NULL AND in_cluster_name IS NULL))
      AND (node_id = in_node_id OR (node_id IS NULL AND in_node_id IS NULL))
      AND (monitor_name = in_monitor_name OR (monitor_name IS NULL AND in_monitor_name IS NULL))
      AND (detail_1st_column = in_detail_name OR (detail_1st_column IS NULL AND in_detail_name IS NULL))
    LIMIT 1;

  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
  --raise INFO 'complete_chunk % in % seconds.', step, time_diff;
  last_time := current__time;
	-- 4. If the record does not exist, we create it
	step := '4';

	IF vTimelineID IS NULL THEN
        INSERT INTO app_123monitor.rp_timeline (
            name, date_created, cluster_name, node_id, monitor_name, detail_1st_column, impact_on_father_timeline
        ) VALUES (
            vName,
            NOW(),
            in_cluster_name,
            in_node_id,
            in_monitor_name,
            in_detail_name,
            TRUE
        )
        RETURNING id INTO vTimelineID;
    END IF;



	--raise info 'in update_timeline params in_node_id %, in_severity %, in_tooltip %',in_node_id , in_severity ,in_tooltip;
    IF in_severity IS NULL
    THEN vSeverity=-2;
    ELSE vSeverity=in_severity;
    END IF;

    SELECT date_trunc('minute', current_timestamp)
	INTO STRICT vDate;

  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
  --raise INFO 'complete_chunk % in % seconds.', step, time_diff;
  last_time := current__time;
    -- 5. Check if the last chunk is of the received severity.
	--    If the last chunk is of the received severity then update the to_date.
	--    If not close the previous chunk and create a new one with the updates severity and tooltip.
    BEGIN
      --raise info 'point exception 2';
	  step := '5.1';
        SELECT  count(*)
        INTO STRICT vCount
        FROM    app_123monitor.rp_timeline_chunks
        WHERE   timeline_id = vTimelineID AND
                severity=vSeverity AND
                to_date= (SELECT max(to_date) FROM app_123monitor.rp_timeline_chunks WHERE timeline_id = vTimelineID);
    EXCEPTION
        WHEN no_data_found THEN
            vCount:=0;
            --raise info 'point exception 3';
        WHEN OTHERS THEN NULL;
    END;

	--raise info 'point exception 4';
	    IF vCount>0 then -- if the last chunk is of the received severity then update the to_date
	--raise info 'point exception 41';
		step := '5.2';
	        UPDATE  app_123monitor.rp_timeline_chunks
	        SET     to_date= vDate
	        WHERE   timeline_id = vTimelineID AND
	                severity=vSeverity AND
	                to_date= (SELECT max(to_date) FROM app_123monitor.rp_timeline_chunks WHERE timeline_id = vTimelineID);
      --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
  --raise INFO 'complete_chunk % in % seconds.', step, time_diff;
  last_time := current__time;
	--raise info 'point exception 42';
	    ELSE -- close the previous chunk and create a new one with the updates severity and tooltip
	        --raise info 'point exception 5';
			step := '5.3';
	        UPDATE  app_123monitor.rp_timeline_chunks
	        SET     to_date= vDate-interval '1 minute'
	        WHERE   timeline_id = vTimelineID AND
	                to_date= (SELECT max(to_date) FROM app_123monitor.rp_timeline_chunks WHERE timeline_id = vTimelineID);
	        --raise info 'point exception 6';
  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
  --raise INFO 'complete_chunk % in % seconds.', step, time_diff;
  last_time := current__time;
			step := '5.4';
	        INSERT INTO app_123monitor.rp_timeline_chunks (timeline_id, from_date, to_date, severity, tooltip)
				VALUES (vTimelineID,vDate-interval '1 minute',vDate,vSeverity,in_tooltip);
	    END IF;
  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time));
  --raise INFO 'complete_chunk % in % seconds.', step, time_diff;
  last_time := current__time;
	EXCEPTION
	    WHEN OTHERS THEN
	            --raise info 'point exception 7';

	        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
	        ecode := RETURNED_SQLSTATE;
	        PERFORM write_log(in_node_id,in_monitor_name,ecode,errmsg,module,step,3);
	        --raise info 'update_timeline % %',errmsg,ecode;
end;
$$;


--
-- TOC entry 594 (class 1255 OID 53337673)
-- Name: update_timeline_with_time(integer, text, integer); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.update_timeline_with_time(in_node_id integer, in_monitor_name text, in_alert_id integer) RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode VARCHAR:=NULL;
errmsg varchar :=NULL;
SUCCESS int:=0;
FAILURE int:=1;
module  varchar :='update_timeline_with_time';
step    varchar :=NULL;
vCount int :=null;
vDate timestamp :=NULL;
vClusterName TEXT;
vClusterID INT;
vColumn1 TEXT;
vSeverity INT;
vMessage TEXT;
vIsFirstColumnUnique CHAR;

last_time timestamp;
current__time timestamp;
time_diff numeric;

BEGIN
  select clock_timestamp() into last_time;
	-- 1.1. get the cluster_name by the node_id
	step := '20.1';



	SELECT cc.name, cc.id
    INTO vClusterName, vClusterID
    FROM public."clusterCore_c123_node" AS cn
    JOIN public."clusterCore_c123_cluster" AS cc ON cn.cluster_id = cc.id
    WHERE cn.id = in_node_id;

  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time)) * 1000;
  --raise INFO '%   %  update_timeline', time_diff, step;
  last_time := current__time;
	-- 1.2. check if the monitor has a unique first column
	step := '20.2';

	SELECT ind_first_column_unique
    INTO vIsFirstColumnUnique
    FROM app_123monitor.rp_monitors m
    WHERE m.node_id = in_node_id AND m.monitor_name = in_monitor_name;

  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time))*1000;
  --raise INFO '%   %  update_timeline', time_diff, step;
  last_time := current__time;
	-- 2.1. detail_timeline
	step := '20.3';

	IF vIsFirstColumnUnique = 'Y' THEN
		FOR vColumn1, vSeverity, vMessage IN
	        SELECT column1, severity, message
	        FROM app_123monitor.rp_alert_detail rad
	        WHERE rad.alert_id = in_alert_id
	    LOOP
	        PERFORM app_123monitor.update_timeline_chunk_with_time(
	            vClusterName,
	            in_node_id,
	            in_monitor_name,
	            vColumn1,
	            vSeverity,
	            vMessage
	        );
	    END LOOP;
	END IF;

  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time))*1000;
  --raise INFO '%   %   update_timeline', time_diff, step;
  last_time := current__time;

	-- 2.2. monitor_timeline
	step := '20.4';

	SELECT severity, message
	INTO vSeverity, vMessage
	FROM app_123monitor.rp_alert a
	WHERE a.alert_id = in_alert_id;

	PERFORM app_123monitor.update_timeline_chunk_with_time(
	            vClusterName,
	            in_node_id,
	            in_monitor_name,
	            NULL,
	            vSeverity,
	            vMessage
	        );

  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time))*1000;
  --raise INFO '%   %  update_timeline', time_diff, step;
  last_time := current__time;

	-- 2.3. node_timeline
	step := '20.5';

	SELECT
	    MAX(subquery.severity),
	    SUBSTRING(string_agg(subquery.message, E'\n') FOR 300)
	INTO vSeverity, vMessage
	FROM (
	    SELECT DISTINCT ON (ra.monitor_name) ra.severity, ra.message
	    FROM app_123monitor.rp_alert ra
	    JOIN app_123monitor.rp_monitors rm
	        ON ra.node_id = rm.node_id
	        AND ra.monitor_name = rm.monitor_name
	    WHERE ra.node_id = in_node_id
	      AND rm.task_id IS NOT NULL
	    ORDER BY ra.monitor_name, ra.alert_id DESC
	) subquery;
--get time
	select clock_timestamp() into current__time;
  	time_diff := EXTRACT(EPOCH FROM (current__time - last_time))*1000;
  	--raise INFO '%   %  update_timeline', time_diff, step;
  	last_time := current__time;

	step := '20.6';
	PERFORM app_123monitor.update_timeline_chunk_with_time(
	            vClusterName,
	            in_node_id,
	            NULL,
	            NULL,
	            vSeverity,
	            vMessage
	        );

  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time))*1000;
  --raise INFO '%   %  update_timeline', time_diff, step;
  last_time := current__time;
	-- 2.4. cluster_timeline
	step := '20.7';

	SELECT
	    MAX(subquery.severity),
	    SUBSTRING(string_agg(subquery.message, E'\n') FOR 300)
	INTO vSeverity, vMessage
	FROM (
	    SELECT DISTINCT ON (ra.monitor_name) ra.severity, ra.message
	    FROM app_123monitor.rp_alert ra
	    JOIN app_123monitor.rp_monitors rm
	        ON ra.node_id = rm.node_id
	        AND ra.monitor_name = rm.monitor_name
		JOIN public."clusterCore_c123_node" cn
        	ON ra.node_id = cn.id
	    WHERE cn.cluster_id = vClusterID
	      AND rm.task_id IS NOT NULL
	    ORDER BY ra.monitor_name, ra.alert_id DESC
	) subquery;

	select clock_timestamp() into current__time;
  	time_diff := EXTRACT(EPOCH FROM (current__time - last_time))*1000;
  	--raise INFO '%   %  update_timeline', time_diff, step;
  	last_time := current__time;

	step := '20.8';

	PERFORM app_123monitor.update_timeline_chunk_with_time(
	            vClusterName,
	            NULL,
	            NULL,
	            NULL,
	            vSeverity,
	            vMessage
	        );

  --get time
  select clock_timestamp() into current__time;
  time_diff := EXTRACT(EPOCH FROM (current__time - last_time))*1000;
  --raise INFO '%   %  update_timeline', time_diff, step;
  last_time := current__time;

	EXCEPTION
	    WHEN OTHERS THEN

	        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
	        ecode := RETURNED_SQLSTATE;
	        PERFORM write_log(in_node_id,in_monitor_name,ecode,errmsg,module,step,3);
	        --raise info 'update_timeline % %',errmsg,ecode;
END;
$$;


--
-- TOC entry 561 (class 1255 OID 46070047)
-- Name: week_stats(); Type: FUNCTION; Schema: app_123monitor; Owner: -
--

CREATE FUNCTION app_123monitor.week_stats() RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE

ecode varchar(32):=NULL;
errmsg varchar(1000) :=NULL;
module  varchar(100) :='week_stats';
step    varchar(500) :=NULL;
vStart timestamp:=NULL;
vEnd timestamp:=NULL;
vLog text :='';
vOrg   int :=NULL;
vStr text:=NULL;
organizations CURSOR FOR SELECT * FROM organization;
rec RECORD;
monitor RECORD;
col RECORD;
deleted_rows INT := NULL;
col_counter INT;

BEGIN
    -- Capturing the function execution start time.
    SELECT statement_timestamp() INTO STRICT vStart;

    -- Iterating through each organization.
    FOR org IN organizations LOOP
        -- Iterating through each monitor associated with the organization.
        FOR monitor IN (
            SELECT * FROM app_123monitor.rp_monitors m 
            WHERE org_id = org.org_id 
            AND node_id IS NOT NULL
            AND node_id = 53
			--AND monitor_name IN ('memcheck unique') -- Filtering specific monitors
        ) LOOP
            --RAISE NOTICE 'Processing monitor: % (node_id: %)', monitor.monitor_name, monitor.node_id;
            

            INSERT INTO app_123monitor.rp_alert_week   
            SELECT 
                nextval('app_123monitor.alert_week_seq'),
                node_id,
                monitor_name,
                NOW() AS date_created,
                MAX(severity),
                MAX(message),
                AVG(runtime_duration_msec),
                node_type 
            FROM app_123monitor.rp_alert a 
            WHERE monitor_name = monitor.monitor_name
                AND node_id = monitor.node_id
                AND a.date_created >= date_trunc('hour', now()) - interval '1 hour'
  				AND a.date_created < date_trunc('hour', now())

            GROUP BY node_id, monitor_name, NOW(), node_type;


			-- !!! STEP-1: add to avg table
            vStr := 'INSERT INTO app_123monitor.rp_alert_detail_avg_week
                     SELECT 
                     currval(''app_123monitor.alert_week_seq''),
                     nextval(''app_123monitor.alert_detail_week_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'round(avg(' || col.column_name || '::numeric),1),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND a.date_created >= date_trunc(''hour'', now()) - interval ''1 hour''
  					 AND a.date_created < date_trunc(''hour'', now())
                     GROUP BY currval(''app_123monitor.alert_week_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


			-- !!! STEP-2: add to max table
			vStr := 'INSERT INTO app_123monitor.rp_alert_detail_max_week
                     SELECT 
                     currval(''app_123monitor.alert_week_seq''),
                     nextval(''app_123monitor.alert_detail_week_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'max(' || col.column_name || '::numeric),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND a.date_created >= date_trunc(''hour'', now()) - interval ''1 hour''
  					 AND a.date_created < date_trunc(''hour'', now())
                     GROUP BY currval(''app_123monitor.alert_week_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


			-- !!! STEP-3: add to min table
			vStr := 'INSERT INTO app_123monitor.rp_alert_detail_min_week
                     SELECT 
                     currval(''app_123monitor.alert_week_seq''),
                     nextval(''app_123monitor.alert_detail_week_seq'') AS alert_detail_id,
                     MAX(d.severity),
                     column1::TEXT,';

            -- Column counter (starting from column2).
            col_counter := 2;


			FOR col IN (
			    SELECT * FROM app_123monitor.rp_monitor_columns 
			    WHERE monitor_name = monitor.monitor_name AND column_name != 'column1'
			) LOOP
		        IF col.column_type = 'numeric' THEN
		            vStr := vStr || 'min(' || col.column_name || '::numeric),';
		        ELSE
		            vStr := vStr || 'max(' || col.column_name || '::text),';
		        END IF;
				col_counter := col_counter + 1;
			END LOOP;

            -- If there are fewer than 10 columns, fill in the remaining with NULL.
            WHILE col_counter <= 10 LOOP
                vStr := vStr || 'NULL,';
                col_counter := col_counter + 1;
            END LOOP;


            vStr := vStr || 'MAX(a.message) 
                     FROM app_123monitor.rp_alert a
                     JOIN app_123monitor.rp_alert_detail d ON a.alert_id = d.alert_id
                     WHERE monitor_name = ''' || monitor.monitor_name || '''
                     AND node_id = ' || monitor.node_id || '
                     AND a.date_created >= date_trunc(''hour'', now()) - interval ''1 hour''
  					 AND a.date_created < date_trunc(''hour'', now())
                     GROUP BY currval(''app_123monitor.alert_week_seq''), column1;';


            --RAISE NOTICE 'Executing query: %', vStr;
            EXECUTE vStr;


        END LOOP;
    END LOOP;




select statement_timestamp() into STRICT vEnd;


step:='';
RAISE info 'completed time :%',vEnd-vStart;

  exception
    when others then
        GET STACKED DIAGNOSTICS errmsg := MESSAGE_TEXT,
        ecode := RETURNED_SQLSTATE;
        PERFORM write_log(1,'','week_stats: '||vLog||chr(10)||' in '||vEnd-vStart||' seconds',module,step,1);
        RAISE NOTICE 'hour_stats error:% %', ecode, errmsg;
        PERFORM write_log(1,ecode,errmsg,module,step,3);

end;
$$;


--
-- TOC entry 431 (class 1259 OID 17006)
-- Name: alert_day_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_day_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 432 (class 1259 OID 17007)
-- Name: alert_detail_day_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_detail_day_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 433 (class 1259 OID 17008)
-- Name: alert_detail_hour_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_detail_hour_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 434 (class 1259 OID 17009)
-- Name: alert_detail_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_detail_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 484 (class 1259 OID 45931790)
-- Name: alert_detail_six_hours_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_detail_six_hours_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 486 (class 1259 OID 46070050)
-- Name: alert_detail_week_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_detail_week_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 435 (class 1259 OID 17010)
-- Name: alert_hour_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_hour_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 436 (class 1259 OID 17011)
-- Name: alert_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 483 (class 1259 OID 45930970)
-- Name: alert_six_hours_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_six_hours_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 485 (class 1259 OID 46070049)
-- Name: alert_week_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.alert_week_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 437 (class 1259 OID 17012)
-- Name: app_monitor_result_raw_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.app_monitor_result_raw_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 438 (class 1259 OID 17013)
-- Name: app_worker_job_id_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.app_worker_job_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 439 (class 1259 OID 17014)
-- Name: mail_queue_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.mail_queue_seq
    START WITH 19821
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 20;


SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- TOC entry 440 (class 1259 OID 17015)
-- Name: monitor_text; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.monitor_text (
    id integer NOT NULL,
    text character varying(1000)
);


--
-- TOC entry 509 (class 1259 OID 56686745)
-- Name: pg_stat_statement_1d; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.pg_stat_statement_1d (
    node_id integer,
    date_created timestamp without time zone,
    query text NOT NULL,
    calls bigint,
    total_exec_time double precision,
    avg_exec_time numeric(10,3)
);


--
-- TOC entry 507 (class 1259 OID 56686735)
-- Name: pg_stat_statement_1h; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.pg_stat_statement_1h (
    node_id integer,
    date_created timestamp without time zone,
    query text NOT NULL,
    calls bigint,
    total_exec_time double precision,
    avg_exec_time numeric(10,3)
);


--
-- TOC entry 510 (class 1259 OID 56686750)
-- Name: pg_stat_statement_1w; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.pg_stat_statement_1w (
    node_id integer,
    date_created timestamp without time zone,
    query text NOT NULL,
    calls bigint,
    total_exec_time double precision,
    avg_exec_time numeric(10,3)
);


--
-- TOC entry 508 (class 1259 OID 56686740)
-- Name: pg_stat_statement_6h; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.pg_stat_statement_6h (
    node_id integer,
    date_created timestamp without time zone,
    query text NOT NULL,
    calls bigint,
    total_exec_time double precision,
    avg_exec_time numeric(10,3)
);


--
-- TOC entry 441 (class 1259 OID 17018)
-- Name: r_params; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.r_params (
    module character varying(4000),
    name character varying(4000),
    value character varying(40000),
    date_created timestamp with time zone
);


--
-- TOC entry 442 (class 1259 OID 17023)
-- Name: rp_agent; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_agent (
    agent_id integer NOT NULL,
    ip character varying(100),
    agent_key text,
    last_update timestamp without time zone,
    ind_active character(1),
    role character varying(20),
    ind_default character(1)
);


--
-- TOC entry 443 (class 1259 OID 17028)
-- Name: rp_agent_agent_id_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.rp_agent_agent_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 3983 (class 0 OID 0)
-- Dependencies: 443
-- Name: rp_agent_agent_id_seq; Type: SEQUENCE OWNED BY; Schema: app_123monitor; Owner: -
--

ALTER SEQUENCE app_123monitor.rp_agent_agent_id_seq OWNED BY app_123monitor.rp_agent.agent_id;


--
-- TOC entry 444 (class 1259 OID 17029)
-- Name: rp_alert; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert (
    alert_id integer NOT NULL,
    node_id integer,
    monitor_name text,
    date_created timestamp without time zone,
    severity integer,
    message text,
    runtime_duration_msec integer,
    node_type character varying(100)
);


--
-- TOC entry 499 (class 1259 OID 56205345)
-- Name: rp_alert_current; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_current (
    alert_id integer NOT NULL,
    node_id integer,
    monitor_name text,
    date_created timestamp without time zone,
    severity integer,
    message text,
    runtime_duration_msec integer,
    node_type character varying(100)
);


--
-- TOC entry 445 (class 1259 OID 17034)
-- Name: rp_alert_day; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_day (
    alert_id integer NOT NULL,
    node_id integer,
    monitor_name text,
    date_created timestamp without time zone,
    severity integer,
    message text,
    runtime_duration_msec integer,
    node_type character varying(100)
);


--
-- TOC entry 446 (class 1259 OID 17039)
-- Name: rp_alert_detail; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000),
    line_id bigint
);


--
-- TOC entry 447 (class 1259 OID 17044)
-- Name: rp_alert_detail_avg_day; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_avg_day (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 476 (class 1259 OID 45750359)
-- Name: rp_alert_detail_avg_hour; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_avg_hour (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 479 (class 1259 OID 45912181)
-- Name: rp_alert_detail_avg_six_hours; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_avg_six_hours (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 488 (class 1259 OID 46070060)
-- Name: rp_alert_detail_avg_week; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_avg_week (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 448 (class 1259 OID 17049)
-- Name: rp_alert_detail_hour; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_hour (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 449 (class 1259 OID 17054)
-- Name: rp_alert_detail_max_day; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_max_day (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 478 (class 1259 OID 45750753)
-- Name: rp_alert_detail_max_hour; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_max_hour (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 480 (class 1259 OID 45913008)
-- Name: rp_alert_detail_max_six_hours; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_max_six_hours (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 489 (class 1259 OID 46070068)
-- Name: rp_alert_detail_max_week; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_max_week (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 450 (class 1259 OID 17059)
-- Name: rp_alert_detail_min_day; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_min_day (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 477 (class 1259 OID 45750745)
-- Name: rp_alert_detail_min_hour; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_min_hour (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 481 (class 1259 OID 45913016)
-- Name: rp_alert_detail_min_six_hours; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_min_six_hours (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 490 (class 1259 OID 46070076)
-- Name: rp_alert_detail_min_week; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_detail_min_week (
    alert_id integer,
    alert_detail_id integer NOT NULL,
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message character varying(1000)
);


--
-- TOC entry 451 (class 1259 OID 17064)
-- Name: rp_alert_hour; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_hour (
    alert_id integer NOT NULL,
    node_id integer,
    monitor_name text,
    date_created timestamp without time zone,
    severity integer,
    message text,
    runtime_duration_msec integer,
    node_type character varying(100)
);


--
-- TOC entry 482 (class 1259 OID 45913781)
-- Name: rp_alert_six_hours; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_six_hours (
    alert_id integer NOT NULL,
    node_id integer,
    monitor_name text,
    date_created timestamp without time zone,
    severity integer,
    message text,
    runtime_duration_msec integer,
    node_type character varying(100)
);


--
-- TOC entry 487 (class 1259 OID 46070052)
-- Name: rp_alert_week; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_alert_week (
    alert_id integer NOT NULL,
    node_id integer,
    monitor_name text,
    date_created timestamp without time zone,
    severity integer,
    message text,
    runtime_duration_msec integer,
    node_type character varying(100)
);


--
-- TOC entry 452 (class 1259 OID 17069)
-- Name: rp_mail_queue; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.rp_mail_queue (
    id integer NOT NULL,
    org_id integer,
    node_id integer,
    sender character varying(500),
    mail_to character varying(500),
    mail_subject character varying(1000),
    mail_message text,
    ind_sent character(1),
    date_created timestamp with time zone,
    date_sent timestamp with time zone,
    send_return_message character varying(4000),
    send_return_code character varying(100)
);


--
-- TOC entry 453 (class 1259 OID 17074)
-- Name: rp_monitor_columns; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_monitor_columns (
    org_id integer,
    node_id integer,
    monitor_name character varying(100),
    column_name character varying(100),
    display_name character varying(100),
    column_type character varying(100),
    node_type character varying(100)
);


--
-- TOC entry 475 (class 1259 OID 44594338)
-- Name: rp_monitor_result_raw; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_monitor_result_raw (
    org_id integer,
    node_id integer NOT NULL,
    task_id numeric,
    date_created timestamp without time zone,
    monitor_result_id bigint,
    line_id integer NOT NULL,
    col1 text,
    col2 text,
    col3 text,
    col4 text,
    col5 text,
    col6 text,
    col7 text,
    col8 text,
    col9 text,
    col10 text,
    task_run_id uuid,
    ind_analyzed character(1),
    analyze_status text
);


--
-- TOC entry 474 (class 1259 OID 44594337)
-- Name: rp_monitor_result_raw_line_id_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.rp_monitor_result_raw_line_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 3984 (class 0 OID 0)
-- Dependencies: 474
-- Name: rp_monitor_result_raw_line_id_seq; Type: SEQUENCE OWNED BY; Schema: app_123monitor; Owner: -
--

ALTER SEQUENCE app_123monitor.rp_monitor_result_raw_line_id_seq OWNED BY app_123monitor.rp_monitor_result_raw.line_id;


--
-- TOC entry 454 (class 1259 OID 17082)
-- Name: rp_monitors; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_monitors (
    org_id integer,
    node_id integer,
    db_type character varying(100) NOT NULL,
    monitor_name character varying(100) NOT NULL,
    monitor_description character varying(1000),
    pre_script character varying(10000),
    monitor_script character varying(10000),
    ind_enabled character(1) NOT NULL,
    red_rule text,
    yellow_rule text,
    red_rule_message character varying(500),
    yellow_rule_message character varying(500),
    ind_send_email_notifications character(1) NOT NULL,
    monitor_interval character varying(100),
    runtime_red_threshold integer,
    runtime_yellow_threshold integer,
    return_code_threshold character varying(1000),
    ind_status_graph character(1),
    ind_create_timeline character(1),
    ind_timeline_full_impact character(1),
    cmd_type character varying(10),
    ind_first_column_unique character(1),
    ind_alert_on_added_missing character(1),
    alert_on_added_missing_severity integer,
    ind_alert_compare_to_previous_check character(1),
    alert_compare_to_previous_check_severity integer,
    alert_compare_to_previous_check_higher_lower character varying(10),
    alert_compare_to_previous_check_percent numeric(10,0),
    ind_break_long_running character(1),
    ind_compute_baseline character(1),
    data_reduction_function character varying(100),
    renew_alert_every character varying(100),
    ind_red_by_row_count character(1),
    red_by_row_count_option character varying(100),
    red_by_row_count_items integer,
    ind_yellow_by_row_count character(1),
    yellow_by_row_count_option character varying(100),
    yellow_by_row_count_items integer,
    graph_aggregation character varying(100),
    graph_aggregation_column character varying(100),
    snoozed_until timestamp without time zone,
    count_long_running integer,
    ind_broken character(1),
    num_weeks_in_baseline integer,
    task_id integer,
    module character varying(15)
);


--
-- TOC entry 455 (class 1259 OID 17087)
-- Name: rp_nodes; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_nodes (
    org_id integer NOT NULL,
    node_id integer NOT NULL,
    db_type character varying(100),
    node_display_name character varying(100),
    db_user character varying(100),
    db_password character varying(100),
    instance character varying(100),
    db_port integer,
    os_user character varying(100),
    os_password character varying(100),
    machine character varying(100),
    database_version character varying(500),
    creation_date timestamp with time zone,
    database_status character varying(100),
    database_status_desc character varying(1000),
    machine_status character varying(100),
    machine_status_desc character varying(1000),
    archive_mode character varying(100),
    database_uptime timestamp with time zone,
    ind_enable character(1),
    database_connect_time integer,
    machine_connect_time integer,
    sid character varying(100),
    ssh_port integer,
    ind_deleted character(1),
    date_deleted timestamp with time zone,
    cpu_count integer,
    machine_memory character varying(10),
    ind_collector character(1),
    ind_applier character(1),
    ind_learning character(1),
    fwk character varying(100),
    rpk character varying(100),
    apm_query character varying(1000),
    date_updated timestamp with time zone,
    home_dir character varying(500),
    os_type character varying(100),
    ind_base character(1),
    agent_ip character varying(100),
    agent_port integer
);


--
-- TOC entry 456 (class 1259 OID 17092)
-- Name: rp_organization; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_organization (
    org_id integer NOT NULL,
    date_created timestamp with time zone,
    ind_disable_all_conns character(1),
    organization_name character varying(100),
    ind_enable_notifications character(1),
    administrator_email character varying(100),
    operator_email character varying(100),
    administrator_password character varying(100),
    operator_password character varying(100),
    ind_del_firewall_actions character(1),
    ind_del_resource_manager character(1),
    ind_del_notifications character(1),
    ind_del_failed_logins character(1),
    ind_del_general character(1),
    ind_collector character(1),
    ind_applier character(1),
    ind_housekeeper character(1),
    housekeeper_short_retention integer,
    housekeeper_long_retention integer,
    housekeeper_medium_retention integer,
    max_notifications_per_hour integer
);


--
-- TOC entry 492 (class 1259 OID 51234746)
-- Name: rp_timeline; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_timeline (
    id integer NOT NULL,
    name character varying(100) NOT NULL,
    date_created timestamp without time zone DEFAULT now() NOT NULL,
    cluster_name character varying(100),
    node_id integer,
    monitor_name character varying(100),
    detail_1st_column character varying(200),
    impact_on_father_timeline boolean
);


--
-- TOC entry 494 (class 1259 OID 51237404)
-- Name: rp_timeline_chunks; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_timeline_chunks (
    id integer NOT NULL,
    timeline_id integer NOT NULL,
    from_date timestamp without time zone NOT NULL,
    to_date timestamp without time zone NOT NULL,
    severity integer NOT NULL,
    tooltip text
);


--
-- TOC entry 493 (class 1259 OID 51237403)
-- Name: rp_timeline_chunks_id_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.rp_timeline_chunks_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 3985 (class 0 OID 0)
-- Dependencies: 493
-- Name: rp_timeline_chunks_id_seq; Type: SEQUENCE OWNED BY; Schema: app_123monitor; Owner: -
--

ALTER SEQUENCE app_123monitor.rp_timeline_chunks_id_seq OWNED BY app_123monitor.rp_timeline_chunks.id;


--
-- TOC entry 457 (class 1259 OID 17095)
-- Name: rp_timeline_chunks_old; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.rp_timeline_chunks_old (
    org_id integer,
    node_id integer,
    timeline_name character varying(1000),
    severity integer,
    text_chunks character varying(1000),
    from_date timestamp with time zone,
    to_date timestamp with time zone,
    tooltip character varying(1000),
    father_timeline character varying(1000)
);


--
-- TOC entry 491 (class 1259 OID 51234745)
-- Name: rp_timeline_id_seq; Type: SEQUENCE; Schema: app_123monitor; Owner: -
--

CREATE SEQUENCE app_123monitor.rp_timeline_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 3986 (class 0 OID 0)
-- Dependencies: 491
-- Name: rp_timeline_id_seq; Type: SEQUENCE OWNED BY; Schema: app_123monitor; Owner: -
--

ALTER SEQUENCE app_123monitor.rp_timeline_id_seq OWNED BY app_123monitor.rp_timeline.id;


--
-- TOC entry 458 (class 1259 OID 17100)
-- Name: rp_timelines_old; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.rp_timelines_old (
    org_id integer,
    node_id integer,
    node_type character varying(20) NOT NULL,
    timeline_name character varying(100) NOT NULL,
    timeline_desc character varying(200),
    ind_full_impact character(1),
    ind_visible character(1),
    category character varying(20)
);


--
-- TOC entry 459 (class 1259 OID 17103)
-- Name: t_id; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE TABLE app_123monitor.t_id (
    max integer
);


--
-- TOC entry 503 (class 1259 OID 56657834)
-- Name: tmp_added_missing; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.tmp_added_missing (
    severity integer,
    column1 text,
    message text
);


--
-- TOC entry 501 (class 1259 OID 56657824)
-- Name: tmp_basic; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.tmp_basic (
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message text,
    line_id integer
);


--
-- TOC entry 505 (class 1259 OID 56657844)
-- Name: tmp_basic_added_missing; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.tmp_basic_added_missing (
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message text,
    line_id integer
);


--
-- TOC entry 504 (class 1259 OID 56657839)
-- Name: tmp_compare_to_previous; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.tmp_compare_to_previous (
    severity integer,
    column1 text,
    message text
);


--
-- TOC entry 500 (class 1259 OID 56657819)
-- Name: tmp_current; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.tmp_current (
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    line_id integer
);


--
-- TOC entry 506 (class 1259 OID 56657849)
-- Name: tmp_final; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.tmp_final (
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message text,
    line_id integer
);


--
-- TOC entry 502 (class 1259 OID 56657829)
-- Name: tmp_previous; Type: TABLE; Schema: app_123monitor; Owner: -
--

CREATE UNLOGGED TABLE app_123monitor.tmp_previous (
    severity integer,
    column1 text,
    column2 text,
    column3 text,
    column4 text,
    column5 text,
    column6 text,
    column7 text,
    column8 text,
    column9 text,
    column10 text,
    message text
);


--
-- TOC entry 3737 (class 2604 OID 17141)
-- Name: rp_agent agent_id; Type: DEFAULT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_agent ALTER COLUMN agent_id SET DEFAULT nextval('app_123monitor.rp_agent_agent_id_seq'::regclass);


--
-- TOC entry 3738 (class 2604 OID 44594341)
-- Name: rp_monitor_result_raw line_id; Type: DEFAULT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_monitor_result_raw ALTER COLUMN line_id SET DEFAULT nextval('app_123monitor.rp_monitor_result_raw_line_id_seq'::regclass);


--
-- TOC entry 3739 (class 2604 OID 51234749)
-- Name: rp_timeline id; Type: DEFAULT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_timeline ALTER COLUMN id SET DEFAULT nextval('app_123monitor.rp_timeline_id_seq'::regclass);


--
-- TOC entry 3741 (class 2604 OID 51237407)
-- Name: rp_timeline_chunks id; Type: DEFAULT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_timeline_chunks ALTER COLUMN id SET DEFAULT nextval('app_123monitor.rp_timeline_chunks_id_seq'::regclass);


--
-- TOC entry 3743 (class 2606 OID 17143)
-- Name: monitor_text monitor_text_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.monitor_text
    ADD CONSTRAINT monitor_text_pkey PRIMARY KEY (id);


--
-- TOC entry 3831 (class 2606 OID 56205351)
-- Name: rp_alert_current rp_alert_current_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_current
    ADD CONSTRAINT rp_alert_current_pkey PRIMARY KEY (alert_id);


--
-- TOC entry 3759 (class 2606 OID 17145)
-- Name: rp_alert_day rp_alert_day_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_day
    ADD CONSTRAINT rp_alert_day_pkey PRIMARY KEY (alert_id);


--
-- TOC entry 3765 (class 2606 OID 17147)
-- Name: rp_alert_detail_avg_day rp_alert_detail_avg_day_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_avg_day
    ADD CONSTRAINT rp_alert_detail_avg_day_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3794 (class 2606 OID 45750365)
-- Name: rp_alert_detail_avg_hour rp_alert_detail_avg_hour_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_avg_hour
    ADD CONSTRAINT rp_alert_detail_avg_hour_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3803 (class 2606 OID 45912187)
-- Name: rp_alert_detail_avg_six_hours rp_alert_detail_avg_six_hours_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_avg_six_hours
    ADD CONSTRAINT rp_alert_detail_avg_six_hours_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3818 (class 2606 OID 46070066)
-- Name: rp_alert_detail_avg_week rp_alert_detail_avg_week_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_avg_week
    ADD CONSTRAINT rp_alert_detail_avg_week_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3768 (class 2606 OID 17149)
-- Name: rp_alert_detail_hour rp_alert_detail_hour_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_hour
    ADD CONSTRAINT rp_alert_detail_hour_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3771 (class 2606 OID 17151)
-- Name: rp_alert_detail_max_day rp_alert_detail_max_day_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_max_day
    ADD CONSTRAINT rp_alert_detail_max_day_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3800 (class 2606 OID 45750759)
-- Name: rp_alert_detail_max_hour rp_alert_detail_max_hour_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_max_hour
    ADD CONSTRAINT rp_alert_detail_max_hour_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3806 (class 2606 OID 45913014)
-- Name: rp_alert_detail_max_six_hours rp_alert_detail_max_six_hours_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_max_six_hours
    ADD CONSTRAINT rp_alert_detail_max_six_hours_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3821 (class 2606 OID 46070074)
-- Name: rp_alert_detail_max_week rp_alert_detail_max_week_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_max_week
    ADD CONSTRAINT rp_alert_detail_max_week_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3774 (class 2606 OID 17153)
-- Name: rp_alert_detail_min_day rp_alert_detail_min_day_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_min_day
    ADD CONSTRAINT rp_alert_detail_min_day_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3797 (class 2606 OID 45750751)
-- Name: rp_alert_detail_min_hour rp_alert_detail_min_hour_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_min_hour
    ADD CONSTRAINT rp_alert_detail_min_hour_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3809 (class 2606 OID 45913022)
-- Name: rp_alert_detail_min_six_hours rp_alert_detail_min_six_hours_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_min_six_hours
    ADD CONSTRAINT rp_alert_detail_min_six_hours_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3824 (class 2606 OID 46070082)
-- Name: rp_alert_detail_min_week rp_alert_detail_min_week_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail_min_week
    ADD CONSTRAINT rp_alert_detail_min_week_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3762 (class 2606 OID 17155)
-- Name: rp_alert_detail rp_alert_detail_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_detail
    ADD CONSTRAINT rp_alert_detail_pkey PRIMARY KEY (alert_detail_id);


--
-- TOC entry 3777 (class 2606 OID 17157)
-- Name: rp_alert_hour rp_alert_hour_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_hour
    ADD CONSTRAINT rp_alert_hour_pkey PRIMARY KEY (alert_id);


--
-- TOC entry 3756 (class 2606 OID 17159)
-- Name: rp_alert rp_alert_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert
    ADD CONSTRAINT rp_alert_pkey PRIMARY KEY (alert_id);


--
-- TOC entry 3812 (class 2606 OID 45913787)
-- Name: rp_alert_six_hours rp_alert_six_hours_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_six_hours
    ADD CONSTRAINT rp_alert_six_hours_pkey PRIMARY KEY (alert_id);


--
-- TOC entry 3815 (class 2606 OID 46070058)
-- Name: rp_alert_week rp_alert_week_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_alert_week
    ADD CONSTRAINT rp_alert_week_pkey PRIMARY KEY (alert_id);


--
-- TOC entry 3780 (class 2606 OID 17161)
-- Name: rp_mail_queue rp_mail_queue_pk; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_mail_queue
    ADD CONSTRAINT rp_mail_queue_pk PRIMARY KEY (id);


--
-- TOC entry 3783 (class 2606 OID 17163)
-- Name: rp_nodes rp_nodes_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_nodes
    ADD CONSTRAINT rp_nodes_pkey PRIMARY KEY (node_id);


--
-- TOC entry 3785 (class 2606 OID 17165)
-- Name: rp_organization rp_organization_pk; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_organization
    ADD CONSTRAINT rp_organization_pk PRIMARY KEY (org_id);


--
-- TOC entry 3828 (class 2606 OID 51237411)
-- Name: rp_timeline_chunks rp_timeline_chunks_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_timeline_chunks
    ADD CONSTRAINT rp_timeline_chunks_pkey PRIMARY KEY (id);


--
-- TOC entry 3826 (class 2606 OID 51234752)
-- Name: rp_timeline rp_timeline_pkey; Type: CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_timeline
    ADD CONSTRAINT rp_timeline_pkey PRIMARY KEY (id);


--
-- TOC entry 3744 (class 1259 OID 48008187)
-- Name: alert_alert_id_node_id; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_alert_id_node_id ON app_123monitor.rp_alert USING btree (alert_id, node_id);


--
-- TOC entry 3745 (class 1259 OID 48008191)
-- Name: alert_bla; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_bla ON app_123monitor.rp_alert USING btree (node_id, alert_id, monitor_name, severity, date_created);


--
-- TOC entry 3757 (class 1259 OID 17167)
-- Name: alert_day_date_created; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_day_date_created ON app_123monitor.rp_alert_day USING btree (date_created);


--
-- TOC entry 3775 (class 1259 OID 17168)
-- Name: alert_hour_date_created; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_hour_date_created ON app_123monitor.rp_alert_hour USING btree (date_created);


--
-- TOC entry 3746 (class 1259 OID 52738779)
-- Name: alert_ix1; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_ix1 ON app_123monitor.rp_alert USING btree (monitor_name, node_id, node_type, date_created);


--
-- TOC entry 3747 (class 1259 OID 53187183)
-- Name: alert_ix2; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_ix2 ON app_123monitor.rp_alert USING btree (date_created);


--
-- TOC entry 3748 (class 1259 OID 48008190)
-- Name: alert_monitor_name_alert_id; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_monitor_name_alert_id ON app_123monitor.rp_alert USING btree (monitor_name, alert_id);


--
-- TOC entry 3810 (class 1259 OID 45913788)
-- Name: alert_six_hours_date_created; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_six_hours_date_created ON app_123monitor.rp_alert_six_hours USING btree (date_created);


--
-- TOC entry 3813 (class 1259 OID 46070059)
-- Name: alert_week_date_created; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX alert_week_date_created ON app_123monitor.rp_alert_week USING btree (date_created);


--
-- TOC entry 3749 (class 1259 OID 55743240)
-- Name: idx_alert_node_monitor_alertid_severity; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX idx_alert_node_monitor_alertid_severity ON app_123monitor.rp_alert USING btree (node_id, monitor_name, alert_id DESC, severity);


--
-- TOC entry 3750 (class 1259 OID 55748066)
-- Name: idx_alert_node_monitor_severity_alertid; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX idx_alert_node_monitor_severity_alertid ON app_123monitor.rp_alert USING btree (node_id, severity, monitor_name, alert_id DESC);


--
-- TOC entry 3751 (class 1259 OID 55734280)
-- Name: rp_alert_1ix; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_1ix ON app_123monitor.rp_alert USING btree (node_id, monitor_name, alert_id);


--
-- TOC entry 3752 (class 1259 OID 55737727)
-- Name: rp_alert_2ix; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_2ix ON app_123monitor.rp_alert USING btree (node_id, monitor_name, severity, alert_id);


--
-- TOC entry 3753 (class 1259 OID 55739501)
-- Name: rp_alert_3ix; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_3ix ON app_123monitor.rp_alert USING btree (alert_id, node_id, monitor_name, severity);


--
-- TOC entry 3754 (class 1259 OID 55779603)
-- Name: rp_alert_4ix; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_4ix ON app_123monitor.rp_alert USING btree (node_id, monitor_name, severity, message);


--
-- TOC entry 3760 (class 1259 OID 17169)
-- Name: rp_alert_detail_1ix; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_1ix ON app_123monitor.rp_alert_detail USING btree (alert_id);


--
-- TOC entry 3763 (class 1259 OID 17170)
-- Name: rp_alert_detail_avg_day_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_avg_day_idx ON app_123monitor.rp_alert_detail_avg_day USING btree (alert_id);


--
-- TOC entry 3792 (class 1259 OID 45750366)
-- Name: rp_alert_detail_avg_hour_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_avg_hour_idx ON app_123monitor.rp_alert_detail_avg_hour USING btree (alert_id);


--
-- TOC entry 3801 (class 1259 OID 45912188)
-- Name: rp_alert_detail_avg_six_hours_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_avg_six_hours_idx ON app_123monitor.rp_alert_detail_avg_six_hours USING btree (alert_id);


--
-- TOC entry 3816 (class 1259 OID 46070067)
-- Name: rp_alert_detail_avg_week_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_avg_week_idx ON app_123monitor.rp_alert_detail_avg_week USING btree (alert_id);


--
-- TOC entry 3766 (class 1259 OID 17171)
-- Name: rp_alert_detail_hour_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_hour_idx ON app_123monitor.rp_alert_detail_hour USING btree (alert_id);


--
-- TOC entry 3769 (class 1259 OID 17172)
-- Name: rp_alert_detail_max_day_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_max_day_idx ON app_123monitor.rp_alert_detail_max_day USING btree (alert_id);


--
-- TOC entry 3798 (class 1259 OID 45750760)
-- Name: rp_alert_detail_max_hour_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_max_hour_idx ON app_123monitor.rp_alert_detail_max_hour USING btree (alert_id);


--
-- TOC entry 3804 (class 1259 OID 45913015)
-- Name: rp_alert_detail_max_six_hours_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_max_six_hours_idx ON app_123monitor.rp_alert_detail_max_six_hours USING btree (alert_id);


--
-- TOC entry 3819 (class 1259 OID 46070075)
-- Name: rp_alert_detail_max_week_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_max_week_idx ON app_123monitor.rp_alert_detail_max_week USING btree (alert_id);


--
-- TOC entry 3772 (class 1259 OID 17173)
-- Name: rp_alert_detail_min_day_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_min_day_idx ON app_123monitor.rp_alert_detail_min_day USING btree (alert_id);


--
-- TOC entry 3795 (class 1259 OID 45750752)
-- Name: rp_alert_detail_min_hour_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_min_hour_idx ON app_123monitor.rp_alert_detail_min_hour USING btree (alert_id);


--
-- TOC entry 3807 (class 1259 OID 45913023)
-- Name: rp_alert_detail_min_six_hours_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_min_six_hours_idx ON app_123monitor.rp_alert_detail_min_six_hours USING btree (alert_id);


--
-- TOC entry 3822 (class 1259 OID 46070083)
-- Name: rp_alert_detail_min_week_idx; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_alert_detail_min_week_idx ON app_123monitor.rp_alert_detail_min_week USING btree (alert_id);


--
-- TOC entry 3778 (class 1259 OID 49717148)
-- Name: rp_mail_queue_ind_sent_date_created; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_mail_queue_ind_sent_date_created ON app_123monitor.rp_mail_queue USING btree (ind_sent, date_created);


--
-- TOC entry 3788 (class 1259 OID 44594344)
-- Name: rp_monitor_result_raw_date_created; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_monitor_result_raw_date_created ON app_123monitor.rp_monitor_result_raw USING btree (date_created);


--
-- TOC entry 3789 (class 1259 OID 56657928)
-- Name: rp_monitor_result_raw_idx_ind_analyzed_date_taskrun; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_monitor_result_raw_idx_ind_analyzed_date_taskrun ON app_123monitor.rp_monitor_result_raw USING btree (ind_analyzed, date_created, task_run_id) WHERE (ind_analyzed IS NULL);


--
-- TOC entry 3790 (class 1259 OID 49725325)
-- Name: rp_monitor_result_raw_task_id; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_monitor_result_raw_task_id ON app_123monitor.rp_monitor_result_raw USING btree (task_id);


--
-- TOC entry 3791 (class 1259 OID 44594345)
-- Name: rp_monitor_result_raw_task_run_id; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_monitor_result_raw_task_run_id ON app_123monitor.rp_monitor_result_raw USING btree (task_run_id);


--
-- TOC entry 3781 (class 1259 OID 55735457)
-- Name: rp_monitors_1ix; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_monitors_1ix ON app_123monitor.rp_monitors USING btree (node_id, monitor_name);


--
-- TOC entry 3786 (class 1259 OID 17175)
-- Name: rp_timeline_chunks_1ix; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_timeline_chunks_1ix ON app_123monitor.rp_timeline_chunks_old USING btree (org_id, node_id, timeline_name, to_date);


--
-- TOC entry 3787 (class 1259 OID 17176)
-- Name: rp_timeline_chunks_2ix; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX rp_timeline_chunks_2ix ON app_123monitor.rp_timeline_chunks_old USING btree (org_id, node_id, father_timeline, severity, text_chunks, timeline_name, to_date);


--
-- TOC entry 3829 (class 1259 OID 53455304)
-- Name: timeline_id_and_severity_and_date; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE INDEX timeline_id_and_severity_and_date ON app_123monitor.rp_timeline_chunks USING btree (timeline_id, severity, to_date);


--
-- TOC entry 3832 (class 1259 OID 56205352)
-- Name: uq_rp_alert_current_unique; Type: INDEX; Schema: app_123monitor; Owner: -
--

CREATE UNIQUE INDEX uq_rp_alert_current_unique ON app_123monitor.rp_alert_current USING btree (node_id, monitor_name, node_type);


--
-- TOC entry 3833 (class 2606 OID 51237412)
-- Name: rp_timeline_chunks rp_timeline_chunks_timeline_id_fkey; Type: FK CONSTRAINT; Schema: app_123monitor; Owner: -
--

ALTER TABLE ONLY app_123monitor.rp_timeline_chunks
    ADD CONSTRAINT rp_timeline_chunks_timeline_id_fkey FOREIGN KEY (timeline_id) REFERENCES app_123monitor.rp_timeline(id) ON DELETE CASCADE;


-- Completed on 2025-04-02 14:36:16

--
-- PostgreSQL database dump complete
--

